﻿---------------------------
--- Core Addon Creation ---
---------------------------
local tomQuest2 = LibStub("AceAddon-3.0"):NewAddon("tomQuest2", "AceEvent-3.0", "AceTimer-3.0", "AceBucket-3.0", "AceHook-3.0", "AceComm-3.0", "AceSerializer-3.0", "LibSink-2.0")
_G["tomQuest2"] = tomQuest2

-----------------------
--- Library loading ---
-----------------------
local LC = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-Core")
local LibTourist = LibStub("LibTourist-3.0")
local LSM = LibStub("LibSharedMedia-3.0")
local LDB = LibStub("LibDataBroker-1.1")
local LBF = LibStub("LibButtonFacade", true)

--------------------------------------
--- Copy global functions to local ---
--------------------------------------
local len, sub, format, tconcat, tremove, sort, find = string.len, string.sub, format, table.concat, tremove, sort, find
local pairs, ipairs, next, min, max, floor, abs, byte, mod, band, GetTime = pairs, ipairs, next, min, max, floor, abs, byte, mod, bit.band, GetTime
local CreateFrame, GetItemInfo, IsShiftKeyDown, IsAltKeyDown, IsControlKeyDown = CreateFrame, GetItemInfo, IsShiftKeyDown, IsAltKeyDown, IsControlKeyDown

local function paternize(pattern)
	pattern = pattern:gsub("[()]", "%%%1")
	return format("^%s$", pattern:gsub("(%%%d?$?.)", "(.+)"))
end
-----------------
--- variables ---
-----------------
WATCHFRAME_MAXQUESTS, WATCHFRAME_MAXACHIEVEMENTS, MAX_WATCHABLE_QUESTS = 100, 100, 100
local origiOnEvent = UIErrorsFrame:GetScript("OnEvent")
local TOOLTIP_UPDATE_TIME, MAX_PLAYER_LEVEL, NO_DAILY_QUESTS_REMAINING, MAX_QUESTS, MAX_DAILY = TOOLTIP_UPDATE_TIME, MAX_PLAYER_LEVEL, NO_DAILY_QUESTS_REMAINING, MAX_QUESTS, 25
local DUNGEON, HEROIC, RAID, ITEM_SPELL_TRIGGER_ONUSE, ITEM_STARTS_QUEST = LFG_TYPE_DUNGEON, ITEM_HEROIC, LFG_TYPE_RAID, ITEM_SPELL_TRIGGER_ONUSE, ITEM_STARTS_QUEST
local COPPER_AMOUNT_SYMBOL, SILVER_AMOUNT_SYMBOL, GOLD_AMOUNT_SYMBOL = COPPER_AMOUNT_SYMBOL, SILVER_AMOUNT_SYMBOL, GOLD_AMOUNT_SYMBOL
local TOOLTIP_PADDING, CELL_MARGIN_L, CELL_MARGIN_R, CELL_MARGIN_V, LINE_SPACING_V = 10, 12, 0, 3, 2
local QUESTS_TRACKER, QUESTS_TOOLTIP, ACHIEVEMENTS_TRACKER = "questsTracker", "questsTooltip", "achievementsTracker"
local expandTexture, collapseTexture = "Interface\\Buttons\\UI-PlusButton-Up", "Interface\\Buttons\\UI-MinusButton-Up"
local _, prdb, chdb, abandoning, questsTooltipDataObj, dailyQuestsTooltipDataObj, tq2QlFrame, tq2LhFrame, tq2ParentFrame, qlCurrentText, lhCurrentText, hideQuestsTracker, hideAchievementsTracker, syncParty
local subZone, currentZone, oldZone = "", "", ""
local version, firstCompatibleVersion, lastIncompatibleVersion = 400, 400, 399
local fd, fh, fm = 1/86400, 1/3600, 1/60
local dailyPattern, achievementsPattern = "^(%d-)~(.-)$", "^(%d-)~(d-)$"
local trivialText = "|cff%02x%02x%02x[%s%s]|r "..gsub(TRIVIAL_QUEST_DISPLAY, "cff000000", "cff%%s")
local normalText = "|cff%02x%02x%02x[%s%s]|r "..gsub(NORMAL_QUEST_DISPLAY, "cff000000", "cff%%s")

local scanTooltipLines = {"scanTooltipTQ2TextLeft2", "scanTooltipTQ2TextLeft3", "scanTooltipTQ2TextLeft4", "scanTooltipTQ2TextLeft5"}
local pId = {"party1", "party2", "party3", "party4"}
local texCoords = {
	available = {0.125, 0.25, 0.5, 1},
	active = {0.25, 0.375, 0.5, 1},
	availabledaily = {0.375, 0.5, 0.5, 1},
	activedaily = {0.5, 0.625, 0.5, 1},
}
local interactivityAction = {
	mouseRightShift = LC["Shift + Right click"],
	mouseRightControl = LC["Ctrl + Right click"],
	mouseRightAlt = LC["Alt + Right click"],
	mouseRight = LC["Right click"],
	mouseLeftShift = LC["Shift + Left click"],
	mouseLeftControl = LC["Ctrl + Left click"],
	mouseLeftAlt = LC["Alt + Left click"],
	mouseLeft = LC["Left click"],
	mouseMiddleShift = LC["Shift + Middle click"],
	mouseMiddleControl = LC["Ctrl + Middle click"],
	mouseMiddleAlt = LC["Alt + Middle click"],
	mouseMiddle = LC["Middle click"],
}
local tags = {
	[DAILY] = "daily",
	[GROUP] = "group",
	[ELITE] = "elite",
	[PVP] = "pvp",
	[DUNGEON] = "dungeon",
	[HEROIC] = "heroic",
	[LC["Escort"]] = "escort",
	[""] = "notag",
}
local reactions = {
	[FACTION_STANDING_LABEL1] = 1, [FACTION_STANDING_LABEL1_FEMALE] = 1,
	[FACTION_STANDING_LABEL2] = 2, [FACTION_STANDING_LABEL2_FEMALE] = 2,
	[FACTION_STANDING_LABEL3] = 3, [FACTION_STANDING_LABEL3_FEMALE] = 3,
	[FACTION_STANDING_LABEL4] = 4, [FACTION_STANDING_LABEL4_FEMALE] = 4,
	[FACTION_STANDING_LABEL5] = 5, [FACTION_STANDING_LABEL5_FEMALE] = 5,
	[FACTION_STANDING_LABEL6] = 6, [FACTION_STANDING_LABEL6_FEMALE] = 6,
	[FACTION_STANDING_LABEL7] = 7, [FACTION_STANDING_LABEL7_FEMALE] = 7,
	[FACTION_STANDING_LABEL8] = 8, [FACTION_STANDING_LABEL8_FEMALE] = 8,
}
local scanTooltipTQ2 = CreateFrame( "GameTooltip", "scanTooltipTQ2", nil, "GameToolTipTemplate")
scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")

tomQuest2.PARTYQUESTSZONE = LC["PARTYQUESTSZONE"]
tomQuest2.numQuests, tomQuest2.numCompletedQuests, tomQuest2.dbVersion, tomQuest2.lastCompatibleDB, tomQuest2.firstRun, tomQuest2.buttonIndex = 0, 0, 3, 1, true, 0
tomQuest2.playerName = UnitName("player")
tomQuest2.localClass, tomQuest2.playerClass = UnitClass("player")
tomQuest2.playerLevel = UnitLevel("player")
tomQuest2.faction = UnitFactionGroup("player")
tomQuest2.itemUseLen = len(ITEM_SPELL_TRIGGER_ONUSE)
tomQuest2.objectsPattern, tomQuest2.monstersPattern, tomQuest2.factionPattern = paternize(QUEST_OBJECTS_FOUND), paternize(QUEST_MONSTERS_KILLED), paternize(QUEST_FACTION_NEEDED)
tomQuest2.playersPattern, tomQuest2.dailyCounterPattern = paternize(QUEST_PLAYERS_KILLED), paternize(DAILY_QUESTS_REMAINING)
tomQuest2.found, tomQuest2.item, tomQuest2.kill, tomQuest2.playerKilled = paternize(ERR_QUEST_ADD_FOUND_SII), paternize(ERR_QUEST_ADD_ITEM_SII), paternize(ERR_QUEST_ADD_KILL_SII), paternize(ERR_QUEST_ADD_PLAYER_KILL_SII)
tomQuest2.oComplete, tomQuest2.qComplete, tomQuest2.qFailed = paternize(ERR_QUEST_OBJECTIVE_COMPLETE_S), paternize(ERR_QUEST_COMPLETE_S), paternize(ERR_QUEST_FAILED_S)
tomQuest2.numCompletedDailyQuests = 0
tomQuest2.numItemButtons, tomQuest2.numButtons, tomQuest2.numStatusBar, tomQuest2.numContentCells = 0, 0, 0, 0
tomQuest2.numPartyMembers, tomQuest2.numRaidMembers = 0, 0
--Quests tooltip fonts
tomQuest2.cQToFontTQ2 = CreateFont("cQToFontTQ2")
tomQuest2.qQToFontTQ2 = CreateFont("qQToFontTQ2")
tomQuest2.qoQToFontTQ2 = CreateFont("qoQToFontTQ2")
--Quests tracker fonts
tomQuest2.cQTrFontTQ2 = CreateFont("cQTrFontTQ2")
tomQuest2.qQTrFontTQ2 = CreateFont("qQTrFontTQ2")
tomQuest2.qoQTrFontTQ2 = CreateFont("qoQTrFontTQ2")
--Achievements tracker fonts
tomQuest2.cATrFontTQ2 = CreateFont("cATrFontTQ2")
tomQuest2.scATrFontTQ2 = CreateFont("scATrFontTQ2")
tomQuest2.aATrFontTQ2 = CreateFont("aATrFontTQ2")
tomQuest2.acATrFontTQ2 = CreateFont("acATrFontTQ2")
tomQuest2.sbATrFontTQ2 = CreateFont("sbATrFontTQ2")

tomQuest2.sortedCategories, tomQuest2.sortedQuestsByCategory, tomQuest2.sortedQuests, tomQuest2.sortedDailyQuests = {}, {}, {}, {}
tomQuest2.tempTable, tomQuest2.moneyTempTable = {}, {}
tomQuest2.items, tomQuest2.itemsTimeStamp, tomQuest2.inventorySlotId, tomQuest2.rarityColor, tomQuest2.collapsedHeader = {}, {}, {}, {}, {}
tomQuest2.quests, tomQuest2.questsObjectives, tomQuest2.questsTitleToqid, tomQuest2.moduleState = {}, {}, {}, {}
tomQuest2.dailies, tomQuest2.forbiddenQuests = {}, {}
tomQuest2.questsCategories, tomQuest2.questsByCategory = {}, {}
tomQuest2.achievementsCategories, tomQuest2.achievements, tomQuest2.achievementsTradeSkills = {}, {}, {}
tomQuest2.achievementsItems, tomQuest2.achievementsMobs, tomQuest2.achievementName, tomQuest2.achievementIcon = {}, {}, {}, {}
tomQuest2.itemStartingQuest, tomQuest2.usableQuestItems = {}, {}
tomQuest2.classColors = {}
tomQuest2.hintCells = {}
tomQuest2.party, tomQuest2.partyTimeStamp = {}, {}
tomQuest2.categoryButtons = {questsTooltip = {}, questsTracker = {}, achievementsTracker = {}}
tomQuest2.questCategoryCells = {questsTooltip = {}, questsTracker = {}}
tomQuest2.questTextCells, tomQuest2.questStatusCells, tomQuest2.questsDescriptionCells = {questsTooltip = {}, questsTracker = {}}, {questsTooltip = {}, questsTracker = {}}, {questsTooltip = {}, questsTracker = {}}
tomQuest2.questsObjectiveTextCells, tomQuest2.questsObjectiveStatusCells = {questsTooltip = {}, questsTracker = {}}, {questsTooltip = {}, questsTracker = {}}
tomQuest2.specialItemButtons, tomQuest2.fakeItemButtons = {questsTooltip = {}, questsTracker = {}}, {questsTooltip = {}, questsTracker = {}}
tomQuest2.achievementCategoryTextCells, tomQuest2.achievementCategoryStatusCells = {}, {}
tomQuest2.achievementCells, tomQuest2.achievementIcons, tomQuest2.achievementStatusBars, tomQuest2.achievementDescriptionCells = {}, {}, {}, {}
tomQuest2.achievementCriterionTextCells, tomQuest2.achievementCriterionStatusCells, tomQuest2.achievementBooleanCriterionCells = {}, {}, {}
tomQuest2.itemButtonCache, tomQuest2.buttonCache, tomQuest2.statusBarCache, tomQuest2.contentCellCache = {}, {}, {}, {}
tomQuest2.stack = {}
tomQuest2.specialItems = {["32971"] = true}
tomQuest2.lhrepl = {["<"] = "&lt;", [">"] = "&gt;"}
tomQuest2.repl = {["<"] = "[", [">"] = "]"}
tomQuest2.achMobs = {1206, 2557, 2556, 1312, 2257}
tomQuest2.achItems = {1244, 1956, 1225, 1517}
tomQuest2.achTrade = {1779, 1800}
tomQuest2.substitute = {["Écureuil"] = "Ecureuil", ["Écureuil des Grisonnes"] = "Ecureuil des Grisonnes"}
tomQuest2.interactivityList = {
	["chatLink"] = LC["Insert quest link in chat"],
	["objectiveProgress"] = LC["Insert quest objectives progress in chat"],
	["macroUpdate"] = LC["Update special quest item macro"],
	["questTooltip"] = LC["Display of quest tooltip"],
	["shareQuest"] = LC["Share quest"],
	["trackQuest"] = LC["Track quest"],
	["abandonQuest"] = LC["Abandon quest"],
	["displayQuest"] = LC["Diplay quest log"],
	["displayQuestInfo"] = LC["Display quest on map"],
	["nothing"] = LC["Do nothing"],
}
tomQuest2.framesBackDrop = {
	questsTooltip = GameTooltip:GetBackdrop(),
	questsTracker = GameTooltip:GetBackdrop(),
	achievementsTracker = GameTooltip:GetBackdrop()
}
tomQuest2.statusBarBackDrop = {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	insets = {top = -1, left = -1, bottom = -1, right = -1}
}
tomQuest2.sliderBackDrop = {
	bgFile = "Interface\\Buttons\\UI-SliderBar-Background",
	edgeFile = "Interface\\Buttons\\UI-SliderBar-Border",
	tile = true, edgeSize = 8, tileSize = 8,
	insets = {top = 3, left = 3, bottom = 3, right = 3}
}
local inventorySlot = {"HeadSlot", "NeckSlot", "ShoulderSlot", "BackSlot", "ChestSlot", "ShirtSlot", "TabardSlot", "WristSlot", "HandsSlot", "WaistSlot", "LegsSlot", "FeetSlot", "Finger0Slot", "Finger1Slot", "Trinket0Slot", "Trinket1Slot", "MainHandSlot", "SecondaryHandSlot", "RangedSlot", "AmmoSlot"}
for _, v in pairs(inventorySlot) do
	local slotId = GetInventorySlotInfo(v)
	tomQuest2.inventorySlotId[slotId] = true
end
for rarity = 0, 6 do
	local r, g, b = GetItemQualityColor(rarity)
	tomQuest2.rarityColor[rarity] = format("%02x%02x%02x", r*255, g*255, b*255)
end

---------------------------------------
--- Shared Media Sound Registration ---
---------------------------------------
LSM:Register("sound", "Peon Ready", [[Sound\Creature\Peon\PeonReady1.wav]])
LSM:Register("sound", "Work Done", [[Interface\Addons\tomQuest2\media\Peasant_work_done.mp3]])
LSM:Register("sound", "Thrumm", [[Sound\Interface\igPlayerBind.wav]])
LSM:Register("sound", "More work?", [[Sound\Creature\Peasant\PeasantWhat3.wav]])
LSM:Register("sound", "Work complete!", [[Sound\Creature\Peon\PeonBuildingComplete1.wav]])
LSM:Register("sound", "Quest Added", [[Sound\interface\iQuestActivate.wav]])
LSM:Register("sound", "Quest Completed", [[Sound\interface\iQuestComplete.wav]])
LSM:Register("sound", "Quest Failed", [[Sound\interface\igQuestFailed.wav]])
LSM:Register("sound", "Auction Window Open", [[Sound\interface\AuctionWindowOpen.wav]])
LSM:Register("sound", "Auction Window Close", [[Sound\interface\AuctionWindowClose.wav]])
LSM:Register("sound", "Ready Check", [[Sound\interface\levelup2.wav]])
LSM:Register("sound", "Level Up", [[Sound\interface\levelup.wav]])

-----------------------
--- Tools functions ---
-----------------------
local function onLeave(self)
	GameTooltip:Hide()
end

local function short(value)
	if value >= 10000000 then
		return format("%.1fm", value / 1000000)
	elseif value >= 1000000 then
		return format("%.2fm", value / 1000000)
	elseif value >= 100000 then
		return format("%.0fk", value / 1000)
	elseif value >= 10000 then
		return format("%.1fk", value / 1000)
	else
		return format("%d", value)
	end
end

local function formatTime(s)
	if s >= 60 then
		return format("%dm%ds", floor(s/60+0.5), floor(s%60))
	else
		return format("%ds", s)
	end
end

local function utf8sub(name)
	local bytes = len(name)
	if bytes <= 3 then
		return name
	else
		local len, pos = 0, 1
		while pos <= bytes do
			len = len + 1
			local c = byte(name, pos)
			if c > 0 and c <= 127 then
				pos = pos + 1
			elseif c >= 192 and c <= 223 then
				pos = pos + 2
			elseif c >= 224 and c <= 239 then
				pos = pos + 3
			elseif c >= 240 and c <= 247 then
				pos = pos + 4
			end
			if len == 3 then break end
		end
		return sub(name, 1, pos - 1)
	end
end

local function getTipAnchor(frame)
	local x, y = frame:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf = (x > UIParent:GetWidth() * 2/3) and "RIGHT" or (x < UIParent:GetWidth() / 3) and "LEFT" or ""
	local vhalf = (y > UIParent:GetHeight() / 2) and "TOP" or "BOTTOM"
	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end
local function getTrackerPosition(tracker)
	local x, y = tracker:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf, xOffset, vhalf, yOffset
	local width, height = UIParent:GetWidth(), UIParent:GetHeight()
	if x > width/2 then
		hhalf = "RIGHT"
		xOffset = -(width - tracker:GetRight())
	else
		hhalf = "LEFT"
		xOffset = tracker:GetLeft()
	end
	if y > height/2 then
		vhalf = "TOP"
		yOffset = -(height - tracker:GetTop())
	else
		vhalf = "BOTTOM"
		yOffset = tracker:GetBottom()
	end
	return vhalf..hhalf, vhalf..hhalf, xOffset, yOffset
end
local function play(sound)
	local soundPlayed = PlaySoundFile(sound)
	if not soundPlayed then
		PlaySound(sound)
	end
end

local ldbOnClick = {
	openOptions = function()
		LoadAddOn("tomQuest2_Config")
		InterfaceOptionsFrame_OpenToCategory(tomQuest2.profilesOptionFrame)
		InterfaceOptionsFrame_OpenToCategory(tomQuest2.mainOptionFrame)
	end,
	toggleQuestTracker = function()
		tomQuest2:tQ2toggleQuestsTracker()
	end,
	toggleAchievementsTracker = function()
		tomQuest2:tQ2toggleAchievementsTracker()
	end,
	toggleAnnouncementModule = function()
		tomQuest2:setModuleEnabled("announce", tomQuest2.moduleState["announce"] and false or true)
	end,
	toggleQuestsLog = function()
		ToggleFrame(QuestLogFrame)
	end,
	toggleSyncPartyModule = function()
		tomQuest2:setModuleEnabled("syncParty", tomQuest2.moduleState["syncParty"] and false or true)
	end,
	toggleQuestsTrackerModule = function()
		tomQuest2:setModuleEnabled("questsTracker", tomQuest2.moduleState["questsTracker"] and false or true)
	end,
	toggleAchievementsTrackerModule = function()
		tomQuest2:setModuleEnabled("achievementsTracker", tomQuest2.moduleState["achievementsTracker"] and false or true)
	end,
	lockQuestsTracker = function()
		prdb.questsTacker.lockTracker = not prdb.questsTracker.lockTracker
	end,
	lockAchievementsTracker = function()
		prdb.achievementsTracker.lockTracker = not prdb.achievementsTracker.lockTracker
	end,
	nothing = function(value)
		return
	end,
}

local levelTag = {
	elite = function(qid, level, group)
		return level + prdb.eliteAddLevel
	end,
	group = function(qid, level, group)
		return level + prdb.groupAddLevel * (group - tomQuest2.numPartyMembers)
	end,
	heroic = function(qid, level, group)
		return level + prdb.heroicAddLevel * (group - tomQuest2.numPartyMembers)
	end,
	dungeon = function(qid, level, group)
		return level + prdb.dungeonAddLevel * (group - tomQuest2.numPartyMembers)
	end,
	raid = function(qid, level, group)
		return level + prdb.raidAddLevel * (group - max(tomQuest2.numRaidMembers, tomQuest2.numPartyMembers))
	end,
	escort = function(qid, level, group)
		return level
	end,
	pvp = function(qid, level, group)
		return level
	end,
	daily = function(qid, level, group)
		return level
	end,
	notag = function(qid, level, group)
		return level
	end,
}

function tomQuest2:normalizeColorComponent(component)
	if component > 1 then return 1 elseif component < 0 then return 0 else return component end
end

function tomQuest2:getColorFromCompletionRGB(percent)
	if percent <= 0 then
		return prdb.rj0, prdb.gj0, prdb.bj0
	elseif percent >= 1 then
		return prdb.rj3, prdb.gj3, prdb.bj3
	elseif percent <= 0.5 then
		return self:normalizeColorComponent(prdb.ri1*percent + prdb.rj1), self:normalizeColorComponent(prdb.gi1*percent + prdb.gj1), self:normalizeColorComponent(prdb.bi1*percent + prdb.bj1)
	else
		return self:normalizeColorComponent(prdb.ri2*percent + prdb.rj2), self:normalizeColorComponent(prdb.gi2*percent + prdb.gj2), self:normalizeColorComponent(prdb.bi2*percent + prdb.bj2)
	end
end

function tomQuest2:getColorFromCompletionHEX(percent)
	if percent <= 0 then
		return format("%02x%02x%02x", 255*prdb.rj0, 255*prdb.gj0, 255*prdb.bj0)
	elseif percent >= 1 then
		return format("%02x%02x%02x", 255*prdb.rj3, 255*prdb.gj3, 255*prdb.bj3)
	elseif percent <= 0.5 then
		return format("%02x%02x%02x", 255*self:normalizeColorComponent(prdb.ri1*percent + prdb.rj1), 255*self:normalizeColorComponent(prdb.gi1*percent + prdb.gj1), 255*self:normalizeColorComponent(prdb.bi1*percent + prdb.bj1))
	else
		return format("%02x%02x%02x", 255*self:normalizeColorComponent(prdb.ri2*percent + prdb.rj2), 255*self:normalizeColorComponent(prdb.gi2*percent + prdb.gj2), 255*self:normalizeColorComponent(prdb.bi2*percent + prdb.bj2))
	end
end

function tomQuest2:getDifficultyColor(levelDiff)
	if levelDiff >= 5 then
		return QuestDifficultyColors["impossible"]
	elseif levelDiff >= 3 then
		return QuestDifficultyColors["verydifficult"]
	elseif levelDiff >= -2 then
		return QuestDifficultyColors["difficult"]
	elseif -levelDiff <= GetQuestGreenRange() then
		return QuestDifficultyColors["standard"]
	else
		return QuestDifficultyColors["trivial"]
	end
end

function tomQuest2:computeQuestsLevel()
	for qid, questData in pairs(self.quests) do
		self.quests[qid].weightedLevel = levelTag[questData.shortTag](qid, questData.level, questData.group)
	end
	self:questsSort()
	self:setQuestsTrackerLayout()
end

function tomQuest2:computeQuestsTag()
	for qid, questData in pairs(self.quests) do
		local tagLevel = prdb.level == "questLevel" and questData.level or questData.weightedLevel
		if tagLevel > 0 or questData.shortTag ~= "notag" or questData.group > 0 or questData.daily == 1 then
			self.quests[qid].tag = format("[%s%s%s%s]", tagLevel > 0 and tagLevel or "", prdb[questData.shortTag], questData.group > 0 and questData.group or "", questData.daily == 1 and (questData.shortTag ~= "daily" and prdb["daily"] or "") or "")
		else
			self.quests[qid].tag = ""
		end
		self:updateQuestCells(qid)
	end
	self:setQuestsTrackerLayout()
end

function tomQuest2:formatMoney(money)
	local tIndex = 0
	local gold = floor(money / 10000)
	local silver = mod(floor(money / 100), 100)
	local copper = mod(floor(money), 100)
	if prdb.moneySeparator == "dot" then
		if prdb.colorizeMoney then
			if gold > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffffd700"..gold.."|r"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffc7c7cf"..silver.."|r"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffeda55f"..copper.."|r"
			end
		else
			if gold > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = gold
			end
			if silver > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = silver
			end
			if copper > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = copper
			end
		end
		return tconcat(self.moneyTempTable, ".", 1, tIndex)
	elseif prdb.moneySeparator == "symbol" then
		if prdb.colorizeMoney then
			if gold > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffffd700"..gold..GOLD_AMOUNT_SYMBOL.."|r"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffc7c7cf"..silver..SILVER_AMOUNT_SYMBOL.."|r"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffeda55f"..copper..COPPER_AMOUNT_SYMBOL.."|r"
			end
		else
			if gold > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = gold..GOLD_AMOUNT_SYMBOL
			end
			if silver > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = silver..SILVER_AMOUNT_SYMBOL
			end
			if copper > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = copper..COPPER_AMOUNT_SYMBOL
			end
		end
		return tconcat(self.moneyTempTable, "", 1, tIndex)
	elseif prdb.moneySeparator == "texture" then
		if prdb.colorizeMoney then
			if gold > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffffd700"..gold.."|r|TInterface\\MoneyFrame\\UI-GoldIcon:20|t"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffc7c7cf"..silver.."|r|TInterface\\MoneyFrame\\UI-SilverIcon:20|t"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = "|cffeda55f"..copper.."|r|TInterface\\MoneyFrame\\UI-CopperIcon:20|t"
			end
		else
			if gold > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = gold.."|TInterface\\MoneyFrame\\UI-GoldIcon:20|t"
			end
			if silver > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = silver.."|TInterface\\MoneyFrame\\UI-SilverIcon:20|t"
			end
			if copper > 0 then
				tIndex = tIndex + 1
				self.moneyTempTable[tIndex] = copper.."|TInterface\\MoneyFrame\\UI-CopperIcon:20|t"
			end
		end
		return tconcat(self.moneyTempTable, "", 1, tIndex)
	end
end

function tomQuest2:Print(text)
	if text then
		DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99tomQuest2|r: "..text)
	end
end

-------------------
--- Class Color ---
-------------------
for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
	tomQuest2.classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
end
local playerColor = tomQuest2.classColors[tomQuest2.playerClass]

local function updateClassColors()
	for class, color in pairs(CUSTOM_CLASS_COLORS) do
		tomQuest2.classColors[class] = format("%02x%02x%02x", color.r*255, color.g*255, color.b*255)
	end
	playerColor = tomQuest2.classColors[tomQuest2.playerClass]
	tomQuest2:updateAllQuestsStatus()
end

-----------------------
--- Default profile ---
-----------------------
local defaults = {
	profile = {
		--Achievements Tracker
		timedAchievements = true,
		--Quests Tracker
		onLogIn = false,
		onQuestAccepted = 3,
		onObjectiveProgress = true,
		unTrackInactive = false,
		unTrackDelay = 5,
		onSubZone = true,
		onZone = true,
		onDaily = true,
		onClass = true,
		--Quests Tooltip
		showNumCompletedQuests = true,
		showNumQuests = true,
		showMaxQuest = true,
		colorizeQuestsCounter = true,
		qToMouseRightShift = "openOptions",
		qToMouseRightControl = "openOptions",
		qToMouseRightAlt = "openOptions",
		qToMouseRight = "openOptions",
		qToMouseLeftShift = "toggleQuestTracker",
		qToMouseLeftControl = "toggleAnnouncementModule",
		qToMouseLeftAlt = "toggleAchievementsTracker",
		qToMouseLeft = "toggleQuestsLog",
		qToMouseMiddleShift = "toggleQuestTracker",
		qToMouseMiddleControl = "toggleAnnouncementModule",
		qToMouseMiddleAlt = "toggleAchievementsTracker",
		qToMouseMiddle = "toggleQuestsLog",
		--Daily Quests Tooltip
		showNumCompletedDailyQuests = true,
		showMaxDailyQuest = true,
		showRemainingTime = true,
		colorizeDailyQuestsCounter = true,
		colorizeDailyQuestsTimer = true,
		showCOTD = true,
		dqToMouseRightShift = "openOptions",
		dqToMouseRightControl = "openOptions",
		dqToMouseRightAlt = "openOptions",
		dqToMouseRight = "openOptions",
		dqToMouseLeftShift = "toggleQuestTracker",
		dqToMouseLeftControl = "toggleAnnouncementModule",
		dqToMouseLeftAlt = "toggleAchievementsTracker",
		dqToMouseLeft = "toggleQuestsLog",
		dqToMouseMiddleShift = "toggleQuestTracker",
		dqToMouseMiddleControl = "toggleAnnouncementModule",
		dqToMouseMiddleAlt = "toggleAchievementsTracker",
		dqToMouseMiddle = "toggleQuestsLog",
		--Tooltips
		mobTooltip = true,
		itemTooltip = true,
		--Quests Givers
		questTitleColor = "000000",
		addQuestLevel = true,
		fadeNotCompletedQuests = true,
		automaticAccept = 4,
		automaticAcceptEscort = false,
		automaticTurnIn = false,
		--Announce
		announcePlayerObjectiveProgress = true,
		announcePlayerObjectiveComplete = true,
		announcePlayerQuestComplete = true,
		announcePlayerQuestFailed = true,
		announceObjectiveProgressWhenQuestComplete = false,
		--Notifications
		hideBlizzardNotification = true,
		notifiyObjectiveProgressWhenQuestComplete = false,
		notifyPlayerObjectiveProgress = true,
		notifyPlayerObjectiveComplete = true,
		notifyPlayerQuestComplete = true,
		notifyPlayerQuestFailed = true,
		notifyItemStartingQuestLooted = true,
		notifyPartyObjectiveProgress = true,
		notifyPartyObjectiveComplete = true,
		notifyPartyQuestComplete = true,
		notifyPartyQuestFailed = true,
		notifyPartyQuestAccepted = true,
		notifyPartyQuestTurnedIn = true,
		notifyPartyQuestAbandonned = true,
		sinkOptions = {
		},
		--SoundNotifications
		soundQuestComplete = "Work Done",
		soundQuestFailed = "Thrumm",
		soundObjectiveComplete = "Peon Ready",
		--Display Engine
		skin = {
			skin = "DreamLayout",
			gloss = 0,
			backdrop = false,
			Colors = {},
		},
		questsTooltip = {
			hideCompletedObjective = 2,
			hideZoneLevelRange = false,
			hideQuestTag = false,
			categoryFont = LSM.DefaultMedia.font,
			categoryFontSize = 12,
			categoryFontOutline = "",
			questFont = LSM.DefaultMedia.font,
			questFontSize = 10,
			questFontOutline = "",
			questObjectiveFont = LSM.DefaultMedia.font,
			questObjectiveFontSize = 8,
			questObjectiveFontOutline = "",
			bgTexture = "Blizzard Tooltip",
			borderTexture = "Blizzard Tooltip",
			borderInset = 2.5,
			borderWidth = 14,
			scale = 1,
			hasMaxHeight = true,
			maxHeight = 500,
			showCollapseButton = true,
			collapseButtonSize = 14,
			questsCellPadding = 5,
			objectivesCellPadding = 10,
			maxWidth = 250,
			minWidth = 250,
			statusMaxWidth = 70,
			statusMinWidth = 70,
			backDropColor = {0.09, 0.09, 0.09, 1},
			borderColor = {1, 1, 1, 1},
			colorizeCategoryName = true,
			defaultCategoryNameColor = "ffffff",
			colorizeCategoryLevel = true,
			defaultCategoryLevelColor = "ffffff",
			colorizeQuestName = true,
			defaultQuestNameColor = "ffffff",
			colorizeQuestLevel = true,
			defaultQuestLevelColor = "ffffff",
			colorizeQuestObjective = true,
			defaultQuestObjectiveColor = "ffffff",
			colorizeQuestObjectiveCounter = true,
			defaultQuestObjectiveCounterColor = "ffffff",
			defaultQuestDescriptionColor = "ffffff",
			showQuestItemIcon = true,
			questItemIconSize = 18,
			showHints = true,
			overTooltip = true,
			mouseRightShift = "chatLink",
			mouseRightControl = "objectiveProgress",
			mouseRightAlt = "macroUpdate",
			mouseRight = "questTooltip",
			mouseLeftShift = "trackQuest",
			mouseLeftControl = "shareQuest",
			mouseLeftAlt = "abandonQuest",
			mouseLeft = "displayQuest",
			mouseMiddleShift = "displayQuestInfo",
			mouseMiddleControl = "displayQuestInfo",
			mouseMiddleAlt = "displayQuestInfo",
			mouseMiddle = "displayQuestInfo",
		},
		questsTracker = {
			point = "TOPRIGHT",
			relativePoint = "TOPRIGHT",
			xOffset = -30,
			yOffset = -30,
			showByCategory = true,
			autoCollapseCategory = true,
			lockTracker = true,
			toggleTracker = true,
			hideTrackerInCombat = true,
			hideCompletedQuest = 2,
			hideCompletedObjective = 2,
			onlyCurrentZone = false,
			limitQuestLevel = false,
			maxLevelDiff = 3,
			hideZoneLevelRange = false,
			hideQuestTag = false,
			categoryFont = LSM.DefaultMedia.font,
			categoryFontSize = 12,
			categoryFontOutline = "",
			questFont = LSM.DefaultMedia.font,
			questFontSize = 10,
			questFontOutline = "",
			questObjectiveFont = LSM.DefaultMedia.font,
			questObjectiveFontSize = 8,
			questObjectiveFontOutline = "",
			bgTexture = "Blizzard Tooltip",
			borderTexture = "Blizzard Tooltip",
			borderInset = 2.5,
			borderWidth = 14,
			scale = 1,
			hasMaxHeight = true,
			maxHeight = 500,
			showCollapseButton = true,
			collapseButtonSize = 12,
			questsCellPadding = 5,
			objectivesCellPadding = 10,
			maxWidth = 250,
			minWidth = 250,
			statusMaxWidth = 70,
			statusMinWidth = 70,
			backDropColor = {0.09, 0.09, 0.09, 1},
			borderColor = {1, 1, 1, 1},
			colorizeCategoryName = true,
			defaultCategoryNameColor = "ffffff",
			colorizeCategoryLevel = true,
			defaultCategoryLevelColor = "ffffff",
			colorizeQuestName = true,
			defaultQuestNameColor = "ffffff",
			colorizeQuestLevel = true,
			defaultQuestLevelColor = "ffffff",
			colorizeQuestTimer = true,
			defaultQuestTimerColor = "ffffff",
			colorizeQuestObjective = true,
			defaultQuestObjectiveColor = "ffffff",
			colorizeQuestObjectiveCounter = true,
			defaultQuestObjectiveCounterColor = "ffffff",
			defaultQuestDescriptionColor = "ffffff",
			showQuestItemIcon = true,
			questItemIconSize = 18,
			oorColor = {0.8, 0.1, 0.1},
			showItemsStartingQuest = true,
			showUsableQuestItemsNotAttached = true,
			otherItemIconSize = 12,
			disableInteraction = false,
			overTooltip = true,
			mouseRightShift = "chatLink",
			mouseRightControl = "objectiveProgress",
			mouseRightAlt = "macroUpdate",
			mouseRight = "questTooltip",
			mouseLeftShift = "trackQuest",
			mouseLeftControl = "shareQuest",
			mouseLeftAlt = "abandonQuest",
			mouseLeft = "displayQuest",
			mouseMiddleShift = "displayQuestInfo",
			mouseMiddleControl = "displayQuestInfo",
			mouseMiddleAlt = "displayQuestInfo",
			mouseMiddle = "displayQuestInfo",
		},
		achievementsTracker = {
			point = "TOPLEFT",
			relativePoint = "TOPLEFT",
			xOffset = 30,
			yOffset = -30,
			showInQuestTracker = true,
			positionInQuestTracker = 1,
			lockTracker = true,
			toggleTracker = true,
			hideTrackerInCombat = true,
			hideCompletedCriteria = true,
			showByCategory = true,
			categoryFont = LSM.DefaultMedia.font,
			categoryFontSize = 12,
			categoryFontOutline = "",
			subCategoryFont = LSM.DefaultMedia.font,
			subCategoryFontSize = 12,
			subCategoryFontOutline = "",
			achievementFont = LSM.DefaultMedia.font,
			achievementFontSize = 10,
			achievementFontOutline = "",
			achievementCriterionFont = LSM.DefaultMedia.font,
			achievementCriterionFontSize = 8,
			achievementCriterionFontOutline = "",
			statusBarFont = LSM.DefaultMedia.font,
			statusBarFontSize = 8,
			statusBarFontOutline = "",
			bgTexture = "Blizzard Tooltip",
			borderTexture = "Blizzard Tooltip",
			borderWidth = 14,
			borderInset = 2.5,
			scale = 1,
			hasMaxHeight = true,
			maxHeight = 500,
			subCategoryCellPadding = 5,
			showCollapseButton = true,
			categoryCollapseButtonSize = 12,
			subCategoryCollapseButtonSize = 12,
			showAchievementIcon = true,
			achievementIconSize = 10,
			achievementCellPadding = 5,
			criteriaCellPadding = 10,
			maxWidth = 250,
			minWidth = 250,
			statusMaxWidth = 70,
			statusMinWidth = 70,
			numBooleanCriteriaColumns = 2,
			backDropColor = {0.09, 0.09, 0.09, 1},
			borderColor = {1, 1, 1, 1},
			colorizeACName = true,
			defaultACNameColor = "ffffff",
			colorizeACCounter = true,
			defaultACCounterColor = "ffffff",
			colorizeASCName = true,
			defaultASCNameColor = "ffffff",
			colorizeASCCounter = true,
			defaultASCCounterColor = "ffffff",
			defaultANameColor = "ffffff",
			colorizeATimer = true,
			defaultATimerColor = "ffffff",
			colorizeACrName = true,
			defaultACrNameColor = "ffffff",
			colorizeACrStatus = true,
			defaultACrStatusColor = "ffffff",
			colorizeStatusBar = true,
			defaultStatusBarColor = {0, 0.6, 0},
			colorizeStatusBarText = false,
			defaultStatusBarTextColor = "ffffff",
			defaultDescriptionColor = "ffffff",
			displayAsStatusBar = true,
			statusBarTexture = LSM.DefaultMedia.statusbar,
			statusBarHeight = 12,
			rightStatusBarPadding = 40,
			leftStatusBarPadding = 40,
			disableInteraction = false,
			overTooltip = true,
			mouseRightShift = "chatLink",
			mouseRightControl = "nothing",
			mouseRightAlt = "nothing",
			mouseRight = "achievementTooltip",
			mouseLeftShift = "removeTrackedAchievement",
			mouseLeftControl = "nothing",
			mouseLeftAlt = "nothing",
			mouseLeft = "displayAchievement",
			mouseMiddleShift = "nothing",
			mouseMiddleControl = "nothing",
			mouseMiddleAlt = "nothing",
			mouseMiddle = "nothing",
		},
		--Quests information
		backDropColor = {0.09, 0.09, 0.19, 0.5},
		borderColor = {0.5, 0.5, 0.5, 1},
		attach = 1,
		showQuestLog = true,
		qlFont = LSM.DefaultMedia.font,
		qlFontSizeH1 = 14,
		qlFontSizeH2 = 12,
		qlFontSize = 10,
		showLightHeaded = true,
		showAllCommentsOnOnePage = false,
		lhFont = LSM.DefaultMedia.font,
		lhFontSize = 10,
		tomQuest2ParentFrame = {
			width = 640,
			height = 400,
			point = "CENTER",
			x = 0,
			y = 0,
		},
		tomQuest2QlFrame = {
			width = 320,
			height = 400,
			point = "CENTER",
			x = 0,
			y = 0,
		},
		tomQuest2LhFrame = {
			width = 320,
			height = 400,
			point = "CENTER",
			x = 0,
			y = 0,
		},
		color = "ffffd100",
		--Core
		colorizeMoney = true, moneySeparator = "symbol", partyHeader = true,
		categorySorting = "levelA", categoryWithoutLvlPos = 0, questsSorting = "weightedA",
		hideDefaultBlizTracker = true,
		eliteAddLevel = 3, groupAddLevel = 1, dungeonAddLevel = 2, heroicAddLevel = 3, raidAddLevel = 1,
		level = "questLevel", elite = "+", group = "g", pvp = "p", raid = "r", dungeon = "d", heroic = "d+", daily = "\226\128\162", escort = "e", notag = "",
		completedColor = "00ff00", failedColor = "ff0000",
		customColorMode = true,
		rj0 = 1, gj0 = 0, bj0 = 0,
		ri1 = 0, rj1 = 1, gi1 = 2, gj1 = 0, bi1 = 0, bj1 = 0,
		ri2 = -2, rj2 = 2, gi2 = 0, gj2 = 1, bi2 = 0, bj2 = 0,
		rj3 = 0, gj3 = 1, bj3 = 0,
		modules = {
			dailyTooltip = true,
			notifications = true,
			informations = true,
			questsTooltip = true,
			questsTracker = true,
			soundNotifications = true,
			syncParty = true,
			questsGivers = true,
			tagQuestLog = true,
			tooltips = true,
			announce = false,
			achievementsTracker = true,
			achievementsTradeSkills = true,
		},
		raidModules = {
			enabled = true,
			dailyTooltip = "inRaidInstance",
			notifications = "inRaidInstance",
			informations = "enabled",
			questsTooltip = "enabled",
			questsTracker = "inRaidInstance",
			soundNotifications = "enabled",
			syncParty = "inRaidInstance",
			questsGivers = "enabled",
			tagQuestLog = "enabled",
			tooltips = "inRaidInstance",
			announce = "inRaidInstance",
			achievementsTracker = "enabled",
			achievementsTradeSkills = "enabled",
		},
	},
}

----------------------
--- Display Engine ---
----------------------
local function startAchievementsTrackerMoving(self)
	self:StartMoving()
end

local function stopAchievementsTrackerMoving(self)
	self:StopMovingOrSizing()
	prdb.achievementsTracker.point, prdb.achievementsTracker.relativePoint, prdb.achievementsTracker.xOffset, prdb.achievementsTracker.yOffset = getTrackerPosition(self)
	self:SetPoint(prdb.achievementsTracker.point, UIParent, prdb.achievementsTracker.relativePoint, prdb.achievementsTracker.xOffset, prdb.achievementsTracker.yOffset)
end

local function startQuestsTrackerMoving(self)
	self:StartMoving()
end

local function stopQuestsTrackerMoving(self)
	self:StopMovingOrSizing()
	prdb.questsTracker.point, prdb.questsTracker.relativePoint, prdb.questsTracker.xOffset, prdb.questsTracker.yOffset = getTrackerPosition(self)
	self:SetPoint(prdb.questsTracker.point, UIParent, prdb.questsTracker.relativePoint, prdb.questsTracker.xOffset, prdb.questsTracker.yOffset)
end

local function slider_OnValueChanged(self)
	self:GetParent().scrollFrame:SetVerticalScroll(self:GetValue())
end

local function tooltip_OnMouseWheel(self, delta)
	local slider = self.slider
	local currentValue = slider:GetValue()
	local minValue,maxValue = slider:GetMinMaxValues()
	if delta < 0 and currentValue < maxValue then
		slider:SetValue(min(maxValue, currentValue + 10))
	elseif delta > 0 and currentValue > minValue then
		slider:SetValue(max(minValue, currentValue - 10))
	end
end

local function updateScrolling(self, maxheight)
	local scale = self:GetScale()
	local topside = self:GetTop()
	local bottomside = self:GetBottom()
	local screensize = UIParent:GetHeight()/scale
	local tipsize = (topside - bottomside)/scale
	if bottomside < 0 or topside > screensize or (maxheight and tipsize > maxheight) then
		local shrink = (bottomside < 0 and (5 - bottomside) or 0) + (topside > screensize and (topside - screensize + 5) or 0)
		if maxheight and tipsize - shrink > maxheight then
			shrink = tipsize - maxheight
		end
		self:SetHeight(2 * TOOLTIP_PADDING + self.height - shrink)
		self:SetWidth(2 * TOOLTIP_PADDING + self.width + 20)
		self.scrollFrame:SetPoint("RIGHT", self, "RIGHT", -(TOOLTIP_PADDING + 20), 0)
		self.slider:SetMinMaxValues(0, shrink)
		self.slider:Show()
		self:EnableMouseWheel(true)
		self:SetScript("OnMouseWheel", tooltip_OnMouseWheel)
	else
		self:SetHeight(2 * TOOLTIP_PADDING + self.height)
		self:SetWidth(2 * TOOLTIP_PADDING + self.width)
		self.scrollFrame:SetPoint("RIGHT", self, "RIGHT", -TOOLTIP_PADDING, 0)
		if self.slider then
			self.slider:SetValue(0)
			self.slider:Hide()
			self:EnableMouseWheel(false)
			self:SetScript("OnMouseWheel", nil)
		end
	end
end

function tomQuest2:getContainer(name)
	local container = CreateFrame("Frame", name, UIParent)
	container.scrollFrame = CreateFrame("ScrollFrame", name.."ScrollFrame", container)
	container.scrollFrame:SetPoint("TOP", container, "TOP", 0, -TOOLTIP_PADDING)
	container.scrollFrame:SetPoint("BOTTOM", container, "BOTTOM", 0, TOOLTIP_PADDING)
	container.scrollFrame:SetPoint("LEFT", container, "LEFT", TOOLTIP_PADDING, 0)
	container.scrollFrame:SetPoint("RIGHT", container, "RIGHT", -TOOLTIP_PADDING, 0)
	container.slider = CreateFrame("Slider", name.."Slider", container)
	container.slider:SetOrientation("VERTICAL")
	container.slider:SetPoint("TOPRIGHT", container, "TOPRIGHT", -TOOLTIP_PADDING, -TOOLTIP_PADDING)
	container.slider:SetPoint("BOTTOMRIGHT", container, "BOTTOMRIGHT", -TOOLTIP_PADDING, TOOLTIP_PADDING)
	container.slider:SetBackdrop(self.sliderBackDrop)
	container.slider:SetThumbTexture([[Interface\Buttons\UI-SliderBar-Button-Vertical]])
	container.slider:SetMinMaxValues(0, 1)
	container.slider:SetValueStep(1)
	container.slider:SetWidth(12)
	container.slider:SetScript("OnValueChanged", slider_OnValueChanged)
	container.slider:SetValue(0)
	container.scrollChild = CreateFrame("Frame", name.."ScrollChild", container.scrollFrame)
	container.scrollFrame:SetScrollChild(container.scrollChild)
	return container
end

function tomQuest2:setBackDrop(cellType)
	self.framesBackDrop[cellType].bgFile = LSM:Fetch("background", prdb[cellType].bgTexture)
	self.framesBackDrop[cellType].edgeFile = LSM:Fetch("border", prdb[cellType].borderTexture)
	self.framesBackDrop[cellType].insets.left = prdb[cellType].borderInset
	self.framesBackDrop[cellType].insets.right = prdb[cellType].borderInset
	self.framesBackDrop[cellType].insets.top = prdb[cellType].borderInset
	self.framesBackDrop[cellType].insets.bottom = prdb[cellType].borderInset
	self.framesBackDrop[cellType].edgeSize = prdb[cellType].borderWidth
end

local function setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, cellPadding, showButton, buttonSize, useItemSize, enableInteraction, displayFrame, cell, button)
	cell:EnableMouse(enableInteraction)
	local textWidth = min(max(cell.fs:GetStringWidth(), totalMinWidth - cellPadding - CELL_MARGIN_L), totalMaxWidth - cellPadding - CELL_MARGIN_L)
	maxTotalWidth = max(maxTotalWidth, textWidth)
	cell.fs:SetWidth(textWidth)
	local height
	if button then
		if showButton then
			button:Show()
			button:RegisterForClicks(enableInteraction and "AnyDown" or nil)
		else
			button:Hide()
		end
		if useItemSize then
			height = max(buttonSize, cell.fs:GetHeight())
		else
			height = cell.fs:GetHeight()
		end
	else
		height = cell.fs:GetHeight()
	end
	cell:SetHeight(height)
	cell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", cellPadding + CELL_MARGIN_L, -vSpaceUsed)
	vSpaceUsed = vSpaceUsed + height
	cell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPLEFT", cellPadding + CELL_MARGIN_L + textWidth, -vSpaceUsed)
	cell:Show()
	return vSpaceUsed + LINE_SPACING_V, maxTotalWidth
end

local function setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, textCellPadding, showButton, buttonSize, useItemSize, enableInteraction, displayFrame, textCell, statusCell, button)
	textCell:EnableMouse(enableInteraction)
	local textWidth = min(max(textCell.fs:GetStringWidth(), minWidth - textCellPadding - CELL_MARGIN_L), maxWidth - textCellPadding - CELL_MARGIN_L)
	maxTextWidth = max(maxTextWidth, textWidth)
	textCell.fs:SetWidth(textWidth)
	statusCell:EnableMouse(enableInteraction)
	local statusWidth = min(max(statusCell.fs:GetStringWidth(), statusMinWidth), statusMaxWidth)
	maxStatusWidth = max(maxStatusWidth, statusWidth)
	statusCell.fs:SetWidth(statusWidth)
	maxTotalWidth = max(maxTotalWidth, textWidth + statusWidth)
	local height
	if button then
		if showButton then
			button:Show()
			button:RegisterForClicks(enableInteraction and "AnyDown" or nil)
		else
			button:Hide()
		end
		if useItemSize then
			height = max(buttonSize, textCell.fs:GetHeight(), statusCell.fs:GetHeight())
		else
			height = max(textCell.fs:GetHeight(), statusCell.fs:GetHeight())
		end
	else
		height = max(textCell.fs:GetHeight(), statusCell.fs:GetHeight())
	end
	textCell:SetHeight(height)
	statusCell:SetHeight(height)
	textCell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", textCellPadding + CELL_MARGIN_L, -vSpaceUsed)
	statusCell:SetPoint("TOPRIGHT", displayFrame, "TOPRIGHT", - CELL_MARGIN_R, -vSpaceUsed)
	vSpaceUsed = vSpaceUsed + height
	textCell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPLEFT", textCellPadding + textWidth + CELL_MARGIN_L, -vSpaceUsed)
	statusCell:SetPoint("BOTTOMLEFT", displayFrame, "TOPRIGHT", -statusWidth - CELL_MARGIN_R, -vSpaceUsed)
	textCell:Show()
	statusCell:Show()
	return vSpaceUsed + LINE_SPACING_V, maxTextWidth, maxStatusWidth, maxTotalWidth
end

function tomQuest2:setQuestLayout(qid, cellType, questsCellPadding, objectivesCellPadding, questItemIconSize, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, displayTime, enableInteraction)
	local displayFrame = self.displayFrames[cellType].scrollChild
	vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, questsCellPadding, prdb[cellType].showQuestItemIcon, questItemIconSize, false, enableInteraction, displayFrame, self.questTextCells[cellType][qid], self.questStatusCells[cellType][qid], self.specialItemButtons[cellType][qid] or self.fakeItemButtons[cellType][qid])
	if self.questsObjectives[qid] then
		for oid, qoData in ipairs(self.questsObjectives[qid]) do
			if prdb[cellType].hideCompletedObjective == 3 or (prdb[cellType].hideCompletedObjective == 2 and qoData.partyStatus == 0) or (prdb[cellType].hideCompletedObjective == 1 and qoData.playerStatus == 0) then
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, objectivesCellPadding, nil, nil, nil, enableInteraction, displayFrame, self.questsObjectiveTextCells[cellType][qid][oid], self.questsObjectiveStatusCells[cellType][qid][oid], nil)
			end
		end
	else
		if self.quests[qid].objective then
			vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, objectivesCellPadding, nil, nil, nil, enableInteraction, displayFrame, self.questsDescriptionCells[cellType][qid], nil)
		end
	end
	return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
end

function tomQuest2:setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, enableInteraction, collapseIconSize, questItemIconSize, questsCellPadding, objectivesCellPadding, displayTime)
	local displayFrame = self.displayFrames.questsTracker.scrollChild
	if prdb.questsTracker.showByCategory then
		for _, category in ipairs(self.sortedCategories) do
			if not prdb.questsTracker.onlyCurrentZone or category == self.currentZone then
				local vSpaceUsedOld = vSpaceUsed
				local questCategoryButton = self.categoryButtons.questsTracker[category]
				local questCategoryCell = self.questCategoryCells.questsTracker[category]
				vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, 0, prdb.questsTracker.showCollapseButton, collapseIconSize, true, enableInteraction, displayFrame, questCategoryCell, questCategoryButton)
				local hideCategory = true
				if chdb.categoryDisplay.questsTracker[category] == 1 or not enableInteraction then
					for _, qid in ipairs(self.sortedQuestsByCategory[category]) do
						if self.quests[qid] and chdb.questsTracked[qid] and (prdb.questsTracker.hideCompletedQuest == 3 or (prdb.questsTracker.hideCompletedQuest == 2 and self.quests[qid].partyStatus <= 0) or (prdb.questsTracker.hideCompletedQuest == 1 and self.quests[qid].playerStatus <= 0)) and ((prdb.questsTracker.limitQuestLevel and (self.quests[qid].weightedLevel - self.playerLevel <= prdb.questsTracker.maxLevelDiff)) or not prdb.questsTracker.limitQuestLevel) then
							hideCategory = false
							vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setQuestLayout(qid, QUESTS_TRACKER, questsCellPadding, objectivesCellPadding, questItemIconSize, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, displayTime, enableInteraction)
						else
							self.questTextCells.questsTracker[qid]:Hide()
							self.questStatusCells.questsTracker[qid]:Hide()
							if self.questsObjectives[qid] then
								for oid, qoData in ipairs(self.questsObjectives[qid]) do
									self.questsObjectiveTextCells.questsTracker[qid][oid]:Hide()
									self.questsObjectiveStatusCells.questsTracker[qid][oid]:Hide()
								end
							elseif self.quests[qid].objective then
								self.questsDescriptionCells.questsTracker[qid]:Hide()
							end
						end
					end
					maxTotalWidth = max(maxTotalWidth, maxTextWidth + maxStatusWidth)
				else
					for _, qid in ipairs(self.sortedQuestsByCategory[category]) do
						if self.quests[qid] and chdb.questsTracked[qid] and (prdb.questsTracker.hideCompletedQuest == 3 or (prdb.questsTracker.hideCompletedQuest == 2 and self.quests[qid].partyStatus <= 0 ) or (prdb.questsTracker.hideCompletedQuest == 1 and self.quests[qid].playerStatus <= 0)) and ((prdb.questsTracker.limitQuestLevel and (self.quests[qid].weightedLevel - self.playerLevel <= prdb.questsTracker.maxLevelDiff)) or not prdb.questsTracker.limitQuestLevel) then
							hideCategory = false
							self.questTextCells.questsTracker[qid]:Hide()
							self.questStatusCells.questsTracker[qid]:Hide()
							if self.questsObjectives[qid] then
								for oid, qoData in ipairs(self.questsObjectives[qid]) do
									self.questsObjectiveTextCells.questsTracker[qid][oid]:Hide()
									self.questsObjectiveStatusCells.questsTracker[qid][oid]:Hide()
								end
							elseif self.quests[qid].objective then
								self.questsDescriptionCells.questsTracker[qid]:Hide()
							end
						end
					end
				end
				if hideCategory then
					questCategoryCell:Hide()
					vSpaceUsed = vSpaceUsedOld
				else
					questCategoryCell:Show()
				end
			else
				questCategoryCell:Hide()
			end
		end
	else
		for _, qid in ipairs(self.sortedQuests) do
			if self.quests[qid] and chdb.questsTracked[qid] and (prdb.questsTracker.hideCompletedQuest == 3 or (prdb.questsTracker.hideCompletedQuest == 2 and self.quests[qid].partyStatus <= 0) or (prdb.questsTracker.hideCompletedQuest == 1 and self.quests[qid].playerStatus <= 0)) and ((prdb.questsTracker.limitQuestLevel and (self.quests[qid].weightedLevel - self.playerLevel <= prdb.questsTracker.maxLevelDiff)) or not prdb.questsTracker.limitQuestLevel) then
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setQuestLayout(qid, "questsTracker", questsCellPadding, objectivesCellPadding, questItemIconSize, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, displayTime, enableInteraction)
			end
		end
		maxTotalWidth = max(maxTotalWidth, maxTextWidth + maxStatusWidth)
	end
	return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
end

function tomQuest2:setQuestsTooltipLayout()
	local minWidthQTo, maxWidthQTo = prdb.questsTooltip.minWidth + CELL_MARGIN_L, prdb.questsTooltip.maxWidth + CELL_MARGIN_L
	local statusMinWidthQTo, statusMaxWidthQTo = prdb.questsTooltip.statusMinWidth + CELL_MARGIN_R, prdb.questsTooltip.statusMaxWidth + CELL_MARGIN_R
	local totalMinWidthQTo, totalMaxWidthQTo = minWidthQTo + statusMinWidthQTo + CELL_MARGIN_L + CELL_MARGIN_R, maxWidthQTo + statusMaxWidthQTo + CELL_MARGIN_L + CELL_MARGIN_R
	local collapseIconSizeQTo, questItemIconSizeQTo = prdb.questsTooltip.collapseButtonSize, prdb.questsTooltip.questItemIconSize
	local questsCellPaddingQTo, objectivesCellPaddingQTo
	if prdb.questsTooltip.showQuestItemIcon then
		questsCellPaddingQTo = prdb.questsTooltip.questsCellPadding + questItemIconSizeQTo
		objectivesCellPaddingQTo = prdb.questsTooltip.objectivesCellPadding + questItemIconSizeQTo
	else
		questsCellPaddingQTo = prdb.questsTooltip.questsCellPadding
		objectivesCellPaddingQTo = prdb.questsTooltip.objectivesCellPadding
	end
	local questsTooltip = self.displayFrames.questsTooltip
	local displayFrame = questsTooltip.scrollChild
	local vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = 2*CELL_MARGIN_V, 0, 0, 0
	vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidthQTo, totalMaxWidthQTo, 0, prdb.questsTooltip.showCollapseButton, collapseIconSizeQTo, true, true, displayFrame, self.tooltipHeaderCell, self.tooltipHeaderButton, true)
	vSpaceUsed = vSpaceUsed + 20
	for _, category in ipairs(self.sortedCategories) do
		vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidthQTo, totalMaxWidthQTo, 0, prdb.questsTooltip.showCollapseButton, collapseIconSizeQTo, true, true, displayFrame, self.questCategoryCells.questsTooltip[category], self.categoryButtons.questsTooltip[category])
		local displayTime = GetTime()
		if chdb.categoryDisplay.questsTooltip[category] == 1 then
			for _, qid in ipairs(self.sortedQuestsByCategory[category]) do
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setQuestLayout(qid, QUESTS_TOOLTIP, questsCellPaddingQTo, objectivesCellPaddingQTo, questItemIconSizeQTo, minWidthQTo, maxWidthQTo, statusMinWidthQTo, statusMaxWidthQTo, totalMinWidthQTo, totalMaxWidthQTo, maxTextWidth, maxStatusWidth, maxTotalWidth, vSpaceUsed, displayTime, true)
			end
			maxTotalWidth = max(maxTotalWidth, maxTextWidth + maxStatusWidth)
		else
			for _, qid in ipairs(self.sortedQuestsByCategory[category]) do
				self.questTextCells.questsTooltip[qid]:Hide()
				self.questStatusCells.questsTooltip[qid]:Hide()
				if self.questsObjectives[qid] then
					for oid, qoData in ipairs(self.questsObjectives[qid]) do
						self.questsObjectiveTextCells.questsTooltip[qid][oid]:Hide()
						self.questsObjectiveStatusCells.questsTooltip[qid][oid]:Hide()
					end
				elseif self.quests[qid].objective then
					self.questsDescriptionCells.questsTooltip[qid]:Hide()
				end
			end
		end
	end
	vSpaceUsed = vSpaceUsed + 20
	if prdb.questsTooltip.showHints then
		for _, hintCell in pairs(self.hintCells) do
			vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidthQTo, totalMaxWidthQTo, 0, nil, nil, nil, true, displayFrame, hintCell, nil)
		end
	else
		for _, hintCell in pairs(self.hintCells) do
			hintCell:Hide()
		end
	end
	local headerWidth = self.tooltipHeaderCell.fs:GetStringWidth()
	self.tooltipHeaderCell.fs:SetWidth(headerWidth)
	local height = self.tooltipHeaderCell.fs:GetHeight()
	self.tooltipHeaderCell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", (maxTotalWidth - headerWidth)/2, -2*CELL_MARGIN_V)
	self.tooltipHeaderCell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPRIGHT", -(maxTotalWidth - headerWidth)/2, -2*CELL_MARGIN_V - height)
	questsTooltip:SetBackdrop(self.framesBackDrop.questsTooltip)
	questsTooltip:SetBackdropColor(prdb.questsTooltip.backDropColor[1], prdb.questsTooltip.backDropColor[2], prdb.questsTooltip.backDropColor[3], prdb.questsTooltip.backDropColor[4])
	questsTooltip:SetBackdropBorderColor(prdb.questsTooltip.borderColor[1], prdb.questsTooltip.borderColor[2], prdb.questsTooltip.borderColor[3], prdb.questsTooltip.borderColor[4])
	questsTooltip:SetScale(prdb.questsTooltip.scale)
	questsTooltip.height = vSpaceUsed
	questsTooltip.width = maxTotalWidth
	questsTooltip:SetHeight(vSpaceUsed)
	questsTooltip:SetWidth(maxTotalWidth)
	questsTooltip.scrollChild:SetHeight(vSpaceUsed)
	questsTooltip.scrollChild:SetWidth(maxTotalWidth)
	questsTooltip:EnableMouse(true)
end

function tomQuest2:setQuestsTrackerLayout()
	local displayFrame = self.displayFrames.questsTracker
	if prdb.questsTracker.toggleTracker and not hideQuestsTracker then
		local minWidthQTr, maxWidthQTr = prdb.questsTracker.minWidth + CELL_MARGIN_L, prdb.questsTracker.maxWidth + CELL_MARGIN_L
		local statusMinWidthQTr, statusMaxWidthQTr = prdb.questsTracker.statusMinWidth + CELL_MARGIN_R, prdb.questsTracker.statusMaxWidth + CELL_MARGIN_R
		local totalMinWidthQTr, totalMaxWidthQTr = minWidthQTr + statusMinWidthQTr + CELL_MARGIN_L + CELL_MARGIN_R, maxWidthQTr + statusMaxWidthQTr + CELL_MARGIN_L + CELL_MARGIN_R
		local collapseIconSizeQTr, questItemIconSizeQTr = prdb.questsTracker.collapseButtonSize, prdb.questsTracker.questItemIconSize
		local questsCellPaddingQTr, objectivesCellPaddingQTr
		if prdb.questsTracker.showByCategory then
			if prdb.questsTracker.showQuestItemIcon then
				questsCellPaddingQTr = prdb.questsTracker.questsCellPadding + questItemIconSizeQTr
				objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding + questItemIconSizeQTr
			else
				questsCellPaddingQTr = prdb.questsTracker.questsCellPadding
				objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding
			end
		else
			if prdb.questsTracker.showQuestItemIcon then
				questsCellPaddingQTr = prdb.questsTracker.questItemIconSize
				objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding - prdb.questsTracker.questsCellPadding + prdb.questsTracker.questItemIconSize
			else
				questsCellPaddingQTr = 0
				objectivesCellPaddingQTr = prdb.questsTracker.objectivesCellPadding - prdb.questsTracker.questsCellPadding
			end
		end
		local vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = 2*CELL_MARGIN_V, minWidthQTr, statusMinWidthQTr, totalMinWidthQTr
		if prdb.achievementsTracker.showInQuestTracker and next(self.achievementsCategories) then
			local columnMinWidthATr, columnMaxWidthATr = totalMinWidthQTr / prdb.achievementsTracker.numBooleanCriteriaColumns, totalMaxWidthQTr / prdb.achievementsTracker.numBooleanCriteriaColumns
			local categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr = prdb.achievementsTracker.categoryCollapseButtonSize, prdb.achievementsTracker.subCategoryCollapseButtonSize, prdb.achievementsTracker.achievementIconSize
			local criteriaCellPaddingATr, subCategoryCellPaddingATr = prdb.achievementsTracker.criteriaCellPadding, prdb.achievementsTracker.subCategoryCellPadding
			local achievementCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr
			if prdb.achievementsTracker.showByCategory then
				if prdb.achievementsTracker.showAchievementIcon then
					achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding
				else
					achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding
				end
				subAchievementCellPaddingATr = subCategoryCellPaddingATr + achievementCellPaddingATr
				subCriteriaCellPaddingATr = subCategoryCellPaddingATr + criteriaCellPaddingATr
			else
				if prdb.achievementsTracker.showAchievementIcon then
					achievementCellPaddingATr = achievementIconSizeATr
				else
					achievementCellPaddingATr = 0
				end
				subAchievementCellPaddingATr = achievementCellPaddingATr
				subCriteriaCellPaddingATr = criteriaCellPaddingATr
			end
			if prdb.achievementsTracker.positionInQuestTracker == 1 then
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setAchievementsCategoryLayout(QUESTS_TRACKER, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, columnMinWidthATr, columnMaxWidthATr, not prdb.achievementsTracker.disableInteraction, categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr, achievementCellPaddingATr, criteriaCellPaddingATr, subCategoryCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr)
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, not prdb.questsTracker.disableInteraction, collapseIconSizeQTr, questItemIconSizeQTr, questsCellPaddingQTr, objectivesCellPaddingQTr, GetTime())
			else
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, not prdb.questsTracker.disableInteraction, collapseIconSizeQTr, questItemIconSizeQTr, questsCellPaddingQTr, objectivesCellPaddingQTr, GetTime())
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setAchievementsCategoryLayout(QUESTS_TRACKER, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, columnMinWidthATr, columnMaxWidthATr, not prdb.achievementsTracker.disableInteraction, categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr, achievementCellPaddingATr, criteriaCellPaddingATr, subCategoryCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr)
			end
		else
			vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setQuestCategoryLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthQTr, maxWidthQTr, statusMinWidthQTr, statusMaxWidthQTr, totalMinWidthQTr, totalMaxWidthQTr, not prdb.questsTracker.disableInteraction, collapseIconSizeQTr, questItemIconSizeQTr, questsCellPaddingQTr, objectivesCellPaddingQTr, GetTime())
		end
		if vSpaceUsed == 2*CELL_MARGIN_V then return displayFrame:Hide() end
		displayFrame:SetBackdrop(self.framesBackDrop.questsTracker)
		displayFrame:SetBackdropColor(prdb.questsTracker.backDropColor[1], prdb.questsTracker.backDropColor[2], prdb.questsTracker.backDropColor[3], prdb.questsTracker.backDropColor[4])
		displayFrame:SetBackdropBorderColor(prdb.questsTracker.borderColor[1], prdb.questsTracker.borderColor[2], prdb.questsTracker.borderColor[3], prdb.questsTracker.borderColor[4])
		displayFrame:SetScale(prdb.questsTracker.scale)
		displayFrame:SetParent(UIParent)
		displayFrame:SetPoint(prdb.questsTracker.point, UIParent, prdb.questsTracker.relativePoint, prdb.questsTracker.xOffset, prdb.questsTracker.yOffset)
		if not prdb.questsTracker.disableInteraction then
			displayFrame.height = vSpaceUsed
			displayFrame.width = maxTotalWidth
			displayFrame:SetHeight(vSpaceUsed)
			displayFrame:SetWidth(maxTotalWidth)
			displayFrame.scrollChild:SetHeight(vSpaceUsed)
			displayFrame.scrollChild:SetWidth(maxTotalWidth)
			displayFrame:EnableMouse(true)
			displayFrame:SetMovable(not prdb.questsTracker.lockTracker)
			displayFrame:RegisterForDrag("LeftButton")
			displayFrame:SetScript("OnDragStart", startQuestsTrackerMoving)
			displayFrame:SetScript("OnDragStop", stopQuestsTrackerMoving)
			updateScrolling(displayFrame, prdb.questsTracker.hasMaxHeight and prdb.questsTracker.maxHeight or nil)
		else
			displayFrame:SetHeight(vSpaceUsed)
			displayFrame:SetWidth(maxTotalWidth)
			displayFrame:EnableMouse(false)
		end
		displayFrame:Show()
	else
		displayFrame:Hide()
	end
end

function tomQuest2:setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, achievementCellPadding, criteriaCellPadding)
	local displayFrame = self.displayFrames[self.ACHIEVEMENTS_TRACKER_FRAME].scrollChild
	vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, achievementCellPadding, prdb.achievementsTracker.showAchievementIcon, achievementIconSize, true, enableInteraction, displayFrame, self.achievementCells[aid], self.achievementIcons[aid])
	if self.achievements[aid].numCriteria == 0 then
		vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, self.achievementDescriptionCells[aid], nil)
	elseif self.achievements[aid].numCriteria == 1 then
		local achievementStatusBar = self.achievementStatusBars[aid]
		if achievementStatusBar then
			if prdb.achievementsTracker.displayAsStatusBar then
				vSpaceUsed, maxTotalWidth = setMonoCellLayout(vSpaceUsed, maxTotalWidth, totalMinWidth, totalMaxWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, self.achievementDescriptionCells[aid], nil)
				achievementStatusBar:EnableMouse(enableInteraction)
				achievementStatusBar:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", prdb.achievementsTracker.leftStatusBarPadding, -vSpaceUsed - 1)
				vSpaceUsed = vSpaceUsed + prdb.achievementsTracker.statusBarHeight + 2
				achievementStatusBar:SetPoint("BOTTOMRIGHT", displayFrame, "TOPRIGHT", -prdb.achievementsTracker.rightStatusBarPadding, -vSpaceUsed + 1)
				achievementStatusBar:Show()
				self.achievementCriterionTextCells[aid][1]:Hide()
				self.achievementCriterionStatusCells[aid][1]:Hide()
			else
				achievementStatusBar:Hide()
				self.achievementDescriptionCells[aid]:Hide()
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, self.achievementCriterionTextCells[aid][1], self.achievementCriterionStatusCells[aid][1], nil)
			end
		end
	else
		if self.achievementCriterionTextCells[aid] then
			for cid in pairs(self.achievementCriterionTextCells[aid]) do
				vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, criteriaCellPadding, nil, nil, nil, enableInteraction, displayFrame, self.achievementCriterionTextCells[aid][cid], self.achievementCriterionStatusCells[aid][cid], nil)
			end
		elseif self.achievementBooleanCriterionCells[aid] then
			local cIndex, numBooleanCriteriaColumns, maxCellWidth, rowHeight = 1, prdb.achievementsTracker.numBooleanCriteriaColumns, 0, 0
			for cid, cell in pairs(self.achievementBooleanCriterionCells[aid]) do
				if (prdb.achievementsTracker.hideCompletedCriteria and self.achievements[aid].criteria[cid].completed == 0) or (not prdb.achievementsTracker.hideCompletedCriteria) then
					local textWidth = min(max(cell.fs:GetStringWidth(), columnMinWidth - criteriaCellPadding - CELL_MARGIN_L), columnMaxWidth - criteriaCellPadding - CELL_MARGIN_L)
					maxCellWidth = max(maxCellWidth, textWidth)
				end
			end
			maxTotalWidth = max(maxTotalWidth, numBooleanCriteriaColumns*(maxCellWidth + CELL_MARGIN_L) + CELL_MARGIN_R)
			for cid, cell in pairs(self.achievementBooleanCriterionCells[aid]) do
				if (prdb.achievementsTracker.hideCompletedCriteria and self.achievements[aid].criteria[cid].completed == 0) or (not prdb.achievementsTracker.hideCompletedCriteria) then
					cell:EnableMouse(enableInteraction)
					cell.fs:SetWidth(maxCellWidth)
					rowHeight = max(rowHeight, cell.fs:GetHeight())
					cell:SetHeight(rowHeight)
					cell:SetPoint("TOPLEFT", displayFrame, "TOPLEFT", criteriaCellPadding + CELL_MARGIN_L + (cIndex-1) * (maxCellWidth + CELL_MARGIN_L), -vSpaceUsed)
					cell:SetPoint("BOTTOMRIGHT", displayFrame, "TOPLEFT", criteriaCellPadding + CELL_MARGIN_L + cIndex * maxCellWidth, -vSpaceUsed - rowHeight)
					cell:Show()
					if cIndex == numBooleanCriteriaColumns then
						vSpaceUsed = vSpaceUsed + rowHeight + LINE_SPACING_V
						cIndex, rowHeight = 1, 0
					else
						cIndex = cIndex + 1
					end
				end
			end
			cIndex = cIndex - 1
			if cIndex ~= 0 then
				vSpaceUsed = vSpaceUsed + rowHeight + LINE_SPACING_V
			end
		end
	end
	return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
end

function tomQuest2:hideAchievementCells(aid)
	self.achievementCells[aid]:Hide()
	self.achievementIcons[aid]:Hide()
	local achievementStatusBar = self.achievementStatusBars[aid]
	if achievementStatusBar then
		achievementStatusBar:Hide()
		self.achievementDescriptionCells[aid]:Hide()
	end
	if self.achievementCriterionTextCells[aid] then
		for cid, frame in pairs(self.achievementCriterionTextCells[aid]) do
			frame:Hide()
			self.achievementCriterionStatusCells[aid][cid]:Hide()
		end
	elseif self.achievementBooleanCriterionCells[aid] then
		for cid, frame in pairs(self.achievementBooleanCriterionCells[aid]) do
			frame:Hide()
		end
	end
end

function tomQuest2:setAchievementsCategoryLayout(frameUsed, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, categoryCollapseIconSize, subCategoryCollapseIconSize, achievementIconSize, achievementCellPadding, criteriaCellPadding, subCategoryCellPadding, subAchievementCellPadding, subCriteriaCellPadding)
	local displayFrame = self.displayFrames[frameUsed].scrollChild
	if not next(self.achievements) then
		return displayFrame:Hide()
	elseif prdb.achievementsTracker.showByCategory then
		for cid, cData in pairs(self.achievementsCategories) do
			vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, 0, prdb.achievementsTracker.showCollapseButton, categoryCollapseIconSize, true, enableInteraction, displayFrame, self.achievementCategoryTextCells[cid], self.achievementCategoryStatusCells[cid], self.categoryButtons.achievementsTracker[cid])
			if chdb.categoryDisplay.achievementsTracker[cid] == 1 or not enableInteraction then
				if next(cData.achievements) then
					for aid in pairs(cData.achievements) do
						vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, achievementCellPadding, criteriaCellPadding)
					end
				end
				if next(cData.subCategory) then
					for scid, scData in pairs(cData.subCategory) do
						vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = setDualCellsLayout(vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, subCategoryCellPadding, prdb.achievementsTracker.showCollapseButton, subCategoryCollapseIconSize, true, enableInteraction, displayFrame, self.achievementCategoryTextCells[scid], self.achievementCategoryStatusCells[scid], self.categoryButtons.achievementsTracker[scid])
						if chdb.categoryDisplay.achievementsTracker[scid] == 1 or not enableInteraction then
							if next(scData.achievements) then
								for aid in pairs(scData.achievements) do
									vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, columnMinWidth, columnMaxWidth, enableInteraction, achievementIconSize, subAchievementCellPadding, subCriteriaCellPadding)
								end
							end
						else
							if next(scData.achievements) then
								for aid in pairs(scData.achievements) do
									self:hideAchievementCells(aid)
								end
							end
						end
					end
				end
			else
				if next(cData.achievements) then
					for aid in pairs(cData.achievements) do
						self:hideAchievementCells(aid)
					end
				end
				if next(cData.subCategory) then
					for scid, scData in pairs(cData.subCategory) do
						self.achievementCategoryTextCells[scid]:Hide()
						self.achievementCategoryStatusCells[scid]:Hide()
						if next(scData.achievements) then
							for aid in pairs(scData.achievements) do
								self:hideAchievementCells(aid)
							end
						end
					end
				end
			end
		end
	else
		for aid, aData in pairs(self.achievements) do
			vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setAchievementsLayout(aid, vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidth, maxWidth, statusMinWidth, statusMaxWidth, totalMinWidth, totalMaxWidth, enableInteraction)
		end
	end
	return vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth
end

function tomQuest2:setAchievementsTrackerLayout()
	if not self.moduleState[ACHIEVEMENTS_TRACKER] then return end
	local displayFrame = self.displayFrames.achievementsTracker
	if prdb.achievementsTracker.showInQuestTracker then 
		displayFrame:Hide()
		return self:setQuestsTrackerLayout()
	elseif prdb.achievementsTracker.toggleTracker and next(self.achievements) and not hideAchievementsTracker then
		local minWidthATr, maxWidthATr = prdb.achievementsTracker.minWidth + CELL_MARGIN_L, prdb.achievementsTracker.maxWidth + CELL_MARGIN_L
		local statusMinWidthATr, statusMaxWidthATr = prdb.achievementsTracker.statusMinWidth + CELL_MARGIN_R, prdb.achievementsTracker.statusMaxWidth + CELL_MARGIN_R
		local totalMinWidthATr, totalMaxWidthATr = minWidthATr + statusMinWidthATr + CELL_MARGIN_L + CELL_MARGIN_R, maxWidthATr + statusMaxWidthATr + CELL_MARGIN_L + CELL_MARGIN_R
		local columnMinWidthATr, columnMaxWidthATr = totalMinWidthATr / prdb.achievementsTracker.numBooleanCriteriaColumns, totalMaxWidthATr / prdb.achievementsTracker.numBooleanCriteriaColumns
		local categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr = prdb.achievementsTracker.categoryCollapseButtonSize, prdb.achievementsTracker.subCategoryCollapseButtonSize, prdb.achievementsTracker.achievementIconSize
		local criteriaCellPaddingATr, subCategoryCellPaddingATr = prdb.achievementsTracker.criteriaCellPadding, prdb.achievementsTracker.subCategoryCellPadding
		local achievementCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr
		if prdb.achievementsTracker.showByCategory then
			if prdb.achievementsTracker.showAchievementIcon then
				achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding + achievementIconSizeATr
			else
				achievementCellPaddingATr = prdb.achievementsTracker.achievementCellPadding
			end
			subAchievementCellPaddingATr = subCategoryCellPaddingATr + achievementCellPaddingATr
			subCriteriaCellPaddingATr = subCategoryCellPaddingATr + criteriaCellPaddingATr
		else
			if prdb.achievementsTracker.showAchievementIcon then
				achievementCellPaddingATr = achievementIconSizeATr
			else
				achievementCellPaddingATr = 0
			end
			subAchievementCellPaddingATr = achievementCellPaddingATr
			subCriteriaCellPaddingATr = criteriaCellPaddingATr
		end
		local vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = 2*CELL_MARGIN_V, minWidthATr, statusMinWidthATr, totalMinWidthATr
		vSpaceUsed, maxTextWidth, maxStatusWidth, maxTotalWidth = self:setAchievementsCategoryLayout(self.ACHIEVEMENTS_TRACKER_FRAME, 2*CELL_MARGIN_V, maxTextWidth, maxStatusWidth, maxTotalWidth, minWidthATr, maxWidthATr, statusMinWidthATr, statusMaxWidthATr, totalMinWidthATr, totalMaxWidthATr, columnMinWidthATr, columnMaxWidthATr, not prdb.achievementsTracker.disableInteraction, categoryCollapseIconSizeATr, subCategoryCollapseIconSizeATr, achievementIconSizeATr, achievementCellPaddingATr, criteriaCellPaddingATr, subCategoryCellPaddingATr, subAchievementCellPaddingATr, subCriteriaCellPaddingATr)
		if vSpaceUsed == 2*CELL_MARGIN_V then return displayFrame:Hide() end
		displayFrame:SetBackdrop(self.framesBackDrop[self.ACHIEVEMENTS_TRACKER_FRAME])
		displayFrame:SetBackdropColor(prdb.achievementsTracker.backDropColor[1], prdb.achievementsTracker.backDropColor[2], prdb.achievementsTracker.backDropColor[3], prdb.achievementsTracker.backDropColor[4])
		displayFrame:SetBackdropBorderColor(prdb.achievementsTracker.borderColor[1], prdb.achievementsTracker.borderColor[2], prdb.achievementsTracker.borderColor[3], prdb.achievementsTracker.borderColor[4])
		displayFrame:SetScale(prdb.achievementsTracker.scale)
		displayFrame:SetParent(UIParent)
		displayFrame:SetPoint(prdb.achievementsTracker.point, UIParent, prdb.achievementsTracker.relativePoint, prdb.achievementsTracker.xOffset, prdb.achievementsTracker.yOffset)
		if not prdb.achievementsTracker.disableInteraction then
			displayFrame.height = vSpaceUsed
			displayFrame.width = maxTotalWidth
			displayFrame:SetHeight(vSpaceUsed)
			displayFrame:SetWidth(maxTotalWidth)
			displayFrame.scrollChild:SetHeight(vSpaceUsed)
			displayFrame.scrollChild:SetWidth(maxTotalWidth)
			displayFrame:EnableMouse(true)
			displayFrame:SetMovable(not prdb.achievementsTracker.lockTracker)
			displayFrame:RegisterForDrag("LeftButton")
			displayFrame:SetScript("OnDragStart", startAchievementsTrackerMoving)
			displayFrame:SetScript("OnDragStop", stopAchievementsTrackerMoving)
			updateScrolling(displayFrame, prdb.achievementsTracker.hasMaxHeight and prdb.achievementsTracker.maxHeight or nil)
		else
			displayFrame:SetHeight(vSpaceUsed)
			displayFrame:SetWidth(maxTotalWidth)
			displayFrame:EnableMouse(false)
		end
		displayFrame:Show()
	else
		displayFrame:Hide()
	end
end

local function skinChanged(self, SkinID, Gloss, Backdrop, Group, Button, Colors)
	prdb.skin.skin = SkinID
	prdb.skin.gloss = Gloss
	prdb.skin.backdrop = Backdrop
	prdb.skin.Colors = Colors
end

function tomQuest2:updateUsedMedia(event, mediatype, key)
	if mediatype == "font" then
		if key == prdb.questsTooltip.categoryFont then
			self.cQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.categoryFont), prdb.questsTooltip.categoryFontSize, prdb.questsTooltip.categoryFontOutline)
		end
		if key == prdb.questsTooltip.questFont then
			self.qQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questFont), prdb.questsTooltip.questFontSize, prdb.questsTooltip.questFontOutline)
		end
		if key == prdb.questsTooltip.questObjectiveFont then
			self.qoQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questObjectiveFont), prdb.questsTooltip.questObjectiveFontSize, prdb.questsTooltip.questObjectiveFontOutline)
		end
		if key == prdb.questsTracker.categoryFont then
			self.cQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.categoryFont), prdb.questsTracker.categoryFontSize, prdb.questsTracker.categoryFontOutline)
		end
		if key == prdb.questsTracker.questFont then
			self.qQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questFont), prdb.questsTracker.questFontSize, prdb.questsTracker.questFontOutline)
		end
		if key == prdb.questsTracker.questObjectiveFont then
			self.qoQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questObjectiveFont), prdb.questsTracker.questObjectiveFontSize, prdb.questsTracker.questObjectiveFontOutline)
		end
		if key == prdb.achievementsTracker.categoryFont then
			self.cATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.categoryFont), prdb.achievementsTracker.categoryFontSize, prdb.achievementsTracker.categoryFontOutline)
		end
		if key == prdb.achievementsTracker.subCategoryFont then
			self.scATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.subCategoryFont), prdb.achievementsTracker.subCategoryFontSize, prdb.achievementsTracker.subCategoryFontOutline)
		end
		if key == prdb.achievementsTracker.achievementFont then
			self.aATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementFont), prdb.achievementsTracker.achievementFontSize, prdb.achievementsTracker.profile.achievementFontOutline)
		end
		if key == prdb.achievementsTracker.achievementCriterionFont then
			self.acATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementCriterionFont), prdb.achievementsTracker.achievementCriterionFontSize, prdb.achievementsTracker.achievementCriterionFontOutline)
		end
		if key == prdb.achievementsTracker.statusBarFont then
			self.sbATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.statusBarFont), prdb.achievementsTracker.statusBarFontSize, prdb.achievementsTracker.statusBarFontOutline)
		end
	end
end

function tomQuest2:PLAYER_REGEN_ENABLED()
	hideQuestsTracker = nil
	hideAchievementsTracker = nil
	tomQuest2:setQuestsTrackerLayout()
	if not prdb.achievementsTracker.showInQuestTracker then
		tomQuest2:setAchievementsTrackerLayout()
	end
end

function tomQuest2:PLAYER_REGEN_DISABLED()
	if prdb.questsTracker.hideTrackerInCombat then
		hideQuestsTracker = true
		self.displayFrames.questsTracker:Hide()
	end
	if prdb.achievementsTracker.hideTrackerInCombat then
		hideAchievementsTracker = true
		self.displayFrames[self.ACHIEVEMENTS_TRACKER_FRAME]:Hide()
	end
end

local cSort = {
	nameD = function(a, b)
		return a > b
	end,
	nameA = function(a, b)
		return a < b
	end,
	levelD = function(a, b)
		local aMin, aMax = tomQuest2.questsCategories[a].sMinLevel, tomQuest2.questsCategories[a].sMaxLevel
		local bMin, bMax = tomQuest2.questsCategories[b].sMinLevel, tomQuest2.questsCategories[b].sMaxLevel
		if aMax == bMax then
			if aMin == bMin then
				return a > b
			else
				return aMin > bMin
			end
		else
			return aMax > bMax
		end
	end,
	levelA = function(a, b)
		local aMin, aMax = tomQuest2.questsCategories[a].sMinLevel, tomQuest2.questsCategories[a].sMaxLevel
		local bMin, bMax = tomQuest2.questsCategories[b].sMinLevel, tomQuest2.questsCategories[b].sMaxLevel
		if aMax == bMax then
			if aMin == bMin then
				return a < b
			else
				return aMin < bMin
			end
		else
			return aMax < bMax
		end
	end
}

function tomQuest2:categoriesSort()
	local tIndex = 0
	for category in pairs(self.questsCategories) do
		tIndex = tIndex + 1
		self.sortedCategories[tIndex] = category
	end
	for i = tIndex + 1, #(self.sortedCategories) do
		self.sortedCategories[i] = nil
	end
	sort(self.sortedCategories, cSort[prdb.categorySorting])
end

local qSort = {
	weightedA = function(a, b)
		local aWL, bWL = tomQuest2.quests[a].weightedLevel or 0, tomQuest2.quests[b].weightedLevel or 0
		if aWL == bWL then
			return tomQuest2.quests[a].title < tomQuest2.quests[b].title
		else
			return aWL < bWL
		end
	end,
	weightedD = function(a, b)
		local aWL, bWL = tomQuest2.quests[a].weightedLevel or 0, tomQuest2.quests[b].weightedLevel or 0
		if aWL == bWL then
			return tomQuest2.quests[a].title > tomQuest2.quests[b].title
		else
			return aWL > bWL
		end
	end,
	levelA = function(a, b)
		local aL, bL = tomQuest2.quests[a].level, tomQuest2.quests[b].level
		if aL == bL then
			return tomQuest2.quests[a].title < tomQuest2.quests[b].title
		else
			return aL < bL
		end
	end,
	levelD = function(a, b)
		local aL, bL = tomQuest2.quests[a].level, tomQuest2.quests[b].level
		if aL == bL then
			return tomQuest2.quests[a].title > tomQuest2.quests[b].title
		else
			return aL > bL
		end
	end,
	nameA = function(a, b)
		return tomQuest2.quests[a].title > tomQuest2.quests[b].title
	end,
	nameD = function(a, b)
		return tomQuest2.quests[a].title < tomQuest2.quests[b].title
	end,
}

function tomQuest2:questsSort()
	local tIndex1 = 0
	for category in pairs(self.questsCategories) do
		local tIndex2 = 0
		if not self.sortedQuestsByCategory[category] then
			self.sortedQuestsByCategory[category] = {}
		end
		for qid in pairs(self.questsByCategory[category]) do
			tIndex1 = tIndex1 + 1
			tIndex2 = tIndex2 + 1
			self.sortedQuestsByCategory[category][tIndex2] = qid
			self.sortedQuests[tIndex1] = qid
		end
		for i = tIndex2 + 1, #(self.sortedQuestsByCategory[category]) do
			self.sortedQuestsByCategory[category][i] = nil
		end
		sort(self.sortedQuestsByCategory[category], qSort[prdb.questsSorting])
	end
	for category in pairs(self.sortedQuestsByCategory) do
		if not self.questsCategories[category] then
			self.sortedQuestsByCategory[category] = nil
		end
	end
	for i = tIndex1 + 1, #(self.sortedQuests) do
		self.sortedQuests[i] = nil
	end
	sort(self.sortedQuests, qSort[prdb.questsSorting])
end

local interactivity = {
	chatLink = function(id, link)
		ChatFrameEditBox:Show()
		ChatEdit_InsertLink(link)
	end,
	tooltip = function(id, link)
		ItemRefTooltip:ClearLines()
		ShowUIPanel(ItemRefTooltip)
		if not ItemRefTooltip:IsVisible() then
			ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
		end
		ItemRefTooltip:SetHyperlink(link)
	end,
	objectiveProgress = function(qid, link)
		if tomQuest2.questsObjectives[qid] and tomQuest2.quests[qid].playerStatus then
			ChatFrameEditBox:Show()
			for _, qoData in pairs(tomQuest2.questsObjectives[qid]) do
				ChatFrameEditBox:Insert(format("{%s : %s/%s}", qoData.desc, qoData.playerGot, qoData.need))
			end
		end
	end,
	macroUpdate = function(qid, link)
		if not link:find("item") then
			link = tomQuest2.quests[qid].specialItemLink
		end
		if link and not InCombatLockdown() then
			local _, _, itemString = find(link, "^|c%x+|H(.+)|h%[.*%]")
			local index = GetMacroIndexByName("tomQuest2_SI")
			if index == 0 then
				index = CreateMacro("tomQuest2_SI", 1, format("#showtooltip\n/use %s", itemString), 0)
				PickupMacro(index)
			else
				EditMacro(index, "tomQuest2_SI", 1, format("#showtooltip\n/use %s", itemString))
			end
		end
	end,
	shareQuest = function(qid, link)
		if tomQuest2.numPartyMembers > 0 and tomQuest2.quests[qid].id and tomQuest2.quests[qid].sharable then
			local wasSelected = GetQuestLogSelection()
			SelectQuestLogEntry(tomQuest2.quests[qid].id)
			QuestLogPushQuest()
			SelectQuestLogEntry(wasSelected)
		end
	end,
	trackQuest = function(qid, link)
		if chdb.questsTracked[qid] then
			RemoveQuestWatch(tomQuest2.quests[qid].id, qid)
		elseif not chdb.questsTracked[qid] then
			AddQuestWatch(tomQuest2.quests[qid].id, nil, qid)
		end
	end,
	abandonQuest = function(qid, link)
		if tomQuest2.quests[qid].id then
			local wasSelected = GetQuestLogSelection()
			SelectQuestLogEntry(tomQuest2.quests[qid].id)
			SetAbandonQuest()
			local abandonItems = GetAbandonQuestItems()
			if abandonItems then
				StaticPopup_Hide("ABANDON_QUEST")
				StaticPopup_Show("ABANDON_QUEST_WITH_ITEMS", GetAbandonQuestName(), abandonItems)
			else
				StaticPopup_Hide("ABANDON_QUEST_WITH_ITEMS")
				StaticPopup_Show("ABANDON_QUEST", GetAbandonQuestName())
			end
			SelectQuestLogEntry(wasSelected)
		end
	end,
	displayQuest = function(qid, link)
		tomQuest2:displayQuestInformations(qid)
	end,
	displayQuestInfo = function(qid, link)
		WorldMap_OpenToQuest(qid)
	end,
	removeTrackedAchievement = function(aid, link)
		RemoveTrackedAchievement(aid)
	end,
	displayAchievement = function(aid, link)
		ToggleAchievementFrame()
		if AchievementFrame:IsShown() then
			AchievementFrame_SelectAchievement(aid)
		end
	end,
	nothing = function()
		return
	end
}

local function categoryOnMouseDown(self, button)
	if self.cellType == "header" then
		if chdb.categoryDisplay.questsTooltip.collapseAll == 0 then
			for zone in pairs(chdb.categoryDisplay.questsTooltip) do
				chdb.categoryDisplay.questsTooltip[zone] = 1
			end
			tomQuest2.tooltipHeaderButton.iconTexture:SetTexture(collapseTexture)
		else
			for zone in pairs(chdb.categoryDisplay.questsTooltip) do
				chdb.categoryDisplay.questsTooltip[zone] = 0
			end
			tomQuest2.tooltipHeaderButton.iconTexture:SetTexture(expandTexture)
		end
		tomQuest2:setQuestsTooltipLayout()
		updateScrolling(tomQuest2.displayFrames.questsTooltip, prdb.questsTooltip.hasMaxHeight and prdb.questsTooltip.maxHeight or nil)
	else
		if chdb.categoryDisplay[self.cellType][self.id] == 1 then
			chdb.categoryDisplay[self.cellType][self.id] = 0
			chdb.categoryDisplay[self.cellType].collapseAll = 0
			tomQuest2.categoryButtons[self.cellType][self.id].iconTexture:SetTexture(expandTexture)
		else
			chdb.categoryDisplay[self.cellType][self.id] = 1
			chdb.categoryDisplay[self.cellType].collapseAll = 1
			tomQuest2.categoryButtons[self.cellType][self.id].iconTexture:SetTexture(collapseTexture)
		end
		if self.cellType == QUESTS_TOOLTIP then
			tomQuest2:setQuestsTooltipLayout()
			updateScrolling(tomQuest2.displayFrames.questsTooltip, prdb.questsTooltip.hasMaxHeight and prdb.questsTooltip.maxHeight or nil)
		elseif self.cellType == QUESTS_TRACKER or prdb.achievementsTracker.showInQuestTracker then
			tomQuest2:setQuestsTrackerLayout()
		else
			tomQuest2:setAchievementsTrackerLayout()
		end
	end
end

local function cellOnMouseDown(self, button)
	if button == "RightButton" then
		if IsShiftKeyDown() then
			interactivity[prdb[self.cellType].mouseRightShift](self.id, self.link)
		elseif IsControlKeyDown() then
			interactivity[prdb[self.cellType].mouseRightControl](self.id, self.link)
		elseif IsAltKeyDown() then
			interactivity[prdb[self.cellType].mouseRightAlt](self.id, self.link)
		else
			interactivity[prdb[self.cellType].mouseRight](self.id, self.link)
		end
	elseif button == "LeftButton" then
		if IsShiftKeyDown() then
			interactivity[prdb[self.cellType].mouseLeftShift](self.id, self.link)
		elseif IsControlKeyDown() then
			interactivity[prdb[self.cellType].mouseLeftControl](self.id, self.link)
		elseif IsAltKeyDown() then
			interactivity[prdb[self.cellType].mouseLeftAlt](self.id, self.link)
		else
			interactivity[prdb[self.cellType].mouseLeft](self.id, self.link)
		end
	elseif button == "MiddleButton" then
		if IsShiftKeyDown() then
			interactivity[prdb[self.cellType].mouseMiddleShift](self.id, self.link)
		elseif IsControlKeyDown() then
			interactivity[prdb[self.cellType].mouseMiddleControl](self.id, self.link)
		elseif IsAltKeyDown() then
			interactivity[prdb[self.cellType].mouseMiddleAlt](self.id, self.link)
		else
			interactivity[prdb[self.cellType].mouseMiddle](self.id, self.link)
		end
	end
end

local function wrongButtonOnClick()
	tomQuest2:Print(LC["This button is not clickable, you can use tomQuest2 macro system instead"])
end

local function cellOnEnter(self)
	if self.cellType == "item" or (self.cellType == "icon" and prdb.achievementsTracker.overTooltip) or prdb[self.cellType].overTooltip then
		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		GameTooltip:SetHyperlink(self.link)
	end
end

local function itemOnEvent(self, event)
	if event == "BAG_UPDATE_COOLDOWN" then
		local start, duration, enable = GetItemCooldown(self.link)
		if start > 0 and duration > 0 and enable > 0 then
			self.coolDown:SetCooldown(start, duration)
			self.coolDown:Show()
		else
			self.coolDown:Hide()
		end
	elseif event == "PLAYER_TARGET_CHANGED" then
		self.rangeTimer = -1
	end
end

local function updateItemRange(self, elapsed)
	self.rangeTimer = self.rangeTimer - elapsed
	if self.rangeTimer <= 0 then
		if IsQuestLogSpecialItemInRange(self:GetID()) == 0 then
			self.iconTexture:SetVertexColor(0.8, 0.1, 0.1)
		else
			self.iconTexture:SetVertexColor(1.0, 1.0, 1.0)
		end
		self.rangeTimer = TOOLTIP_UPDATE_TIME
	end
end

function tomQuest2:getItemButton(parentFrame, id, itemLink, texture, hasRange, cellType, size)
	local button = tremove(self.itemButtonCache)
	if not button then
		self.numItemButtons = self.numItemButtons + 1
		local buttonName = "tomQuest2ItemButton"..self.numItemButtons
		button = CreateFrame("Button", buttonName, parentFrame, "WatchFrameItemButtonTemplate")
		button.iconTexture = _G[buttonName.."IconTexture"]
		button.coolDown = _G[buttonName.."Cooldown"]
		button.count = _G[buttonName.."Count"]
		button.height = button:GetHeight()
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:SetHighlightTexture("")
		_G[buttonName.."HotKey"]:Hide()
		if self.LBFGroup then
			self.LBFGroup:AddButton(button)
		end
		button:SetScript("OnLoad", nil)
		button:SetScript("OnEvent", itemOnEvent)
		button:RegisterEvent("BAG_UPDATE_COOLDOWN")
	else
		button:SetParent(parentFrame)
	end
	button.iconTexture:SetVertexColor(1.0, 1.0, 1.0)
	button:SetID(id)
	button.iconTexture:SetTexture(texture)
	local itemCount = GetItemCount(itemLink)
	if itemCount > 1 then
		button.count:SetText(itemCount)
		button.count:Show()
	else
		button.count:Hide()
	end
	if hasRange then
		button.rangeTimer = -1
		button:SetScript("OnUpdate", updateItemRange)
		button:RegisterEvent("PLAYER_TARGET_CHANGED")
	end
	local start, duration, enable = GetItemCooldown(itemLink)
	if start > 0 and duration > 0 and enable > 0 then
		button.coolDown:SetCooldown(start, duration)
		button.coolDown:Show()
	else
		button.coolDown:Hide()
	end
	button.cellType = cellType
	button:SetScale(size/button.height)
	button:SetFrameLevel(parentFrame:GetFrameLevel()+1)
	button:SetScale(size/button.height)
	button:SetPoint("TOPRIGHT", parentFrame, "TOPLEFT")
	return button
end

function tomQuest2:recycleItemButton(button)
	if not button then return end
	button:SetParent(UIParent)
	button:ClearAllPoints()
	button:Hide()
	button:SetScript("OnUpdate", nil)
	button:UnregisterEvent("PLAYER_TARGET_CHANGED")
	self.itemButtonCache[#(self.itemButtonCache)+1] = button
end

function tomQuest2:getButton(parentFrame, texture, size, buttonType, value1)
	local button = tremove(self.buttonCache)
	if not button then
		self.numButtons = self.numButtons + 1
		local buttonName = "tomQuest2Button"..self.numButtons
		button = CreateFrame("Button", buttonName, parentFrame, "ItemButtonTemplate")
		button.iconTexture = _G[buttonName.."IconTexture"]
		button.count = _G[buttonName.."Count"]
		button.height = button:GetHeight()
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:SetHighlightTexture("")
	else
		button:SetParent(parentFrame)
	end
	button.cellType = buttonType
	if buttonType == "item" then
		button.link = value1
		local itemCount = GetItemCount(value1)
		if itemCount > 1 then
			button.count:SetText(itemCount)
			button.count:Show()
		else
			button.count:Hide()
		end
		button:SetScript("OnEnter", cellOnEnter)
		button:SetScript("OnLeave", onLeave)
		button:SetScript("OnClick", wrongButtonOnClick)
		if self.LBFGroup then
			self.LBFGroup:AddButton(button)
		end
	elseif buttonType == "icon" then
		button.link = value1
		button:SetScript("OnEnter", cellOnEnter)
		button:SetScript("OnLeave", onLeave)
		if self.LBFGroup then
			self.LBFGroup:AddButton(button)
		end
	else
		button.id = value1
		button:SetScript("OnClick", categoryOnMouseDown)
	end
	button.iconTexture:SetTexture(texture)
	button:SetFrameLevel(parentFrame:GetFrameLevel()+1)
	button:SetScale(size/button.height)
	button:SetPoint("TOPRIGHT", parentFrame, "TOPLEFT")
	return button
end

function tomQuest2:recycleButton(button)
	if not button then return end
	button:SetParent(UIParent)
	button:ClearAllPoints()
	button:Hide()
	if self.LBFGroup then
		self.LBFGroup:RemoveButton(button)
	end
	button:SetScript("OnEnter", nil)
	button:SetScript("OnLeave", nil)
	button:SetScript("OnClick", nil)
	button.link, button.category = nil, nil
	self.buttonCache[#(self.buttonCache)+1] = button
end

function tomQuest2:getStatusBar(cellType, parentFrame, id, reqQuantity)
	local statusBar = tremove(self.statusBarCache)
	if not statusBar then
		self.numStatusBar = self.numStatusBar + 1
		local statusBarName = "tomQuest2StatusBar"..self.numStatusBar
		statusBar = CreateFrame("StatusBar", statusBarName, self.displayFrames[parentFrame].scrollChild)
		statusBar.status = statusBar:CreateFontString(statusBarName.."Status", "OVERLAY")
		statusBar.status:SetJustifyH("CENTER")
		statusBar.status:SetPoint("CENTER")
		statusBar.bg = statusBar:CreateTexture(nil, "BORDER")
		statusBar.bg:SetAllPoints(statusBar)
		statusBar:SetBackdrop(self.statusBarBackDrop)
		statusBar:SetBackdropColor(0, 0, 0)
	else
		statusBar:SetParent(self.displayFrames[parentFrame].scrollChild)
	end
	statusBar.cellType = cellType
	statusBar.id = id
	statusBar.link = GetAchievementLink(id)
	statusBar:SetScript("OnEnter", cellOnEnter)
	statusBar:SetScript("OnLeave", onLeave)
	statusBar.status:SetFontObject(self.sbATrFontTQ2)
	statusBar:SetMinMaxValues(0, reqQuantity)
	statusBar:SetFrameLevel(self.displayFrames[parentFrame].scrollChild:GetFrameLevel()+1)
	return statusBar
end

function tomQuest2:recycleStatusBar(statusBar)
	if not statusBar then return end
	statusBar:SetParent(UIParent)
	statusBar:ClearAllPoints()
	statusBar:Hide()
	self.statusBarCache[#(self.statusBarCache)+1] = statusBar
end

function tomQuest2:updateStatusbar(aid, cType, quantity, reqQuantity, color)
	local statusBar = self.achievementStatusBars[aid]
	statusBar:SetValue(quantity)
	statusBar:SetStatusBarTexture(LSM:Fetch("statusbar", prdb.achievementsTracker.statusBarTexture))
	statusBar.bg:SetTexture(LSM:Fetch("statusbar", prdb.achievementsTracker.statusBarTexture))
	local r, g, b
	if prdb.achievementsTracker.colorizeStatusBar then
		r, g, b = self:getColorFromCompletionRGB(quantity / reqQuantity)
	else
		r, g, b = unpack(prdb.achievementsTracker.defaultStatusBarColor)
	end
	statusBar.bg:SetVertexColor(r*0.33, g*0.33, b*0.33)
	statusBar:SetStatusBarColor(r, g, b)
	if cType == 62 or cType == 67 then
		statusBar.status:SetText(self:formatMoney(quantity))
	elseif prdb.achievementsTracker.colorizeStatusBarText then
		statusBar.status:SetFormattedText("|cff%s%s / %s|r", color, quantity, reqQuantity)
	else
		statusBar.status:SetFormattedText("|cff%s%s / %s|r", prdb.achievementsTracker.defaultStatusBarTextColor, quantity, reqQuantity)
	end
end

function tomQuest2:getContentCell(font, justification, cellType, parentFrame, id, content, category)
	local contentCell = tremove(self.contentCellCache)
	if not contentCell then
		self.numContentCells = self.numContentCells + 1
		local contentCellName = "tomQuest2ContentCell"..self.numContentCells
		contentCell = CreateFrame("frame", contentCellName, UIParent)
		contentCell.fs = contentCell:CreateFontString()
		contentCell.fs:SetFontObject(font)
		contentCell.fs:SetJustifyH(justification)
		contentCell.fs:SetAllPoints(contentCell)
	else
		contentCell.fs:SetFontObject(font)
		contentCell.fs:SetJustifyH(justification)
	end
	if content then
		contentCell.link = cellType == ACHIEVEMENTS_TRACKER and GetAchievementLink(id) or "quest:"..id
		contentCell:SetScript("OnEnter", cellOnEnter)
		contentCell:SetScript("OnLeave", onLeave)
		contentCell:SetScript("OnMouseDown", cellOnMouseDown)
	elseif category then
		contentCell:SetScript("OnMouseDown", categoryOnMouseDown)
	end
	contentCell:SetParent(self.displayFrames[parentFrame].scrollChild)
	contentCell:SetFrameLevel(self.displayFrames[parentFrame].scrollChild:GetFrameLevel()+1)
	contentCell.cellType = cellType
	contentCell.id = id
	return contentCell
end

function tomQuest2:recycleContentCell(contentCell)
	if not contentCell then return end
	contentCell:SetParent(UIParent)
	contentCell:ClearAllPoints()
	contentCell:SetScript("OnEnter", nil)
	contentCell:SetScript("OnLeave", nil)
	contentCell:SetScript("OnMouseDown", nil)
	contentCell:SetScript("OnUpdate", nil)
	contentCell:Hide()
	contentCell.id = nil
	self.contentCellCache[#(self.contentCellCache)+1] = contentCell
end

function tomQuest2:updateQuestCategoryCell(category, cellType)
	self.questCategoryCells[cellType][category].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r", prdb[cellType].colorizeCategoryName and self.questsCategories[category].color or prdb[cellType].defaultCategoryNameColor, category, prdb[cellType].colorizeCategoryLevel and self.questsCategories[category].color or prdb[cellType].defaultCategoryLevelColor, prdb[cellType].hideZoneLevelRange and "" or self.questsCategories[category].level)
end

function tomQuest2:createQuestCategoryCell(category, cellType, font)
	if not chdb.categoryDisplay[cellType][category] then
		chdb.categoryDisplay[cellType][category] = 1
	end
	self.questCategoryCells[cellType][category] = self:getContentCell(font, "LEFT", cellType, cellType, category, nil, true)
	self.categoryButtons[cellType][category] = self:getButton(self.questCategoryCells[cellType][category], chdb.categoryDisplay[cellType][category] == 0 and expandTexture or collapseTexture, prdb[cellType].collapseButtonSize, cellType, category)
	self:updateQuestCategoryCell(category, cellType)
end

function tomQuest2:removeQuestCategoryCells(category)
	self:recycleContentCell(self.questCategoryCells.questsTooltip[category])
	self:recycleContentCell(self.questCategoryCells.questsTracker[category])
	self:recycleButton(self.categoryButtons.questsTooltip[category])
	self:recycleButton(self.categoryButtons.questsTracker[category])
	self.questCategoryCells.questsTooltip[category], self.questCategoryCells.questsTracker[category] = nil, nil
	self.categoryButtons.questsTooltip[category], self.categoryButtons.questsTracker[category] = nil, nil
end

local function timedQuestUpdate(self, elapsed)
	self.duration = self.duration + elapsed
	if self.duration >= 1 then
		local qid, cellType = self.qid, self.cellType
		if tomQuest2.quests[qid] and tomQuest2.quests[qid].remainingTime then
			tomQuest2.quests[qid].remainingTime = tomQuest2.quests[qid].remainingTime - self.duration
			if tomQuest2.quests[qid].remainingTime > 0 then
				self.fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s |cff%s%s|r", prdb[cellType].colorizeQuestLevel and tomQuest2.quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or tomQuest2.quests[qid].tag, prdb[cellType].colorizeQuestName and tomQuest2.quests[qid].color or prdb[cellType].defaultQuestNameColor, tomQuest2.quests[qid].title, self.quests[qid].playersOnQuest > 1 and "<"..tomQuest2.quests[qid].playersOnQuest..">" or "", prdb[cellType].colorizeQuestTimer and tomQuest2:getColorFromCompletionHEX(tomQuest2.quests[qid].remainingTime / tomQuest2.quests[qid].initialTimer) or prdb[cellType].defaultQuestTimerColor, formatTime(tomQuest2.quests[qid].remainingTime))
				self.duration = 0
			else
				self.fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s", prdb[cellType].colorizeQuestLevel and tomQuest2.quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or tomQuest2.quests[qid].tag, prdb[cellType].colorizeQuestName and tomQuest2.quests[qid].color or prdb[cellType].defaultQuestNameColor, tomQuest2.quests[qid].title, self.quests[qid].playersOnQuest > 1 and "<"..tomQuest2.quests[qid].playersOnQuest..">" or "")
				self:SetScript("OnUpdate", nil)
				tomQuest2.quests[qid].initialTimer, tomQuest2.quests[qid].remainingTime = nil, nil
			end
		else
			self:SetScript("OnUpdate", nil)
			tomQuest2.quests[qid].initialTimer, tomQuest2.quests[qid].remainingTime = nil, nil
		end
	end
end

function tomQuest2:updateQuestTextCell(qid, cellType)
	if self.quests[qid].initialTimer then
		self.quests[qid].remainingTime = self.quests[qid].initialTimer + self.quests[qid].startTime - GetTime()
		self.questTextCells[cellType][qid].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s |cff%s%s|r", prdb[cellType].colorizeQuestLevel and self.quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or self.quests[qid].tag, prdb[cellType].colorizeQuestName and self.quests[qid].color or prdb[cellType].defaultQuestNameColor, self.quests[qid].title, self.quests[qid].playersOnQuest > 1 and "<"..self.quests[qid].playersOnQuest..">" or "", prdb[cellType].colorizeQuestTimer and self:getColorFromCompletionHEX(self.quests[qid].remainingTime / self.quests[qid].initialTimer) or prdb[cellType].defaultQuestTimerColor, formatTime(self.quests[qid].remainingTime))
		self.questTextCells[cellType][qid]:SetScript("OnUpdate", timedQuestUpdate)
	else
		self.questTextCells[cellType][qid].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r %s", prdb[cellType].colorizeQuestLevel and self.quests[qid].color or prdb[cellType].defaultQuestLevelColor, prdb[cellType].hideQuestTag and "" or self.quests[qid].tag, prdb[cellType].colorizeQuestName and self.quests[qid].color or prdb[cellType].defaultQuestNameColor, self.quests[qid].title, self.quests[qid].playersOnQuest > 1 and "<"..self.quests[qid].playersOnQuest..">" or "")
	end
end

function tomQuest2:updateQuestCells(qid)
	local questStatus
	if self.quests[qid].complete and next(self.quests[qid].complete) then
		local tIndex, partyStatus = 0, 1
		for partyName, completed in pairs(self.quests[qid].complete) do
			if completed == 1 then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = format("|cff%s%s|r: |cff%s%s|r", self.party[partyName].color, self.party[partyName].subName, prdb.completedColor, LC["Finished"])
			else
				partyStatus = 0
				if completed == -1 then
					tIndex = tIndex + 1
					self.tempTable[tIndex] = format("|cff%s%s|r: |cff%s%s|r", self.party[partyName].color, self.party[partyName].subName, prdb.failedColor, LC["Failed"])
				end
			end
		end
		if self.quests[qid].playerStatus then
			if self.quests[qid].playerStatus == 1 then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = format("|cff%s%s|r", prdb.completedColor, LC["Finished"])
			else
				partyStatus = 0
				if self.quests[qid].playerStatus == -1 then
					tIndex = tIndex + 1
					self.tempTable[tIndex] = format("|cff%s%s|r", prdb.failedColor, LC["Failed"])
				end
			end
		end
		self.quests[qid].partyStatus = partyStatus
		questStatus = tconcat(self.tempTable, ", ", 1, tIndex)
	else
		if self.quests[qid].playerStatus == 1 then
			self.quests[qid].partyStatus = 1
			questStatus = format("|cff%s%s|r", prdb.completedColor, LC["Finished"])
		elseif self.quests[qid].playerStatus == -1 then
			self.quests[qid].partyStatus = 0
			questStatus = format("|cff%s%s|r", prdb.failedColor, LC["Failed"])
		else
			self.quests[qid].partyStatus = 0
			questStatus = ""
		end
	end
	self:updateQuestTextCell(qid, QUESTS_TOOLTIP)
	self:updateQuestTextCell(qid, QUESTS_TRACKER)
	self.questStatusCells.questsTooltip[qid].fs:SetText(questStatus)
	self.questStatusCells.questsTracker[qid].fs:SetText(questStatus)
end

function tomQuest2:removeQuestCells(qid)
	if self.questsObjectives[qid] then
		for _, frame in pairs(self.questsObjectiveTextCells.questsTooltip[qid]) do
			self:recycleContentCell(frame)
		end
		for _, frame in pairs(self.questsObjectiveTextCells.questsTracker[qid]) do
			self:recycleContentCell(frame)
		end
		for _, frame in pairs(self.questsObjectiveStatusCells.questsTooltip[qid]) do
			self:recycleContentCell(frame)
		end
		for _, frame in pairs(self.questsObjectiveStatusCells.questsTracker[qid]) do
			self:recycleContentCell(frame)
		end
		self.questsObjectiveTextCells.questsTooltip[qid], self.questsObjectiveTextCells.questsTracker[qid] = nil, nil
		self.questsObjectiveStatusCells.questsTooltip[qid], self.questsObjectiveStatusCells.questsTracker[qid] = nil, nil
	else
		self:recycleContentCell(self.questsDescriptionCells.questsTooltip[qid])
		self:recycleContentCell(self.questsDescriptionCells.questsTracker[qid])
		self.questsDescriptionCells.questsTooltip[qid], self.questsDescriptionCells.questsTracker[qid] = nil, nil
	end
	self:recycleContentCell(self.questTextCells.questsTooltip[qid])
	self:recycleContentCell(self.questTextCells.questsTracker[qid])
	self.questTextCells.questsTooltip[qid], self.questTextCells.questsTracker[qid] = nil, nil
	self:recycleContentCell(self.questStatusCells.questsTooltip[qid])
	self:recycleContentCell(self.questStatusCells.questsTracker[qid])
	self.questStatusCells.questsTooltip[qid], self.questStatusCells.questsTracker[qid] = nil, nil
	if self.specialItemButtons.questsTooltip[qid] then
		self:recycleContentCell(self.specialItemButtons.questsTooltip[qid])
		self:recycleContentCell(self.specialItemButtons.questsTracker[qid])
		self.specialItemButtons.questsTooltip[qid], self.specialItemButtons.questsTracker[qid] = nil, nil
	elseif self.fakeItemButtons.questsTooltip[qid] then
		self:recycleContentCell(self.fakeItemButtons.questsTooltip[qid])
		self:recycleContentCell(self.fakeItemButtons.questsTracker[qid])
		self.fakeItemButtons.questsTooltip[qid], self.fakeItemButtons.questsTracker[qid] = nil, nil
	end
end

function tomQuest2:updateQuestObjectiveStatus(qid, oid)
	local qoStatus, qoColor
	local nNeed = self.questsObjectives[qid][oid].nNeed
	if self.questsObjectives[qid][oid].got and next(self.questsObjectives[qid][oid].got) then
		local tIndex, totalGot, playerStatus, partyStatus = 0, 0, 0, 1
		local totalNeed = nNeed * self.quests[qid].playersOnQuest
		for partyName, qoData in pairs(self.questsObjectives[qid][oid].got) do
			local nGot = self.questsObjectives[qid][oid].nGot[partyName]
			totalGot = totalGot + nGot
			tIndex = tIndex + 1
			if nGot == nNeed then
				self.tempTable[tIndex] = format("|cff%s%s|r : |cff%%1$s%s|r", self.party[partyName].color, self.party[partyName].subName, LC["d"])
			else
				partyStatus = 0
				self.tempTable[tIndex] = format("|cff%s%s|r : |cff%%1$s%s|r", self.party[partyName].color, self.party[partyName].subName, qoData)
			end
		end
		local nGot = self.questsObjectives[qid][oid].nPlayerGot
		if nGot then
			totalGot = totalGot + nGot
			tIndex = tIndex + 1
			if nGot == nNeed then
				playerStatus = 1
				self.tempTable[tIndex] = format("|cff%%1$s%s|r", LC["d"])
			else
				partyStatus = 0
				self.tempTable[tIndex] = format("|cff%%1$s%s|r", self.questsObjectives[qid][oid].playerGot)
			end
		end
		self.questsObjectives[qid][oid].playerStatus, self.questsObjectives[qid][oid].partyStatus = playerStatus, partyStatus
		qoColor = self:getColorFromCompletionHEX(totalGot/totalNeed)
		qoStatus = format("%s/|cff%s%s", tconcat(self.tempTable, ", ", 1, tIndex), qoColor, self.questsObjectives[qid][oid].need)
	else
		local nGot = self.questsObjectives[qid][oid].nPlayerGot
		if nGot == nNeed then
			self.questsObjectives[qid][oid].playerStatus, self.questsObjectives[qid][oid].partyStatus = 1, 1
			qoColor = self:getColorFromCompletionHEX(1)
			qoStatus = format("|cff%%1$s%s|r/|cff%%1$s%s", LC["d"], self.questsObjectives[qid][oid].need)
		else
			self.questsObjectives[qid][oid].playerStatus, self.questsObjectives[qid][oid].partyStatus = 0, 0
			qoColor = self:getColorFromCompletionHEX(nGot/nNeed)
			qoStatus = format("|cff%%1$s%s|r/|cff%%1$s%s", self.questsObjectives[qid][oid].playerGot, self.questsObjectives[qid][oid].need)
		end
	end
	return qoStatus, qoColor
end

function tomQuest2:updateQuestObjectiveCells(qid, oid)
	local qoStatus, qoColor = self:updateQuestObjectiveStatus(qid, oid)
	self.questsObjectiveTextCells.questsTooltip[qid][oid].fs:SetFormattedText("|cff%s%s|r", prdb.questsTooltip.colorizeQuestObjective and qoColor or prdb.questsTooltip.defaultQuestObjectiveColor, self.questsObjectives[qid][oid].desc)
	self.questsObjectiveTextCells.questsTracker[qid][oid].fs:SetFormattedText("|cff%s%s|r", prdb.questsTracker.colorizeQuestObjective and qoColor or prdb.questsTracker.defaultQuestObjectiveColor, self.questsObjectives[qid][oid].desc)
	self.questsObjectiveStatusCells.questsTooltip[qid][oid].fs:SetFormattedText(qoStatus, prdb.questsTooltip.colorizeQuestObjectiveCounter and qoColor or prdb.questsTooltip.defaultQuestObjectiveColor)
	self.questsObjectiveStatusCells.questsTracker[qid][oid].fs:SetFormattedText(qoStatus, prdb.questsTracker.colorizeQuestObjectiveCounter and qoColor or prdb.questsTracker.defaultQuestObjectiveColor)
end

function tomQuest2:createQuestDescriptionCells(qid)
	self.questsDescriptionCells.questsTooltip[qid] = self:getContentCell(self.qoQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	self.questsDescriptionCells.questsTracker[qid] = self:getContentCell(self.qoQTrFontTQ2, "LEFT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
	self:updateQuestDescriptionCells(qid)
end

function tomQuest2:updateQuestDescriptionCells(qid)
	self.questsDescriptionCells.questsTooltip[qid].fs:SetFormattedText("|cff%s%s|r", prdb.questsTooltip.defaultQuestDescriptionColor, self.quests[qid].objective)
	self.questsDescriptionCells.questsTracker[qid].fs:SetFormattedText("|cff%s%s|r", prdb.questsTracker.defaultQuestDescriptionColor, self.quests[qid].objective)
end

function tomQuest2:createFakeItem(qid)
	if self.fakeItemButtons.questsTooltip[qid] then return end
	self.fakeItemButtons.questsTooltip[qid] = self:getButton(self.questTextCells.questsTooltip[qid], self.quests[qid].specialItemIcon, prdb.questsTooltip.questItemIconSize, "item", self.quests[qid].specialItemLink)
	self.fakeItemButtons.questsTracker[qid] = self:getButton(self.questTextCells.questsTracker[qid], self.quests[qid].specialItemIcon, prdb.questsTracker.questItemIconSize, "item", self.quests[qid].specialItemLink)
end

function tomQuest2:updateAllQuestsStatus(event)
	for qid, questData in pairs(self.quests) do
		self:updateQuestCells(qid)
		if self.questsObjectives[qid] then
			for oid in pairs(self.questsObjectives[qid]) do
				self:updateQuestObjectiveCells(qid, oid)
			end
		end
	end
end

function tomQuest2:updateAchievementCategoryCells(category, categoryColor, categoryName, categoryCounterColor, numTCA, numTA)
	self.achievementCategoryTextCells[category].fs:SetFormattedText("|cff%s%s|r", categoryColor, categoryName)
	self.achievementCategoryStatusCells[category].fs:SetFormattedText("|cff%s%d/%d|r", categoryCounterColor, numTCA, numTA)
end

function tomQuest2:createAchievementCategoryCells(font, size, category, categoryColor, categoryName, categoryCounterColor, numTCA, numTA)
	if not chdb.categoryDisplay.achievementsTracker[category] then
		chdb.categoryDisplay.achievementsTracker[category] = 1
	end
	self.achievementCategoryTextCells[category] = self:getContentCell(font, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, category, nil, true)
	self.achievementCategoryStatusCells[category] = self:getContentCell(font, "RIGHT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, category, nil, true)
	self.categoryButtons.achievementsTracker[category] = self:getButton(self.achievementCategoryTextCells[category], chdb.categoryDisplay.achievementsTracker[category] == 1 and collapseTexture or expandTexture, size, ACHIEVEMENTS_TRACKER, category)
	self:updateAchievementCategoryCells(category, categoryColor, categoryName, categoryCounterColor, numTCA, numTA)
end

function tomQuest2:removeAchievementsCategoryCells(category)
	self:recycleContentCell(self.achievementCategoryTextCells[category])
	self:recycleContentCell(self.achievementCategoryStatusCells[category])
	self:recycleButton(self.categoryButtons.achievementsTracker[category])
	self.achievementCategoryTextCells[category], self.achievementCategoryStatusCells[category], self.categoryButtons.achievementsTracker[category] = nil, nil, nil
end

local function timedAchievementUpdate(self, elapsed)
	self.duration = self.duration + elapsed
	if self.duration >= 1 then
		local aid = self.aid
		if tomQuest2.achievements[aid] and tomQuest2.achievements[aid].remainingTime and tomQuest2.achievements[aid].duration then
			if tomQuest2.achievements[aid].remainingTime > 0 then
				tomQuest2.achievements[aid].remainingTime = tomQuest2.achievements[aid].remainingTime - self.duration
				self.fs:SetFormattedText("|cff%s%s|r |cff%s%s|r", prdb.achievementsTracker.defaultANameColor, tomQuest2.achievements[aid].name, prdb.achievementsTracker.colorizeATimer and tomQuest2:getColorFromCompletionHEX(tomQuest2.achievements[aid].remainingTime / tomQuest2.achievements[aid].duration) or prdb.achievementsTracker.defaultATimerColor, formatTime(tomQuest2.achievements[aid].remainingTime))
				self.duration = 0
			else
				self.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultANameColor, tomQuest2.achievements[aid].name)
				self:SetScript("OnUpdate", nil)
				tomQuest2.achievements[aid].remainingTime, tomQuest2.achievements[aid].duration = nil, nil
			end
		else
			self.fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultANameColor, tomQuest2.achievements[aid].name)
			self:SetScript("OnUpdate", nil)
			tomQuest2.achievements[aid].remainingTime, tomQuest2.achievements[aid].duration = nil, nil
		end
	end
end

------------------
--- Sync Party ---
------------------
local comm = {
	v = function(sender, senderVersion, senderFirstCompatibleVersion, senderClass, currXP, maxXP)
		if senderVersion <= lastIncompatibleVersion then
			tomQuest2:Print(format(LC["The tomQuest2 release (%d) used by %s is too old to synchronise with your release (%d) (min %d)"], senderVersion, sender, version, firstCompatibleVersion))
			return
		elseif version < senderFirstCompatibleVersion then
			tomQuest2:Print(format(LC["Your tomQuest2 release (%d) is too old to synchorise with release (%d) of %s (min %d)"], version, senderVersion, sender, firstCompatibleVersion))
			tomQuest2.moduleState["syncParty"] = nil
			syncParty = nil
			return
		elseif version < senderVersion then
			tomQuest2:Print(format(LC["New release available (%d) ask %s where to find it"], senderVersion, sender))
		end
		if not tomQuest2.party[sender] then
			tomQuest2.party[sender] = {
				subName = utf8sub(sender), class = senderClass, color = tomQuest2.classColors[senderClass], currXP = currXP, maxXP = maxXP, transfer = true,
				fmtXP = format("|cff%s%s / %s (%d%%)|r", tomQuest2:getColorFromCompletionHEX(currXP/maxXP), short(currXP), short(maxXP), floor(currXP/maxXP*10000)/100)
			}
		end
		syncParty = true
		tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("w", version, firstCompatibleVersion, tomQuest2.playerClass, UnitXP("player"), UnitXPMax("player")), "WHISPER", sender, "BULK")
		for qid, qData in pairs(tomQuest2.quests) do
			if qData.playerStatus then
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("q", qid, qData.title, qData.level, qData.shortTag, qData.group, qData.daily, qData.numObjectives, qData.playerStatus, qData.zone), "WHISPER", sender, "BULK")
				local begun = 0
				if tomQuest2.questsObjectives[qid] then
					for oid, qoData in pairs(tomQuest2.questsObjectives[qid]) do
						tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("o", qid, oid, qoData.desc, qoData.playerGot, qoData.need, qoData.nPlayerGot, qoData.nNeed), "WHISPER", sender, "BULK")
						if qoData.nPlayerGot ~= 0 then begun = 1 end
					end
				end
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("r", qid, begun), "WHISPER", sender, "BULK")
			end
		end
		tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("d"), "WHISPER", sender, "BULK")
	end,
	w = function(sender, senderVersion, senderFirstCompatibleVersion, senderClass, currXP, maxXP)
		if senderVersion <= lastIncompatibleVersion then
			tomQuest2:Print(format(LC["The tomQuest2 release (%d) used by %s is too old to synchronise with your release (%d) (min %d)"], senderVersion, sender, version, firstCompatibleVersion))
			return
		elseif version < senderFirstCompatibleVersion then
			tomQuest2:Print(format(LC["Your tomQuest2 release (%d) is too old to synchorise with release (%d) of %s (min %d)"], version, senderVersion, sender, firstCompatibleVersion))
			tomQuest2.moduleState["syncParty"] = nil
			syncParty = nil
		elseif version < senderVersion then
			tomQuest2:Print(format(LC["New release available (%d) ask %s where to find it"], senderVersion, sender))
		end
		if not tomQuest2.party[sender] then
			tomQuest2.party[sender] = {
				subName = utf8sub(sender), class = senderClass, color = tomQuest2.classColors[senderClass], currXP = currXP, maxXP = maxXP, transfer = true,
				fmtXP = format("|cff%s%s / %s (%d%%)|r", tomQuest2:getColorFromCompletionHEX(currXP/maxXP), short(currXP), short(maxXP), floor(currXP/maxXP*10000)/100)
			}
		end
		syncParty = true
	end,
	d = function(sender)
		if not tomQuest2.party[sender] then return end
		tomQuest2.party[sender].transfer = nil
	end,
	q = function(sender, qid, title, level, tag, group, daily, numObjectives, completed, zone)
		if not tomQuest2.party[sender] then return end
		if not tomQuest2.quests[qid] then
			tomQuest2:addQuest(qid, title, level, tag, group, daily, numObjectives, zone)
		end
		tomQuest2:addPlayerToQuest(qid, completed, prdb.partyHeader and tomQuest2.PARTYQUESTSZONE or zone, sender)
		if not tomQuest2.quests[qid].extras then
			tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("e", qid), "WHISPER", sender, "BULK")
		end
	end,
	o = function(sender, qid, oid, desc, got, need, nGot, nNeed)
		if not tomQuest2.party[sender] or not tomQuest2.questsObjectives[qid] then return end
		if not tomQuest2.questsObjectives[qid][oid] then
			tomQuest2:addQuestObjective(qid, oid, desc, need, nNeed)
		end
		tomQuest2:addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot, sender)
	end,
	p = function(sender, qid, oid, got, nGot)
		if not tomQuest2.party[sender] or not tomQuest2.questsObjectives[qid] or not tomQuest2.questsObjectives[qid][oid] or not tomQuest2.questsObjectives[qid][oid].got or not tomQuest2.questsObjectives[qid][oid].got[sender] then return end
		tomQuest2.questsObjectives[qid][oid].got[sender] = got
		tomQuest2.questsObjectives[qid][oid].nGot[sender] = nGot
		tomQuest2:updateQuestObjectiveCells(qid, oid)
		if tomQuest2.moduleState["notifications"] and prdb.notifyPartyObjectiveProgress then
			if nGot == tomQuest2.questsObjectives[qid][oid].nNeed and prdb.notifyPartyObjectiveComplete then
				if not prdb.notifiyObjectiveProgressWhenQuestComplete and tomQuest2.quests[qid].complete[sender] ~= 0 then return end
				tomQuest2:Pour(format(LC["(%s : %s) %s : finished"], sender, tomQuest2.quests[qid].title, tomQuest2.questsObjectives[qid][oid].desc), 0, 1, 0)
			elseif prdb.partyObjectiveProgress and nGot > 0 then
				tomQuest2:Pour(format("(%s : %s) %s : %s / %s", sender, tomQuest2.quests[qid].title, tomQuest2.questsObjectives[qid][oid].desc, got, tomQuest2.questsObjectives[qid][oid].need), tomQuest2:getColorFromCompletionRGB(nGot/tomQuest2.questsObjectives[qid][oid].nNeed))
			end
		end
		tomQuest2:qTrQuestObjectiveProgress(qid, oid, got, nGot)
	end,
	r = function(sender, qid, numObjectives, started)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or not tomQuest2.quests[qid].complete[sender] then return end
		if tomQuest2.moduleState["notifications"] and prdb.notifyPartyQuestAccepted and not tomQuest2.party[sender].transfer then
			tomQuest2:Pour(format(LC["(%s : %s) : accepted"], sender, tomQuest2.quests[qid].title), 0, 1, 0)
		end
		if tomQuest2.party[sender].transfer then
			if not chdb.questsTracked[qid] and prdb.onLogIn then
				AddQuestWatch(tomQuest2.quests[qid].id, nil, qid)
			end
		elseif prdb.onQuestAccepted == 1 or (prdb.onQuestAccepted == 2 and tomQuest2.playerLevel ~= MAX_PLAYER_LEVEL) or (prdb.onObjectiveProgress and started == 1) or (prdb.onDaily and tomQuest2.quests[qid].daily == 1) then
			if not chdb.questsTracked[qid] then
				AddQuestWatch(tomQuest2.quests[qid].id, nil, qid)
			else
				chdb.questsSubZoneAutoTracked[qid] = nil
				chdb.questsZoneAutoTracked[qid] = nil
			end
		end
	end,
	e = function(sender, qid)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or not tomQuest2.quests[qid].playerStatus then return end
		if tomQuest2.quests[qid].objective then
			tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("n", qid, tomQuest2.quests[qid].objective), "WHISPER", sender, "BULK")
		end
		if tomQuest2.quests[qid].description then
			tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("t", qid, tomQuest2.quests[qid].description), "WHISPER", sender, "BULK")
		end
		tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("g", qid, tomQuest2.quests[qid].money, tomQuest2.quests[qid].honor, tomQuest2.quests[qid].talent, tomQuest2.quests[qid].titleReward, tomQuest2.quests[qid].numRewards, tomQuest2.quests[qid].numChoices, tomQuest2.quests[qid].rewardSpellName, tomQuest2.quests[qid].rewardSpellTexture), "WHISPER", sender, "BULK")
		if tomQuest2.quests[qid].numRewards and tomQuest2.quests[qid].numRewards > 0 then
			for i, irData in pairs (tomQuest2.quests[qid].itemRewards) do
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("i", qid, i, irData.name, irData.texture, irData.numItems, irData.quality, irData.isUsable, irData.link), "WHISPER", sender, "BULK")
			end
		end
		if tomQuest2.quests[qid].numChoices and tomQuest2.quests[qid].numChoices > 0 then
			for i, icData in pairs (tomQuest2.quests[qid].itemChoices) do
				tomQuest2:SendCommMessage("tomQ2", tomQuest2:Serialize("j", qid, i, icData.name, icData.texture, icData.numItems, icData.quality, icData.isUsable, icData.link), "WHISPER", sender, "BULK")
			end
		end
	end,
	n = function(sender, qid, objective)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or tomQuest2.quests[qid].objective then return end
		tomQuest2.quests[qid].objective = objective
		if not tomQuest2.questsObjectives[qid] then
			tomQuest2:createQuestDescriptionCells(qid)
		end
		if prdb.onSubZone and subZone ~= "" then
			if not chdb.questsTracked[qid] and tomQuest2.quests[qid].objective and tomQuest2.quests[qid].objective:find(subZone, 1, true) then
				chdb.questsSubZoneAutoTracked[qid] = true
				AddQuestWatch(tomQuest2.quests[qid].id, nil, qid)
			end
		end
	end,
	t = function(sender, qid, description)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or tomQuest2.quests[qid].description then return end
		tomQuest2.quests[qid].description = description
		if prdb.onSubZone and subZone ~= "" then
			if not chdb.questsTracked[qid] and tomQuest2.quests[qid].description and tomQuest2.quests[qid].description:find(subZone, 1, true) then
				chdb.questsSubZoneAutoTracked[qid] = true
				AddQuestWatch(tomQuest2.quests[qid].id, nil, qid)
			end
		end
	end,
	g = function(sender, qid, money, honor, talent, titleReward, numRewards, numChoices, rewardSpellName, rewardSpellTexture)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or tomQuest2.quests[qid].playerStatus then return end
		tomQuest2.quests[qid].money = money
		tomQuest2.quests[qid].honor = honor
		tomQuest2.quests[qid].talent = talent
		tomQuest2.quests[qid].titleReward = titleReward
		tomQuest2.quests[qid].numRewards = numRewards
		tomQuest2.quests[qid].numChoices = numChoices
		tomQuest2.quests[qid].rewardSpellName = rewardSpellName
		tomQuest2.quests[qid].rewardSpellTexture = rewardSpellTexture
	end,
	i = function(sender, qid, i, name, texture, numItems, quality, isUsable, link)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or tomQuest2.quests[qid].playerStatus then return end
		tomQuest2.quests[qid].itemRewards = tomQuest2.quests[qid].itemRewards or {}
		if not tomQuest2.quests[qid].itemRewards[i] then
			tomQuest2.quests[qid].itemRewards[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = link}
		end
	end,
	j = function(sender, qid, i, name, texture, numItems, quality, isUsable, link)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or tomQuest2.quests[qid].playerStatus then return end
		tomQuest2.quests[qid].itemChoices = tomQuest2.quests[qid].itemChoices or {}
		if not tomQuest2.quests[qid].itemChoices[i] then
			tomQuest2.quests[qid].itemChoices[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = link}
		end
	end,
	c = function(sender, qid)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or not tomQuest2.quests[qid].complete[sender] then return end
		tomQuest2:updateQuest(qid, 1, nil, sender)
		if tomQuest2.moduleState["notifications"] and prdb.notifyPartyQuestComplete then
			tomQuest2:Pour(format(LC["(%s : %s) : finished"], sender, tomQuest2.quests[qid].title), 0, 1, 0)
		end
	end,
	a = function(sender, qid)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or not tomQuest2.quests[qid].complete[sender] then return end
		tomQuest2:updateQuest(qid, 0, nil, sender)
	end,
	f = function(sender, qid)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or not tomQuest2.quests[qid].complete[sender] then return end
		tomQuest2:updateQuest(qid, -1, nil, sender)
		if tomQuest2.moduleState["notifications"] and prdb.notifyPartyQuestFailed then
			tomQuest2:Pour(format(LC["(%s : %s) : failed"], sender, tomQuest2.quests[qid].title), 1, 0, 0)
		end
	end,
	l = function(sender, qid, abandoning)
		if not tomQuest2.party[sender] or not tomQuest2.quests[qid] or not tomQuest2.quests[qid].complete[sender] then return end
		if tomQuest2.moduleState["notifications"] then 
			if abandoning then
				if prdb.notifyPartyQuestAbandonned then
					tomQuest2:Pour(format(LC["(%s : %s) : abandonned"], sender, tomQuest2.quests[qid].title), 1, 0, 0)
				end
			elseif prdb.notifyPartyQuestTurnedIn then
				tomQuest2:Pour(format(LC["(%s : %s) : turned in"], sender, tomQuest2.quests[qid].title), 0, 1, 0)
			end
		end
		tomQuest2:questLost(qid)
		tomQuest2:removePartyFromQuest(sender, qid, abandoning)
	end,
	x = function(sender, currXP)
		if not tomQuest2.party[sender] then return end
		tomQuest2.party[sender].currXP = currXP
		tomQuest2.party[sender].fmtXP = format("|cff%s%s / %s (%d%%)|r", tomQuest2:getColorFromCompletionHEX(currXP/tomQuest2.party[sender].maxXP), short(currXP), short(tomQuest2.party[sender].maxXP), floor(currXP/tomQuest2.party[sender].maxXP*10000)/100)
	end,
	u = function(sender, currXP, maxXP)
		if not tomQuest2.party[sender] then return end
		tomQuest2.party[sender].currXP = currXP
		tomQuest2.party[sender].maxXP = maxXP
		tomQuest2.party[sender].fmtXP = format("|cff%s%s / %s (%d%%)|r", tomQuest2:getColorFromCompletionHEX(currXP/maxXP), short(currXP), short(maxXP), floor(currXP/maxXP*10000)/100)
	end,
}

function tomQuest2:commHandler(prefix, message, distribution, sender)
	if sender ~= self.playerName then
		self:onCommand(sender, self:Deserialize(message))
	end
end

function tomQuest2:onCommand(sender, success, commHandler, ...)
	if not success then
		return
	elseif comm[commHandler] then
		comm[commHandler](sender, ...)
	end
end

function tomQuest2:sendMessage(event, commHandler, ...)
	if self.moduleState["syncParty"] and syncParty then
		self:SendCommMessage("tomQ2", self:Serialize(commHandler, ...), "PARTY", nil, "BULK")
	end
end

-----------------------------------
--- Achievements Tracker module ---
-----------------------------------
function tomQuest2:ACHIEVEMENT_EARNED(event, aid)
	if self.achievements[aid] then
		RemoveTrackedAchievement(aid)
	end
	local subCategory = GetAchievementCategory(aid)
	local subCategoryName, category = GetCategoryInfo(subCategory)
	if category and category > 0 then
		if self.achievementsCategories[category] then
			local numTA, numTCA = GetCategoryNumAchievements(category)
			local color = tomQuest2:getColorFromCompletionHEX(numTCA / numTA)
			self:updateAchievementCategoryCells(category, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, self.achievementsCategories[category].categoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
		end
		if self.achievementsCategories[category].subCategory[subCategory] then
			local numTA, numTCA = GetCategoryNumAchievements(subCategory)
			local color = tomQuest2:getColorFromCompletionHEX(numTCA / numTA)
			self:updateAchievementCategoryCells(category, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, self.achievementsCategories[category].subCategory[subCategory].categoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
		end
	elseif self.achievementsCategories[subCategory] then
		local numTA, numTCA = GetCategoryNumAchievements(subCategory)
		local color = tomQuest2:getColorFromCompletionHEX(numTCA / numTA)
		self:updateAchievementCategoryCells(category, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, self.achievementsCategories[subCategory].categoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
	end
end

function tomQuest2:CRITERIA_UPDATE()
	for aid in pairs(self.achievements) do
		for cid = 1, self.achievements[aid].numCriteria do
			local name, cType, completed, quantity, reqQuantity, _, flags = GetAchievementCriteriaInfo(aid, cid)
			completed = completed or 0
			if quantity ~= self.achievements[aid].criteria[cid].quantity or completed ~= self.achievements[aid].criteria[cid].completed then
				self.achievements[aid].criteria[cid].completed, self.achievements[aid].criteria[cid].quantity = completed, quantity
				if reqQuantity == 0 then reqQuantity = 1 end
				local color = self:getColorFromCompletionHEX(quantity / reqQuantity)
				local statusBar = band(flags, ACHIEVEMENT_CRITERIA_PROGRESS_BAR) == ACHIEVEMENT_CRITERIA_PROGRESS_BAR
				local boolean = reqQuantity == 1 and true or false
				if not boolean then
					self.achievementCriterionTextCells[aid][cid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
					self.achievementCriterionStatusCells[aid][cid].fs:SetFormattedText("|cff%s / %s|r", prdb.achievementsTracker.colorizeACrStatus and color or prdb.achievementsTracker.defaultACrStatusColor, quantity, reqQuantity)
					if statusBar then
						self:updateStatusbar(aid, cType, quantity, reqQuantity, color)
					end
				else
					self.achievementBooleanCriterionCells[aid][cid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
					self:setAchievementsTrackerLayout()
				end
			end
		end
	end
end

function tomQuest2:TRACKED_ACHIEVEMENT_UPDATE(event, aid, cid, elapsed, duration)
	if not aid or not duration or not elapsed then return end
	if duration > elapsed then
		local startTime = GetTime() - elapsed
		if not self.achievements[aid] then
			AddTrackedAchievement(aid)
		end
		self.achievements[aid].startTime, self.achievements[aid].duration, self.achievements[aid].remainingTime = startTime, duration, duration - elapsed
		self.achievementCells[aid].fs:SetFormattedText("|cff%s%s|r |cff%s%s|r", prdb.achievementsTracker.defaultANameColor, self.achievements[aid].name, prdb.achievementsTracker.colorizeATimer and self:getColorFromCompletionHEX(self.achievements[aid].remainingTime / duration) or prdb.achievementsTracker.defaultATimerColor, formatTime(self.achievements[aid].remainingTime))
		self.achievementCells[aid].fs:SetScript("OnUpdate", timedAchievementUpdate)
	elseif self.achievements[aid] and self.achievements[aid].startTime then
		self.achievements[aid].startTime = nil
		self.achievements[aid].duration = nil
	end
end

function tomQuest2:AddTrackedAchievement(aid, batch)
	if not self.achievementsFirstRun and chdb.achievementTracked[aid] then
		RemoveTrackedAchievement(aid)
	else
		chdb.achievementTracked[aid] = true
		local _, name, _, completed, _, _, _, description, _, texture = GetAchievementInfo(aid)
		local numCriteria = GetAchievementNumCriteria(aid)
		local subCategory = GetAchievementCategory(aid)
		local subCategoryName, category = GetCategoryInfo(subCategory)
		local categoryName = GetCategoryInfo(category)
		local achievementLink = GetAchievementLink(aid)
		if category > 0 then
			self.achievements[aid] = {name = name, completed = completed, description = description, numCriteria = numCriteria, criteria = {}, category = category, subCategory = subCategory}
			if not self.achievementsCategories[category] then
				self.achievementsCategories[category] = {subCategory = {}, achievements = {}, name = categoryName}
				local numTA, numTCA = GetCategoryNumAchievements(category)
				local color = self:getColorFromCompletionHEX(numTCA / numTA)
				self:createAchievementCategoryCells(self.cATrFontTQ2, prdb.achievementsTracker.categoryCollapseButtonSize, category, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, categoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			end
			if not self.achievementsCategories[category].subCategory[subCategory] then
				local numTA, numTCA = GetCategoryNumAchievements(subCategory)
				self.achievementsCategories[category].subCategory[subCategory] = {achievements = {[aid] = true}, name = subCategoryName}
				local color = self:getColorFromCompletionHEX(numTCA / numTA)
				self:createAchievementCategoryCells(self.scATrFontTQ2, prdb.achievementsTracker.subCategoryCollapseButtonSize, subCategory, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, subCategoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			else
				self.achievementsCategories[category].subCategory[subCategory].achievements[aid] = true
			end
		else
			self.achievements[aid] = {name = name, completed = completed, description = description, image = image, numCriteria = numCriteria, criteria = {}, category = category, subCategory = subCategory}
			if not self.achievementsCategories[subCategory] then
				local numTA, numTCA = GetCategoryNumAchievements(subCategory)
				self.achievementsCategories[subCategory] = {subCategory = {}, achievements = {[aid] = true}, name = subCategoryName}
				local color = self:getColorFromCompletionHEX(numTCA / numTA)
				self:createAchievementCategoryCells(self.cATrFontTQ2, prdb.achievementsTracker.categoryCollapseButtonSize, subCategory, prdb.achievementsTracker.colorizeACName and color or prdb.achievementsTracker.defaultACrNameColor, subCategoryName, prdb.achievementsTracker.colorizeACCounter and color or prdb.achievementsTracker.defaultACCounterColor, numTCA, numTA)
			else
				self.achievementsCategories[subCategory].achievements[aid] = true
			end
		end
		self.achievementCells[aid] = self:getContentCell(self.aATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
		self.achievementCells[aid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultANameColor, name)
		self.achievementIcons[aid] = self:getButton(self.achievementCells[aid], texture, prdb.achievementsTracker.achievementIconSize, "icon", GetAchievementLink(aid))
		if numCriteria == 0 then
			self.achievements[aid].criteria = nil
			self.achievementDescriptionCells[aid] = self:getContentCell(self.acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
			self.achievementDescriptionCells[aid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultDescriptionColor, self.achievements[aid].description)
		else
			for cid = 1, numCriteria do
				local name, cType, completed, quantity, reqQuantity, charName, flags, assetID, quantityString, cid2 = GetAchievementCriteriaInfo(aid, cid)
				if reqQuantity == 0 then reqQuantity = 1 end
				local color = self:getColorFromCompletionHEX(quantity / reqQuantity)
				local statusBar = band(flags, ACHIEVEMENT_CRITERIA_PROGRESS_BAR) == ACHIEVEMENT_CRITERIA_PROGRESS_BAR
				local boolean = reqQuantity == 1 and true or false
				self.achievements[aid].criteria[cid] = {id = cid2, name = name, completed = completed or 0, quantity = quantity}
				if not boolean then
					if not self.achievementCriterionTextCells[aid] then
						self.achievementCriterionTextCells[aid] = {}
						self.achievementCriterionStatusCells[aid] = {}
					end
					if (cType == 7 and quantity > 0) or cType ~= 7 then
						self.achievementCriterionTextCells[aid][cid] = self:getContentCell(self.acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
						self.achievementCriterionStatusCells[aid][cid] = self:getContentCell(self.acATrFontTQ2, "RIGHT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
						self.achievementCriterionTextCells[aid][cid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
						self.achievementCriterionStatusCells[aid][cid].fs:SetFormattedText("|cff%s%s/%s|r", prdb.achievementsTracker.colorizeACrStatus and color or prdb.achievementsTracker.defaultACrStatusColor, quantity, reqQuantity)
					end
					if statusBar then
						self.achievementDescriptionCells[aid] = self:getContentCell(self.acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
						self.achievementDescriptionCells[aid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.defaultDescriptionColor, self.achievements[aid].description)
						self.achievementStatusBars[aid] = self:getStatusBar(ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, reqQuantity)
						self:updateStatusbar(aid, cType, quantity, reqQuantity, color)
					end
				else
					if not self.achievementBooleanCriterionCells[aid] then
						self.achievementBooleanCriterionCells[aid] = {}
					end
					self.achievementBooleanCriterionCells[aid][cid] = self:getContentCell(self.acATrFontTQ2, "LEFT", ACHIEVEMENTS_TRACKER, self.ACHIEVEMENTS_TRACKER_FRAME, aid, true)
					self.achievementBooleanCriterionCells[aid][cid].fs:SetFormattedText("|cff%s%s|r", prdb.achievementsTracker.colorizeACrName and color or prdb.achievementsTracker.defaultACrNameColor, name)
				end
			end
		end
		if not batch then
			self:setAchievementsTrackerLayout()
		end
	end
	if AchievementFrame then
		AchievementFrameAchievements_ForceUpdate()
	end
end

function tomQuest2:RemoveTrackedAchievement(aid)
	if not chdb.achievementTracked[aid] or not self.achievements[aid] then return end
	if self.achievements[aid].startTime then
		self.achievements[aid].startTime = nil
		self.achievements[aid].duration = nil
	end
	chdb.achievementTracked[aid] = nil
	local category, subCategory = self.achievements[aid].category, self.achievements[aid].subCategory
	self.achievements[aid] = nil
	self:recycleContentCell(self.achievementCells[aid])
	self.achievementCells[aid] = nil
	if self.achievementDescriptionCells[aid] then
		self:recycleContentCell(self.achievementDescriptionCells[aid])
		self.achievementDescriptionCells[aid] = nil
	end
	if self.achievementCriterionTextCells[aid] then
		if self.achievementStatusBars[aid] then
			self:recycleStatusBar(self.achievementStatusBars[aid])
			self.achievementStatusBars[aid] = nil
		end
		for cid, frame in pairs(self.achievementCriterionTextCells[aid]) do
			self:recycleContentCell(frame)
		end
		self.achievementCriterionTextCells[aid] = nil
		for cid, frame in pairs(self.achievementCriterionStatusCells[aid]) do
			self:recycleContentCell(frame)
		end
		self.achievementCriterionStatusCells[aid] = nil
	elseif self.achievementBooleanCriterionCells[aid] then
		for cid, frame in pairs(self.achievementBooleanCriterionCells[aid]) do
			self:recycleContentCell(frame)
		end
		self.achievementBooleanCriterionCells[aid] = nil
	end
	if category > 0 and subCategory > 0 then
		self.achievementsCategories[category].subCategory[subCategory].achievements[aid] = nil
		if not next(self.achievementsCategories[category].subCategory[subCategory].achievements) then
			self.achievementsCategories[category].subCategory[subCategory] = nil
			self:removeAchievementsCategoryCells(subCategory)
			if not next(self.achievementsCategories[category].subCategory) and not next(self.achievementsCategories[category].achievements) then
				self.achievementsCategories[category] = nil
				self:removeAchievementsCategoryCells(category)
			end
		end
	elseif subCategory > 0 then
		self.achievementsCategories[subCategory].achievements[aid] = nil
		if not next(self.achievementsCategories[subCategory].subCategory) and not next(self.achievementsCategories[subCategory].achievements) then
			self.achievementsCategories[subCategory] = nil
			self:removeAchievementsCategoryCells(subCategory)
		end
	end
	self:setAchievementsTrackerLayout()
	if AchievementFrame then
		AchievementFrameAchievements_ForceUpdate()
	end
end

function tomQuest2:IsTrackedAchievement(aid)
	return self.achievements[aid] and true or false
end

-----------------------------
--- Quests Tracker module ---
-----------------------------
function tomQuest2:AddQuestWatch(id, timeToTrack, qid, batch)
	if not qid then
		_, _, _, _, _, _, _, _, qid = GetQuestLogTitle(id)
		if not qid or not self.quests[qid] then return end
	end
	chdb.questsTracked[qid] = true
	if QuestLogFrame:IsVisible() then
		QuestLog_Update()
	end
	if not batch then
		self:setQuestsTrackerLayout()
	end
end

function tomQuest2:RemoveQuestWatch(id, qid)
	if not qid then
		_, _, _, _, _, _, _, _, qid = GetQuestLogTitle(id)
		if not qid or not self.quests[qid] then return end
	end
	chdb.questsTracked[qid] = nil
	chdb.questsSubZoneAutoTracked[qid] = nil
	chdb.questsZoneAutoTracked[qid] = nil
	self:setQuestsTrackerLayout()
	if QuestLogFrame:IsVisible() then
		QuestLog_Update()
	end
end

function tomQuest2:qTrQuestObjectiveProgress(qid, oid, got, nGot)
	if prdb.onObjectiveProgress then
		if not chdb.questsTracked[qid] then
			AddQuestWatch(self.quests[qid].id, prdb.unTrackInactive and prdb.unTrackDelay * 60 or nil, qid)
		else
			chdb.questsSubZoneAutoTracked[qid] = nil
			chdb.questsZoneAutoTracked[qid] = nil
		end
	end
end

----------------------
--- Quests Tooltip ---
----------------------
local function questsTooltipDataObjOnEnter(frame)
	tomQuest2:setQuestsTooltipLayout()
	local questsTooltip = tomQuest2.displayFrames.questsTooltip
	questsTooltip:SetPoint(getTipAnchor(frame))
	questsTooltip:SetFrameStrata("TOOLTIP")
	updateScrolling(questsTooltip, prdb.questsTooltip.hasMaxHeight and prdb.questsTooltip.maxHeight or nil)
	questsTooltip:Show()
end

local function hideTooltip()
	if tomQuest2.displayFrames.questsTooltip:IsMouseOver() then return end
	tomQuest2.displayFrames.questsTooltip:SetScript("OnUpdate", nil)
	tomQuest2.displayFrames.questsTooltip:Hide()
end

local function questsTooltipDataObjOnLeave(frame)
	if tomQuest2.displayFrames.questsTooltip:IsMouseOver() then
		tomQuest2.displayFrames.questsTooltip:SetScript("OnUpdate", hideTooltip)
	else
		tomQuest2.displayFrames.questsTooltip:Hide()
	end
end

local function questsTooltipDataObjOnClick(frame, button)
	if button == "RightButton" then
		if IsShiftKeyDown() then
			ldbOnClick[prdb.qToMouseRightShift]()
		elseif IsControlKeyDown() then
			ldbOnClick[prdb.qToMouseRightControl]()
		elseif IsAltKeyDown() then
			ldbOnClick[prdb.qToMouseRightAlt]()
		else
			ldbOnClick[prdb.qToMouseRight]()
		end
	elseif button == "LeftButton" then
		if IsShiftKeyDown() then
			ldbOnClick[prdb.qToMouseLeftShift]()
		elseif IsControlKeyDown() then
			ldbOnClick[prdb.qToMouseLeftControl]()
		elseif IsAltKeyDown() then
			ldbOnClick[prdb.qToMouseLeftAlt]()
		else
			ldbOnClick[prdb.qToMouseLeft]()
		end
	elseif button == "MiddleButton" then
		if IsShiftKeyDown() then
			ldbOnClick[prdb.qToMouseMiddleShift]()
		elseif IsControlKeyDown() then
			ldbOnClick[prdb.qToMouseMiddleControl]()
		elseif IsAltKeyDown() then
			ldbOnClick[prdb.qToMouseMiddleAlt]()
		else
			ldbOnClick[prdb.qToMouseMiddle]()
		end
	end
end

----------------------------
--- Daily Quests Tooltip ---
----------------------------
function tomQuest2:updateDQToText()
	if not self.moduleState["dailyTooltip"] then return end
	local counter, remainingTime
	if prdb.showNumCompletedDailyQuests and prdb.showMaxDailyQuest then
		if prdb.colorizeDailyQuestsCounter then
			counter = format("|cff%s%d/%d|r", self:getColorFromCompletionHEX(self.numCompletedDailyQuests/MAX_DAILY), self.numCompletedDailyQuests, MAX_DAILY)
		else
			counter = format("%d/%d", self.numCompletedDailyQuests, MAX_DAILY)
		end
	elseif prdb.showNumCompletedDailyQuests then
		if prdb.colorizeDailyQuestsCounter then
			counter = format("|cff%s%s|r", self:getColorFromCompletionHEX(self.numCompletedDailyQuests/MAX_DAILY), self.numCompletedDailyQuests)
		else
			counter = self.numCompletedDailyQuests
		end
	elseif prdb.showMaxDailyQuest then
		counter = MAX_DAILY
	end
	if prdb.showRemainingTime then
		local rt = GetQuestResetTime()
		if rt >= 0 and rt <= 86400 then
			if prdb.colorizeDailyQuestsTime then
				remainingTime = format("%d:%02d|r", rt*fh, mod(rt*fm, 60))
			else
				remainingTime = format("|cff%s%d:%02d|r", self:getColorFromCompletionHEX(rt*fd), rt*fh, mod(rt*fm, 60))
			end
		end
	end
	if counter and remainingTime then
		dailyQuestsTooltipDataObj.text = format("%s %s", counter, remainingTime)
	elseif counter then
		dailyQuestsTooltipDataObj.text = counter
	elseif remainingTime then
		dailyQuestsTooltipDataObj.text = remainingTime
	end
end

function tomQuest2:CHAT_MSG_SYSTEM(event, message)
	if message == NO_DAILY_QUESTS_REMAINING then
		self.numCompletedDailyQuests = MAX_DAILY
		self:updateDQToText()
	else
		local remaining = message:match(self.dailyCounterPattern)
		if remaining then
			self.numCompletedDailyQuests = MAX_DAILY - remaining
			self:updateDQToText()
			if remaining == 25 and prdb.dailyList then
				prdb.dailyList[self.playerName].dailies = nil
			end
		end
	end
end

local function dailyQuestsTooltipDataObjOnEnter(frame)
	if not prdb.showCOTD then return end
	GameTooltip:ClearLines()
	GameTooltip:ClearAllPoints()
	GameTooltip:AddLine(LC["Daily quests completed today"])
	for player, playerData in pairs(prdb.dailyList) do
		if playerData.dailies and next(playerData.dailies) then
			GameTooltip:AddLine(format("|cff%s%s|r", tomQuest2.classColors[playerData.class], player))
			for index, questData in ipairs(playerData.quests) do
				local dateJ, titreJ = match(questData, dailyPattern)
				GameTooltip:AddDoubleLine(format("%d. %s", index, titreJ), date("%x %H:%M", dateJ))
			end
		end
	end
	GameTooltip:SetPoint(getTipAnchor(frame))
	GameTooltip:Show()
end

local function dailyQuestsTooltipDataObjOnClick(frame, button)
	if button == "RightButton" then
		if IsShiftKeyDown() then
			ldbOnClick[prdb.dqToMouseRightShift]()
		elseif IsControlKeyDown() then
			ldbOnClick[prdb.dqToMouseRightControl]()
		elseif IsAltKeyDown() then
			ldbOnClick[prdb.dqToMouseRightAlt]()
		else
			ldbOnClick[prdb.dqToMouseRight]()
		end
	elseif button == "LeftButton" then
		if IsShiftKeyDown() then
			ldbOnClick[prdb.dqToMouseLeftShift]()
		elseif IsControlKeyDown() then
			ldbOnClick[prdb.dqToMouseLeftControl]()
		elseif IsAltKeyDown() then
			ldbOnClick[prdb.dqToMouseLeftAlt]()
		else
			ldbOnClick[prdb.dqToMouseLeft]()
		end
	elseif button == "MiddleButton" then
		if IsShiftKeyDown() then
			ldbOnClick[prdb.dqToMouseMiddleShift]()
		elseif IsControlKeyDown() then
			ldbOnClick[prdb.dqToMouseMiddleControl]()
		elseif IsAltKeyDown() then
			ldbOnClick[prdb.dqToMouseMiddleAlt]()
		else
			ldbOnClick[prdb.dqToMouseMiddle]()
		end
	end
end

----------------
--- Tooltips ---
----------------
function tomQuest2:addCriteriaToTooltip(tooltip, aid, cid)
	local _, _, _, completed = GetAchievementCriteriaInfo(aid, cid)
	if completed == 1 then
		tooltip:AddLine(self.achievementName[aid], 0, 1, 0)
	else
		tooltip:AddLine(self.achievementName[aid], 1, 0, 0)
	end
	tooltip:AddTexture(self.achievementIcon[aid])
end

function tomQuest2:OnTooltipSetUnit(tooltip)
	local name, unit = tooltip:GetUnit()
	if not unit then return end
	if self.achievementsMobs[name] then
		for _, critData in pairs(self.achievementsMobs[name]) do
			local aid, cid = critData:match(achievementsPattern)
			self:addCriteriaToTooltip(tooltip, aid, cid)
		end
		tooltip:Show()
	end
	if self.party[name] and self.party[name].currXP and UnitLevel(unit) ~= MAX_PLAYER_LEVEL then
		tooltip:AddDoubleLine(LC["|cffffffffExperience|r"], self.party[name].fmtXP)
		tooltip:Show()
	end
end

function tomQuest2:OnTooltipSetItem(tooltip)
	local name = tooltip:GetItem()
	if not name or not self.achievementsItems[name] then return end
	for _, critData in pairs(self.achievementsItems[name]) do
		local aid, cid = critData:match(achievementsPattern)
		self:addCriteriaToTooltip(tooltip, aid, cid)
	end
	tooltip:Show()
end

function tomQuest2:OnShow(tooltip)
	if tooltip:NumLines() == 1 then
		local name = _G["GameTooltipTextLeft1"]:GetText()
		if not name or not self.achievementsItems[name] then return end
		for _, critData in pairs(self.achievementsItems[name]) do
			local aid, cid = critData:match(achievementsPattern)
			self:addCriteriaToTooltip(tooltip, aid, cid)
		end
		tooltip:Show()
	end
end

function tomQuest2:setMobTooltip()
	if prdb.mobTooltip then
		for _, aid in pairs(self.achMobs) do
			local _, name, _, completed, _, _, _, _, _, icon = GetAchievementInfo(aid)
			if not completed then
				self.achievementName[aid] = name
				self.achievementIcon[aid] = icon
				local numCriteria = GetAchievementNumCriteria(aid)
				for cid = 1, numCriteria do
					local cString = GetAchievementCriteriaInfo(aid, cid)
					if self.substitute[cString] then cString = self.substitute[cString] end
					if not self.achievementsMobs[cString] then
						self.achievementsMobs[cString] = {}
					end
					self.achievementsMobs[cString][#(self.achievementsMobs[cString])+1] = aid.."~"..cid
				end
			end
		end
		self:HookScript(GameTooltip, "OnTooltipSetUnit", "OnTooltipSetUnit")
	else
		for _, aid in pairs(self.achMobs) do
			self.achievementName[aid] = nil
			self.achievementIcon[aid] = nil
		end
		self:Unhook(GameTooltip, "OnTooltipSetUnit")
	end
end

function tomQuest2:setItemTooltip()
	if prdb.itemTooltip then
		for _, aid in pairs(self.achItems) do
			local _, name, _, completed, _, _, _, _, _, icon = GetAchievementInfo(aid)
			if not completed then
				self.achievementName[aid] = name
				self.achievementIcon[aid] = icon
				local numCriteria = GetAchievementNumCriteria(aid)
				for cid = 1, numCriteria do
					local cString = GetAchievementCriteriaInfo(aid, cid)
					if not self.achievementsItems[cString] then
						self.achievementsItems[cString] = {}
					end
					self.achievementsItems[cString][#(self.achievementsItems[cString])+1] = aid.."~"..cid
				end
			end
		end
		self:HookScript(GameTooltip, "OnShow", "OnTooltipShow")
		self:HookScript(GameTooltip, "OnTooltipSetItem", "OnTooltipSetItem")
	else
		for _, aid in pairs(self.achItems) do
			self.achievementName[aid] = nil
			self.achievementIcon[aid] = nil
		end
		self:Unhook(GameTooltip, "OnShow")
		self:Unhook(GameTooltip, "OnTooltipSetItem")
	end
end

---------------------
--- Quests Givers ---
---------------------
function tomQuest2:clickQuest(button)
	if button:IsVisible() then
		local title = button.title
		if button.type == "Available" and (prdb.automaticAccept == 1 or (prdb.automaticAccept == 2 and self.dailies[title]) or (prdb.automaticAccept == 3 and not self.dailies[title])) then
			button:Click()
		elseif button.type == "Active" and prdb.automaticTurnIn and ((self.questsTitleToqid[title] and (self.quests[self.questsTitleToqid[title]].complete[self.playerName] == 1 or not self.questsObjectives[self.questsTitleToqid[title]])) or (not self.questsTitleToqid[title])) then
			button:Click()
		end
	end
end

function tomQuest2:loopAvailableQuests(...)
	local numQuests = select('#', ...)
	if numQuests == 0 then return end
	for i = 1, numQuests, 3 do
		local title, level, trivial = select(i, ...)
		local buttonName = "GossipTitleButton"..self.buttonIndex
		local titleButton = _G[buttonName]
		local gossipButton = _G[buttonName.."GossipIcon"]
		titleButton.title = title
		gossipButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
		gossipButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "availabledaily" or "available"]))
		gossipButton:SetVertexColor(1, 1, 1, 1)
		if prdb.addQuestLevel then
			local color = self:getDifficultyColor(level - self.playerLevel)
			titleButton:SetFormattedText(trivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, self.dailies[title] and prdb.daily or "", prdb.questTitleColor, title)
			titleButton:SetHeight(titleButton:GetTextHeight() + 2)
		end
		self.buttonIndex = self.buttonIndex + 1
	end
	self.buttonIndex = self.buttonIndex + 1
end

function tomQuest2:loopActiveQuests(...)
	local numQuests = select('#', ...)
	if numQuests == 0 then return end
	for i = 1, numQuests, 3 do
		local title, level, trivial = select(i, ...)
		local buttonName = "GossipTitleButton"..self.buttonIndex
		local titleButton = _G[buttonName]
		local gossipButton = _G[buttonName.."GossipIcon"]
		titleButton.title = title
		if prdb.fadeNotCompletedQuests then
			local qid = self.questsTitleToqid[title]
			if qid and self.quests[qid].playerComplete == 0 then
				gossipButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
				gossipButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "activedaily" or "active"]))
				gossipButton:SetVertexColor(0.5, 0.5, 0.5, 0.5)
			else
				gossipButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
				gossipButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "activedaily" or "active"]))
				gossipButton:SetVertexColor(1, 1, 1, 1)
			end
		else
			gossipButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
			gossipButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "activedaily" or "active"]))
			gossipButton:SetVertexColor(1, 1, 1, 1)
		end
		if prdb.addQuestLevel then
			local color = self:getDifficultyColor(level - self.playerLevel)
			titleButton:SetFormattedText(trivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, self.dailies[title] and prdb.daily or "", prdb.questTitleColor, title)
			titleButton:SetHeight(titleButton:GetTextHeight() + 2)
		end
		self.buttonIndex = self.buttonIndex + 1
	end
	self.buttonIndex = tomQuest2.buttonIndex + 1
end

function tomQuest2:loopOptions(...)
	for i=1, select("#", ...), 2 do
		_G["GossipTitleButton"..self.buttonIndex.."GossipIcon"]:SetTexCoord(0, 1, 0, 1)
		self.buttonIndex = self.buttonIndex + 1
	end
end

function tomQuest2:GOSSIP_SHOW()
	self.buttonIndex = 1
	self:loopAvailableQuests(GetGossipAvailableQuests())
	self:loopActiveQuests(GetGossipActiveQuests())
	self:loopOptions(GetGossipOptions())
	if IsShiftKeyDown() then return end
	for i = 1, self.buttonIndex do
		self:clickQuest(_G["GossipTitleButton" .. i])
	end
end

function tomQuest2:QUEST_GREETING()
	local numActive, numAvailable = GetNumActiveQuests() or 0, GetNumAvailableQuests() or 0
	self.buttonIndex = 0
	for i = 1, numActive do
		self.buttonIndex = self.buttonIndex + 1
		local title = GetActiveTitle(i)
		local buttonName = "QuestTitleButton"..self.buttonIndex
		local titleButton = _G[buttonName]
		local questButton = _G[buttonName.."QuestIcon"]
		titleButton.title = title
		if prdb.fadeNotCompletedQuests then
			local qid = self.questsTitleToqid[title]
			if qid and self.quests[qid].playerComplete == 0 then
				questButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
				questButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "activedaily" or "active"]))
				questButton:SetVertexColor(0.5, 0.5, 0.5, 0.5)
			else
				questButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
				questButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "activedaily" or "active"]))
				questButton:SetVertexColor(1, 1, 1, 1)
			end
		else
			questButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
			questButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "activedaily" or "active"]))
			questButton:SetVertexColor(1, 1, 1, 1)
		end
		if prdb.addQuestLevel then
			local level = GetActiveLevel(i)
			local color = self:getDifficultyColor(level - self.playerLevel)
			local trivial = IsActiveQuestTrivial(i)
			titleButton:SetFormattedText(trivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, self.dailies[title] and prdb.daily or "", prdb.questTitleColor, title)
			titleButton:SetHeight(titleButton:GetTextHeight() + 2)
		end
	end
	for i = 1, numAvailable do
		self.buttonIndex = self.buttonIndex + 1
		local title = GetAvailableTitle(i)
		local buttonName = "QuestTitleButton"..self.buttonIndex
		local titleButton = _G[buttonName]
		local questButton = _G[buttonName.."QuestIcon"]
		titleButton.title = title
		questButton:SetTexture("Interface\\MiniMap\\ObjectIcons")
		questButton:SetTexCoord(unpack(texCoords[self.dailies[title] and "availabledaily" or "available"]))
		questButton:SetVertexColor(1, 1, 1, 1)
		if prdb.addQuestLevel then
			local level = GetAvailableLevel(i)
			local color = self:getDifficultyColor(level - self.playerLevel)
			local trivial = IsAvailableQuestTrivial(i)
			titleButton:SetFormattedText(trivial and trivialText or normalText, 255*color.r, 255*color.g, 255*color.b, level == -1 and "*" or level, self.dailies[title] and prdb.daily or "", prdb.questTitleColor, title)
			titleButton:SetHeight(titleButton:GetTextHeight() + 2)
		end
	end
	if IsShiftKeyDown() then return end
	for i = 1, self.buttonIndex do
		self:clickQuest(_G['QuestTitleButton' .. i])
	end
end

function tomQuest2:QUEST_DETAIL()
	local title = GetTitleText()
	if not IsShiftKeyDown() and (prdb.automaticAccept == 1 or (prdb.automaticAccept == 2 and self.dailies[title]) or (prdb.automaticAccept == 3 and not self.dailies[title])) and not self.forbiddenQuests[title] then
		AcceptQuest()
	end
end

function tomQuest2:QUEST_COMPLETE(event)
	if not IsShiftKeyDown() and prdb.automaticTurnIn and GetNumQuestChoices() <= 1 then
		GetQuestReward(QuestFrameRewardPanel.itemChoice)
	end
end

function tomQuest2:QUEST_PROGRESS()
	if not IsShiftKeyDown() and prdb.automaticTurnIn and IsQuestCompletable() then
		CompleteQuest()
	end
end

function tomQuest2:QUEST_ACCEPT_CONFIRM()
	if not IsShiftKeyDown() and prdb.automaticAcceptEscort then
		ConfirmAcceptQuest()
	end
end

---------------------------------
--- Achievements Trade Skills ---
---------------------------------
local function tradeSkillOnEnter(self)
	if self.critId then
		local aid = GetAchievementCriteriaInfo(self.critId)
		if tomQuest2.achievementIcon[aid] and tomQuest2.achievementName[aid] then
			GameTooltip:SetOwner(self, "ANCHOR_NONE")
			GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
			GameTooltip:AddLine(format("|T%s:0|t %s", tomQuest2.achievementIcon[aid], tomQuest2.achievementName[aid]), 1, 0, 0)
			GameTooltip:Show()
		end
	end
end

local function mrtButtonOnEnter(self)
	if self.critId then
		local aid = GetAchievementCriteriaInfo(self.critId)
		if tomQuest2.achievementIcon[aid] and tomQuest2.achievementName[aid] then
			GameTooltip:AddLine(format("|T%s:0|t %s", tomQuest2.achievementIcon[aid], tomQuest2.achievementName[aid]), 1, 0, 0)
			GameTooltip:Show()
		end
	end
end

local function skilletButtonOnEnter(self)
	if self.critId then
		local aid = GetAchievementCriteriaInfo(self.critId)
		if tomQuest2.achievementIcon[aid] and tomQuest2.achievementName[aid] then
			SkilletTradeskillTooltip:AddLine(format("|T%s:0|t %s", tomQuest2.achievementIcon[aid], tomQuest2.achievementName[aid]), 1, 0, 0)
			SkilletTradeskillTooltip:Show()
		end
	end
end

local function atswButtonOnEnter(self)
	if self.critId then
		local aid = GetAchievementCriteriaInfo(self.critId)
		if tomQuest2.achievementIcon[aid] and tomQuest2.achievementName[aid] then
			ATSWTradeskillTooltip:AddLine(format("|T%s:0|t %s", tomQuest2.achievementIcon[aid], tomQuest2.achievementName[aid]), 1, 0, 0)
			ATSWTradeskillTooltip:Show()
		end
	end
end

function tomQuest2:updateTradeSkillButton(skillName, button, highlightButton, hook, onEnter)
	button.critId = self.achievementsTradeSkills[skillName]
	if button.critId then
		local _, _, _, completed = GetAchievementCriteriaInfo(button.critId)
		if not completed then
			button:SetNormalTexture(self.achievementIcon[self.achievementsTradeSkills[skillName]])
			highlightButton:SetTexture(self.achievementIcon[self.achievementsTradeSkills[skillName]])
			if hook then
				if not button.hooked then
					button:HookScript("OnEnter", onEnter)
					button.hooked = true
				end
			else
				button:SetScript("OnEnter", onEnter)
				button:SetScript("OnLeave", onLeave)
			end
		else
			button:SetNormalTexture("")
			highlightButton:SetTexture("")
		end
	else
		button:SetNormalTexture("")
		highlightButton:SetTexture("")
	end
end

function tomQuest2:TradeSkillFrame_Update()
	local tradeSkillName = GetTradeSkillLine()
	if tradeSkillName == self.cooking then
		local offset = FauxScrollFrame_GetOffset(TradeSkillListScrollFrame)
		for i = 1, TRADE_SKILLS_DISPLAYED do
			local skillName, skillType = GetTradeSkillInfo(i + offset)
			if skillType ~= "header" then
				self:updateTradeSkillButton(skillName, _G["TradeSkillSkill"..i], _G["TradeSkillSkill"..i.."Highlight"], false, tradeSkillOnEnter)
			end
		end
	end
end

function tomQuest2:UpdateSkillList()
	local tradeSkillName = GetTradeSkillLine()
	if tradeSkillName == self.cooking then
		local offset = FauxScrollFrame_GetOffset(MRTSkillListScrollFrame)
		for i = 1, 11 do
			local skillName, skillType = GetTradeSkillInfo(i + offset)
			if skillType ~= "header" then
				self:updateTradeSkillButton(skillName, _G["MRTSkillButton"..i], _G["MRTSkillButton"..i.."Highlight"], true, mrtButtonOnEnter)
			end
		end
	end
end

function tomQuest2:internal_UpdateTradeSkillWindow()
	local tradeSkillName = GetTradeSkillLine()
	if tradeSkillName == self.cooking then
		local offset = FauxScrollFrame_GetOffset(SkilletSkillList)
		for i = 1, floor(SkilletSkillList:GetHeight() / SKILLET_TRADE_SKILL_HEIGHT) do
			local skillName, skillType = GetTradeSkillInfo(i + offset)
			if skillType ~= "header" then
				self:updateTradeSkillButton(skillName, _G["SkilletScrollButton"..i], _G["SkilletScrollButton"..i.."Highlight"], true, skilletButtonOnEnter)
				_G["SkilletScrollButton"..i.."Level"]:SetWidth(20)
			end
		end
	end
end

function tomQuest2:ATSWFrame_Update()
	if not ATSWFrame:IsVisible() then return end
	local tradeSkillName = GetTradeSkillLine()
	if tradeSkillName == self.cooking then
		local offset = FauxScrollFrame_GetOffset(ATSWListScrollFrame)
		for i = 1, ATSW_TRADE_SKILLS_DISPLAYED do
			local skillName, skillType = GetTradeSkillInfo(i + offset)
			if skillType ~= "header" then
				self:updateTradeSkillButton(skillName, _G["ATSWSkill"..i], _G["ATSWSkill"..i.."Highlight"], true, atswButtonOnEnter)
			end
		end
	end
end

function tomQuest2:ADDON_LOADED(event, addon)
	if addon == "Blizzard_TradeSkillUI" then
		self:SecureHook("TradeSkillFrame_Update")
	elseif addon == "MrTrader_SkillWindow" then
		self:SecureHook(MRTSkillWindow, "UpdateSkillList")
	elseif addon == "Skillet" then
		self:SecureHook(Skillet, "internal_UpdateTradeSkillWindow")
	elseif addon == "AdvancedTradeSkillWindow" then
		self:SecureHook("ATSWFrame_Update")
	else
		return
	end
	self:UnregisterEvent("ADDON_LOADED")
end

-------------------
--- tagQuestLog ---
-------------------
function tomQuest2:blizzQuestLogUpdate()
	if not QuestLogFrame:IsShown() then return end
	local buttons = QuestLogScrollFrame.buttons
	local numEntries, numQuests = GetNumQuestLogEntries()
	for i = 1, #buttons do
		local questLogTitle = buttons[i]
		local index = questLogTitle:GetID()
		if index > numEntries then break end
		local _, _, _, _, _, _, _, _, qid = GetQuestLogTitle(index)
		if qid and self.quests[qid] then
			questLogTitle:SetFormattedText("  %s%s", self.quests[qid].tag, self.quests[qid].title)
			questLogTitle.tag:Hide()
			questLogTitle.groupMates:SetText(gsub((questLogTitle.groupMates:GetText() or ""), "[<>]", self.repl))
			QuestLogTitleButton_Resize(questLogTitle)
		end
	end
end

--------------------------
--- Quests information ---
--------------------------
local function tq2LhOnUpdateFix(self, elapsed)
	tq2LhFrame.text:SetText(lhCurrentText)
	tq2LhFrame:SetScript("OnUpdate", nil)
end

local function setTq2LhText(msg)
	lhCurrentText = msg
	tq2LhFrame:SetScript("OnUpdate", tq2LhOnUpdateFix)
end

local function updateTq2LhTextSize()
	local width = tomQuest2LhFrame:GetWidth() - 65
	tq2LhFrame.text:SetWidth(width)
	setTq2LhText(lhCurrentText)
end

local function tq2QlOnUpdateFix(self, elapsed)
	tq2QlFrame.text:SetText(qlCurrentText)
	tq2QlFrame:SetScript("OnUpdate", nil)
end

local function setTq2QlText(msg)
	qlCurrentText = msg
	tq2QlFrame:SetScript("OnUpdate", tq2QlOnUpdateFix)
end

local function updateTq2QlTextSize()
	local width = tomQuest2QlFrame:GetWidth() - 65
	tq2QlFrame.text:SetWidth(width)
	setTq2QlText(qlCurrentText)
end

local function onCloseClick(self, button)
	tomQuest2.currentQid = nil
	self:GetParent():Hide()
end

local close = CreateFrame("Button", nil, nil, "UIPanelCloseButton")
close:SetScript("OnClick", onCloseClick)

local closeQL = CreateFrame("Button", nil, nil, "UIPanelCloseButton")
closeQL:SetScript("OnClick", onCloseClick)

local function onResizeEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
	GameTooltip:SetText(LC["Click to resize tomQuest2"])
	GameTooltip:Show()
end

local function onResizeMouseDown(self, button)
	self:GetParent():StartSizing()
end

local function onMouseUp(self, button)
	local parentFrame = self:GetParent()
	local name = parentFrame:GetName()
	parentFrame:StopMovingOrSizing()
	local width = parentFrame:GetWidth()
	local height = parentFrame:GetHeight()
	if name == "tomQuest2ParentFrame" then
		local halfWidth = width/2
		tq2QlFrame:SetWidth(halfWidth)
		tq2LhFrame:SetWidth(halfWidth)
		tq2QlFrame:SetHeight(height)
		tq2LhFrame:SetHeight(height)
		updateTq2QlTextSize()
		updateTq2LhTextSize()
	elseif name == "tomQuest2LhFrame" then
		updateTq2LhTextSize()
	elseif name == "tomQuest2QlFrame" then
		updateTq2QlTextSize()
	end
	prdb[name].point = "BOTTOMLEFT"
	prdb[name].x = parentFrame:GetLeft()
	prdb[name].y = parentFrame:GetBottom()
	prdb[name].width = width
	prdb[name].height = height
end

local resize = CreateFrame("Button")
resize:SetNormalTexture("Interface\\AddOns\\tomQuest2\\media\\Resize")
resize:SetHighlightTexture("Interface\\AddOns\\tomQuest2\\media\\Resize")
resize:SetHeight(12)
resize:SetWidth(12)
resize:SetScript("OnEnter", onResizeEnter)
resize:SetScript("OnLeave", onLeave)
resize:SetScript("OnMouseDown", onResizeMouseDown)
resize:SetScript("OnMouseUp", onMouseUp)

local resizeQL = CreateFrame("Button")
resizeQL:SetNormalTexture("Interface\\AddOns\\tomQuest2\\media\\Resize")
resizeQL:SetHighlightTexture("Interface\\AddOns\\tomQuest2\\media\\Resize")
resizeQL:SetHeight(12)
resizeQL:SetWidth(12)
resizeQL:SetScript("OnEnter", onResizeEnter)
resizeQL:SetScript("OnLeave", onLeave)
resizeQL:SetScript("OnMouseDown", onResizeMouseDown)
resizeQL:SetScript("OnMouseUp", onMouseUp)

local function onMovingMouseDown(self, button)
	self:GetParent():StartMoving()
end

local titlereg = CreateFrame("Button")
titlereg:SetHeight(20)
titlereg:SetScript("OnMouseDown", onMovingMouseDown)
titlereg:SetScript("OnMouseUp", onMouseUp)

local titleregQL = CreateFrame("Button")
titleregQL:SetHeight(20)
titleregQL:SetScript("OnMouseDown", onMovingMouseDown)
titleregQL:SetScript("OnMouseUp", onMouseUp)

local function onIconClick(self, button)
	StaticPopup_Show("LIGHTHEADED_ABOUT_DIALOG")
end

local function onPrevEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
	GameTooltip:SetText(LC["Previous page"])
	GameTooltip:Show()
end

local function onPrevClick(self, button)
	if tomQuest2.currentPage then
		tomQuest2:updateQuestsLightHeadedInformations(tomQuest2.currentQid, tomQuest2.currentPage - 1)
	end
end

local function onNextEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
	GameTooltip:SetText(LC["Next page"])
	GameTooltip:Show()
end

local function onNextClick(self, button)
	if tomQuest2.currentPage then
		tomQuest2:updateQuestsLightHeadedInformations(tomQuest2.currentQid, tomQuest2.currentPage + 1)
	end
end

local function onDisableClick(self, button)
	if tomQuest2.quests[tomQuest2.currentQid].id then
		local wasSelected = GetQuestLogSelection()
		SelectQuestLogEntry(tomQuest2.quests[tomQuest2.currentQid].id)
		SetAbandonQuest()
		local items = GetAbandonQuestItems()
		if items then
			StaticPopup_Hide("ABANDON_QUEST")
			StaticPopup_Show("ABANDON_QUEST_WITH_ITEMS", GetAbandonQuestName(), items)
		else
			StaticPopup_Hide("ABANDON_QUEST_WITH_ITEMS")
			StaticPopup_Show("ABANDON_QUEST", GetAbandonQuestName())
		end
		SelectQuestLogEntry(wasSelected)
	end
end

local function onShareClick(self, button)
	local wasSelected = GetQuestLogSelection()
	SelectQuestLogEntry(tomQuest2.quests[tomQuest2.currentQid].id)
	QuestLogPushQuest()
	SelectQuestLogEntry(wasSelected)
end

local function onHyperlinkClick(self, link)
	if not link then return end
	if link:match("^lhref:npc") then
		tomQuest2.stack[#(tomQuest2.stack)+1] = tomQuest2.currentPage
		tomQuest2.stack[#(tomQuest2.stack)+1] = tomQuest2.currentQid
		local id, name = link:match("^lhref:npc:(.+):(.+)$")
		id = tonumber(id)
		if LightHeaded:LoadNPCData(id) then
			local tIndex = 1
			tomQuest2.tempTable[tIndex] = "|cFF0066FF|Hlhref:back|h[Back]|h|r\n\n\n"..LC["Known locations for "].."|cFFFFFFFF"..name.."|r:"
			for c, z, x, y in LightHeaded:IterateNPCLocs(id) do
				tIndex = tIndex + 1
				tomQuest2.tempTable[tIndex] = "|cFF0066FF|Hlhref:zcoord:"..c..":"..z..":"..x..":"..y..":"..name.."|h["..LightHeaded:GetCoordText(x, y).."]|h|r"
			end
			setTq2LhText(tconcat(tomQuest2.tempTable, "\n", 1, tIndex))
		else
			setTq2LhText("|cFF0066FF|Hlhref:back|h[Back]|h|r\n\n\n"..LC["Location unknown"].."|cFFFFFFFF"..name.."|r")
		end
		tq2LhFrame.next:Disable()
		tq2LhFrame.prev:Disable()
	elseif link:match("^lhref:coord") then
		local xt, yt, qid = link:match("^lhref:coord:([^:]+):([^:]+):(.+)")
		local x = tonumber(xt)
		local y = tonumber(yt)
		if not x or not y then
			self:Print(format(LC["The coordinate you clicked on was not valid: %s"], link))
			return
		end
		local note
		if not tonumber(qid) then
			note = qid
		else
			note = "[LH] "..LightHeaded:GetQuestName(qid)
		end
		if TomTom then
			TomTom:AddWaypoint(x, y, note)
		elseif Cartographer_Waypoints and type(Cartographer_Waypoints.AddLHWaypoint) == "function" then
			Cartographer_Waypoints:AddLHWaypoint(nil, nil, x, y, note)
		elseif MN_ThottInterface and type(MN_ThottInterface_Local) == "function" then
			MN_ThottInterface_Local(x, y, note)
		elseif Cartographer_Waypoints then
			self:Print(LC["LightHeaded waypoints are not supported in this version of Cartographer_Waypoints."])
		end
	elseif link:match("^lhref:zcoord") then
		local c, z, x, y, qid = link:match("^lhref:zcoord:([^:]+):([^:]+):([^:]+):([^:]+):(.+)")
		c, z, x, y = tonumber(c), tonumber(z), tonumber(x), tonumber(y)
		local note
		if not tonumber(qid) then
			note = qid
		else
			note = "[LH]"..LightHeaded:GetQuestName(qid)
		end
		if TomTom and type(TomTom.AddZWaypoint) == "function" then
			TomTom:AddZWaypoint(c, z, x, y, note)
		elseif Cartographer_Waypoints and type(Cartographer_Waypoints.AddLHWaypoint) == "function" then
			Cartographer_Waypoints:AddLHWaypoint(c, z, x, y, note)
		elseif MN_ThottInterface and type(MN_ThottInterface_Legacy) == "function" then
			MN_ThottInterface_Legacy(c, z, x, y, note)
		
		elseif TomTom then
			self:Print(LC["NPC locations are not supported in this version of TomTom."])
		elseif Cartographer_Waypoints then
			self:Print(LC["LightHeaded waypoints are not supported in this version of Cartographer_Waypoints."])
		end
	elseif link:match("^lhref:external") then
		local url = link:match("^lhref:external:(.+)$")
		ChatFrameEditBox:Show()
		ChatFrameEditBox:SetText(url)
		ChatFrameEditBox:SetFocus()
	elseif link:match("^lhref:quest:") then
		tomQuest2.stack[#(tomQuest2.stack)+1] = tomQuest2.currentPage
		tomQuest2.stack[#(tomQuest2.stack)+1] = tomQuest2.currentQid
		local qid = link:match("^lhref:quest:(.+)$")
		qid = tonumber(qid)
		if prdb.showAllCommentsOnOnePage then
			tomQuest2:updateQuestsLightHeadedInformations(qid, 0)
			tq2LhFrame.next:Hide()
			tq2LhFrame.prev:Hide()
			tq2LhFrame.page:Hide()
		else
			tomQuest2:updateQuestsLightHeadedInformations(qid, 1)
		end
	elseif link:match("^lhref:back$") then
		local qid = tremove(tomQuest2.stack)
		local page = tremove(tomQuest2.stack)
		tomQuest2:updateQuestsLightHeadedInformations(qid, page)
	elseif link:match("^lhref:item:") or link:match("^item:") then
		if link:match("^lhref:item:") then
			link = link:sub(7)
		end
		local name, chatLink = GetItemInfo(link)
		if name then
			if IsControlKeyDown() then
				DressUpItemLink(link)
			elseif IsShiftKeyDown() and ChatFrameEditBox:IsVisible() then
				ChatFrameEditBox:Insert(chatLink)
			else
				SetItemRef(link)
			end
		end
	elseif not link:match("^lhref:spell:(%d+)") then
		self:Print(format(LC["Unmanaged lhref:%s "], link))
	end
end

local function onHyperlinkEnter(self, link)
	if not link then return end
	if link:match("^lhref:item") then
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(link:sub(7))
	elseif link:match("^item") then
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetHyperlink(link)
	elseif link:match("^lhref:spell:(%d+)") then
		local qid = tonumber(link:match("^lhref:spell:(%d+)"))
		if not qid then return end
		GameTooltip:SetOwner(self,"ANCHOR_CURSOR")
		GameTooltip:SetQuestLogRewardSpell(tomQuest2.quests[qid].id)
	end
end

function tomQuest2:createLhGUI()
	if tq2LhFrame then return end
	tq2LhFrame = CreateFrame("Frame", "tomQuest2LhFrame", UIParent)
	UISpecialFrames[#UISpecialFrames+1] = "tomQuest2LhFrame"
	tq2LhFrame:SetWidth(640)
	tq2LhFrame:SetHeight(512)
	tq2LhFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = {left = 5, right = 5, top = 5, bottom = 5}, tile = true, tileSize = 16})
	tq2LhFrame:SetBackdropColor(prdb.backDropColor[1], prdb.backDropColor[2], prdb.backDropColor[3], prdb.backDropColor[4])

	tq2LhFrame:EnableMouse()
	tq2LhFrame:SetMovable(1)
	tq2LhFrame:SetResizable(1)
	tq2LhFrame:SetMinResize(300, 300)
	tq2LhFrame:SetWidth(400)
	tq2LhFrame:SetFrameLevel(0)
	tq2LhFrame:SetWidth(325)
	tq2LhFrame:SetHeight(450)

	local icon = CreateFrame("Button", nil, tq2LhFrame)
	icon:SetHeight(64)
	icon:SetWidth(64)
	icon:SetNormalTexture("Interface\\AddOns\\LightHeaded\\images\\wh_icon")
	icon:SetHighlightTexture("Interface\\AddOns\\LightHeaded\\images\\wh_icon_hover")
	icon:GetHighlightTexture():SetBlendMode("BLEND")
	icon:SetPoint("BOTTOMRIGHT", -10, -10)
	icon:SetScript("OnClick", onIconClick)

	tq2LhFrame.page = tq2LhFrame:CreateFontString(nil, "ARTWORK")
	tq2LhFrame.page:SetFontObject(GameFontNormalSmall)
	tq2LhFrame.page:SetPoint("BOTTOM", -32, 15)

	tq2LhFrame.prev = CreateFrame("Button", nil, tq2LhFrame)
	tq2LhFrame.prev:SetWidth(21)
	tq2LhFrame.prev:SetHeight(21)
	tq2LhFrame.prev:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up")
	tq2LhFrame.prev:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down")
	tq2LhFrame.prev:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled")
	tq2LhFrame.prev:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
	tq2LhFrame.prev:SetPoint("RIGHT", tq2LhFrame.page, "LEFT", -25, 0)
	tq2LhFrame.prev:SetScript("OnEnter", onPrevEnter)
	tq2LhFrame.prev:SetScript("OnLeave", onLeave)
	tq2LhFrame.prev:SetScript("OnClick", onPrevClick)

	tq2LhFrame.next = CreateFrame("Button", nil, tq2LhFrame)
	tq2LhFrame.next:SetWidth(21)
	tq2LhFrame.next:SetHeight(21)
	tq2LhFrame.next:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up")
	tq2LhFrame.next:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down")
	tq2LhFrame.next:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled")
	tq2LhFrame.next:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
	tq2LhFrame.next:SetPoint("LEFT", tq2LhFrame.page, "RIGHT", 25, 0)
	tq2LhFrame.next:SetScript("OnEnter", onNextEnter)
	tq2LhFrame.next:SetScript("OnLeave", onLeave)
	tq2LhFrame.next:SetScript("OnClick", onNextClick)

	tq2LhFrame.title = tq2LhFrame:CreateFontString(nil, "ARTWORK")
	tq2LhFrame.title:SetPoint("TOP", 0, -4)
	tq2LhFrame.title:SetFontObject(GameFontHighlight)
	tq2LhFrame.title:SetText("tomQuest2 - LightHeaded")

	local scroll = CreateFrame("ScrollFrame", "tomQuest2LhScrollFrame", tq2LhFrame, "UIPanelScrollFrameTemplate")
	scroll:SetPoint("TOPLEFT", 30, -30)
	scroll:SetPoint("BOTTOMRIGHT", -35, 55)

	tq2LhFrame.text = CreateFrame("SimpleHTML", "tomQuest2LhSimpleHTML", tq2LhFrame.scroll)
	tq2LhFrame.text:SetPoint("TOPLEFT", 0, 0)
	tq2LhFrame.text:SetHeight(300)
	tq2LhFrame.text:SetFontObject(GameFontHighlight)
	tq2LhFrame.text:SetScript("OnHyperlinkClick", onHyperlinkClick)
	tq2LhFrame.text:SetScript("OnHyperlinkEnter", onHyperlinkEnter)
	tq2LhFrame.text:SetScript("OnHyperlinkLeave", onLeave)
	scroll:SetScrollChild(tq2LhFrame.text)

	tq2LhFrame:SetAlpha(1)
	self:lockUnlockLhFrame()
end

function tomQuest2:createQlGUI()
	if tq2QlFrame then return end
	tq2QlFrame = CreateFrame("Frame", "tomQuest2QlFrame", UIParent)
	UISpecialFrames[#UISpecialFrames+1] = "tomQuest2QlFrame"
	tq2QlFrame:SetWidth(640)
	tq2QlFrame:SetHeight(512)
	tq2QlFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = {left = 5, right = 5, top = 5, bottom = 5}, tile = true, tileSize = 16})
	tq2QlFrame:SetBackdropColor(prdb.backDropColor[1], prdb.backDropColor[2], prdb.backDropColor[3], prdb.backDropColor[4])
	tq2QlFrame:EnableMouse()
	tq2QlFrame:SetMovable(1)
	tq2QlFrame:SetResizable(1)
	tq2QlFrame:SetMinResize(300, 300)
	tq2QlFrame:SetWidth(400)
	tq2QlFrame:SetFrameLevel(0)
	tq2QlFrame:SetWidth(325)
	tq2QlFrame:SetHeight(450)

	tq2QlFrame.title = tq2QlFrame:CreateFontString(nil, "ARTWORK")
	tq2QlFrame.title:SetPoint("TOP", 0, -4)
	tq2QlFrame.title:SetFontObject(GameFontHighlight)
	tq2QlFrame.title:SetText("tomQuest2 - Quest Log")

	local scroll = CreateFrame("ScrollFrame", "tomQuest2QlScrollFrame", tq2QlFrame, "UIPanelScrollFrameTemplate")
	scroll:SetPoint("TOPLEFT", 30, -30)
	scroll:SetPoint("BOTTOMRIGHT", -35, 55)

	tq2QlFrame.text = CreateFrame("SimpleHTML", "tomQuest2QlSimpleHTML", tq2QlFrame.scroll)
	tq2QlFrame.text:SetPoint("TOPLEFT", 0, 0)
	tq2QlFrame.text:SetHeight(300)
	tq2QlFrame.text:SetFontObject(GameFontHighlight)
	tq2QlFrame.text:SetScript("OnHyperlinkClick", onHyperlinkClick)
	tq2QlFrame.text:SetScript("OnHyperlinkEnter", onHyperlinkEnter)
	tq2QlFrame.text:SetScript("OnHyperlinkLeave", onLeave)
	scroll:SetScrollChild(tq2QlFrame.text)

	tq2QlFrame.abandon = CreateFrame("Button", "tq2QlAbandonFrame", tq2QlFrame, "UIPanelButtonTemplate")
	tq2QlFrame.abandon:SetWidth(125)
	tq2QlFrame.abandon:SetHeight(21)
	tq2QlFrame.abandon:SetPoint("BOTTOMLEFT", tq2QlFrame, "BOTTOMLEFT", 15, 10)
	tq2QlFrame.abandon:SetText(ABANDON_QUEST)
	tq2QlFrame.abandon:SetScript("OnClick", onDisableClick)

	tq2QlFrame.share = CreateFrame("Button", "tq2QlShareFrame", tq2QlFrame, "UIPanelButtonTemplate")
	tq2QlFrame.share:SetWidth(125)
	tq2QlFrame.share:SetHeight(21)
	tq2QlFrame.share:SetPoint("BOTTOMRIGHT", tq2QlFrame, "BOTTOMRIGHT", -15, 10)
	tq2QlFrame.share:SetText(SHARE_QUEST)
	tq2QlFrame.share:SetScript("OnClick", onShareClick)

	tq2QlFrame:SetAlpha(1)
	self:lockUnlockQlFrame()
end

function tomQuest2:lockUnlockQlFrame()
	tq2QlFrame:ClearAllPoints()
	if prdb.showQuestLog and prdb.showLightHeaded and LightHeaded and (prdb.attach == 1 or prdb.attach == 2) then
		if not tq2ParentFrame then
			tq2ParentFrame = CreateFrame("frame", "tomQuest2ParentFrame", UIParent)
			tq2ParentFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = {left = 5, right = 5, top = 5, bottom = 5}, tile = true, tileSize = 16})
			tq2ParentFrame:SetBackdropColor(prdb.backDropColor[1], prdb.backDropColor[2], prdb.backDropColor[3], prdb.backDropColor[4])
			tq2ParentFrame:SetBackdropBorderColor(prdb.borderColor[1], prdb.borderColor[2], prdb.borderColor[3], prdb.borderColor[4])
			UISpecialFrames[#UISpecialFrames+1] = "tomQuest2ParentFrame"
			tq2ParentFrame:EnableMouse()
			tq2ParentFrame:SetMovable(1)
			tq2ParentFrame:SetResizable(1)
			tq2ParentFrame:SetMinResize(600, 300)
			tq2ParentFrame:SetFrameLevel(0)
			tq2ParentFrame:SetWidth(prdb["tomQuest2ParentFrame"].width)
			tq2ParentFrame:SetHeight(prdb["tomQuest2ParentFrame"].height)
		end
		close:SetParent(tq2ParentFrame)
		close:SetPoint("TOPRIGHT")
		resize:SetParent(tq2ParentFrame)
		resize:SetPoint("BOTTOMRIGHT", -3, 3)
		titlereg:SetParent(tq2ParentFrame)
		titlereg:SetPoint("TOPLEFT", 5, -5)
		titlereg:SetPoint("TOPRIGHT", 0, 0)
		tq2ParentFrame:SetAlpha(1)
		tq2ParentFrame:SetFrameStrata("HIGH")
		tq2QlFrame:SetParent(tomQuest2ParentFrame)
		tq2QlFrame:SetBackdropColor(0, 0, 0, 0)
		tq2QlFrame:SetBackdropBorderColor(0, 0, 0, 0)
		self:restorePosition("tomQuest2ParentFrame")
		tq2QlFrame:SetWidth(prdb["tomQuest2ParentFrame"].width / 2)
		tq2QlFrame:SetHeight(prdb["tomQuest2ParentFrame"].height)
		closeQL:Hide()
		resizeQL:Hide()
		titleregQL:Hide()
		if prdb.attach == 1 then
			tq2QlFrame:SetPoint("TOPLEFT")
			tq2QlFrame:SetPoint("BOTTOMLEFT")
		elseif prdb.attach == 2 then
			tq2QlFrame:SetPoint("TOPRIGHT")
			tq2QlFrame:SetPoint("BOTTOMRIGHT")
		end
		updateTq2QlTextSize()
	elseif prdb.showQuestLog then
		tq2QlFrame:SetParent(UIParent)
		closeQL:SetParent(tq2QlFrame)
		closeQL:SetPoint("TOPRIGHT")
		closeQL:Show()
		resizeQL:SetParent(tq2QlFrame)
		resizeQL:SetPoint("BOTTOMRIGHT", -3, 3)
		resizeQL:Show()
		titleregQL:SetParent(tq2QlFrame)
		titleregQL:SetPoint("TOPLEFT", 5, -5)
		titleregQL:SetPoint("TOPRIGHT", 0, 0)
		titleregQL:Show()
		if tq2ParentFrame then
			tq2ParentFrame:Hide()
		end
		tq2QlFrame:SetAlpha(1)
		tq2QlFrame:SetBackdropColor(prdb.backDropColor[1], prdb.backDropColor[2], prdb.backDropColor[3], prdb.backDropColor[4])
		tq2QlFrame:SetBackdropBorderColor(prdb.borderColor[1], prdb.borderColor[2], prdb.borderColor[3], prdb.borderColor[4])
		tq2QlFrame:SetFrameStrata("HIGH")
		self:restorePosition("tomQuest2QlFrame")
		updateTq2QlTextSize()
	elseif not prdb.showQuestLog then
		tq2QlFrame:Hide()
	end
end

function tomQuest2:lockUnlockLhFrame()
	tq2LhFrame:ClearAllPoints()
	if prdb.showQuestLog and LightHeaded and prdb.showLightHeaded and (prdb.attach == 1 or prdb.attach == 2) then
		tq2LhFrame:SetParent(tq2ParentFrame)
		tq2LhFrame:SetBackdropColor(0, 0, 0, 0)
		tq2LhFrame:SetBackdropBorderColor(0, 0, 0, 0)
		tq2LhFrame:SetWidth(prdb["tomQuest2ParentFrame"].width / 2)
		tq2LhFrame:SetHeight(prdb["tomQuest2ParentFrame"].height)
		if prdb.attach == 1 then
			tq2LhFrame:SetPoint("TOPRIGHT")
			tq2LhFrame:SetPoint("BOTTOMRIGHT")
		elseif prdb.attach == 2 then
			tq2LhFrame:SetPoint("TOPLEFT")
			tq2LhFrame:SetPoint("BOTTOMLEFT")
		end
		updateTq2LhTextSize()
	elseif (prdb.showLightHeaded and LightHeaded) then
		tq2LhFrame:SetParent(UIParent)
		close:SetParent(tq2LhFrame)
		close:SetPoint("TOPRIGHT")
		resize:SetParent(tq2LhFrame)
		resize:SetPoint("BOTTOMRIGHT", -3, 3)
		titlereg:SetParent(tq2LhFrame)
		titlereg:SetPoint("TOPLEFT", 5, -5)
		titlereg:SetPoint("TOPRIGHT", 0, 0)
		if tq2ParentFrame then
			tq2ParentFrame:Hide()
		end
		tq2LhFrame:SetAlpha(1)
		tq2LhFrame:SetBackdropColor(prdb.backDropColor[1], prdb.backDropColor[2], prdb.backDropColor[3], prdb.backDropColor[4])
		tq2LhFrame:SetBackdropBorderColor(prdb.borderColor[1], prdb.borderColor[2], prdb.borderColor[3], prdb.borderColor[4])
		tq2LhFrame:SetFrameStrata("HIGH")
		self:restorePosition("tomQuest2LhFrame")
		updateTq2LhTextSize()
	elseif not (prdb.showLightHeaded and LightHeaded) then
		tq2LhFrame:Hide()
	end
end

function tomQuest2:restorePosition(name)
	local f = _G[name]
	f:ClearAllPoints()
	f:SetPoint(prdb[name].point, prdb[name].x, prdb[name].y)
	f:SetWidth(prdb[name].width)
	f:SetHeight(prdb[name].height)
end

function tomQuest2:updateQuestsLightHeadedInformations(qid, page)
	if not tq2LhFrame:IsVisible() then return end
	local lhText
	local num = LightHeaded:GetNumQuestComments(qid) or 0
	if #(self.stack) > 0 then
		lhText = "|cFF0066FF|Hlhref:back|h[Back]|h|r\n"..self:getQuestLightHeadedInformations(qid, page, num)
	else
		lhText = self:getQuestLightHeadedInformations(qid, page, num)
	end
	setTq2LhText(lhText)
	if prdb.showAllCommentsOnOnePage then
		tq2LhFrame.page:Hide()
		tq2LhFrame.prev:Hide()
		tq2LhFrame.next:Hide()
	else
		tq2LhFrame.page:SetText(format(LC["Page %s of %s"], page, num + 1))
		tq2LhFrame.page:Show()
		tq2LhFrame.prev:Show()
		tq2LhFrame.next:Show()
		if page == 1 then
			tq2LhFrame.prev:Disable()
		else
			tq2LhFrame.prev:Enable()
		end
		if page == num + 1 then
			tq2LhFrame.next:Disable()
		else
			tq2LhFrame.next:Enable()
		end
	end
	self.currentQid = qid
	tomQuest2.currentPage = page
end


local function clean(text)
	text = gsub(text, "%[ul%]", "")
	text = gsub(text, "%[/ul%]", "")
	text = gsub(text, "%[li%]", "")
	text = gsub(text, "%[/li%]", "")
	text = gsub(text, "%[url=", "")
	text = gsub(text, "%[/url%]", "")
	return text
end

function tomQuest2:displayQuestInformations(qid)
	if self.moduleState["informations"] then
		if not self.quests[qid] then return end
		if self.currentQid == qid then
			self.currentQid = nil
			if tq2ParentFrame and tq2ParentFrame:IsVisible() then
				tq2ParentFrame:Hide()
			elseif tq2QlFrame and tq2QlFrame:IsVisible() and tq2LhFrame and tq2LhFrame:IsVisible() then
				tq2QlFrame:Hide()
				tq2LhFrame:Hide()
			elseif tq2QlFrame and tq2QlFrame:IsVisible() then
				tq2QlFrame:Hide()
			elseif tq2LhFrame and tq2LhFrame:IsVisible() then
				tq2LhFrame:Hide()
			end
			return
		end
		self.currentQid = qid
		if prdb.showQuestLog then
			if not tq2QlFrame then
				self:createQlGUI()
			end
			tq2QlFrame:Show()
			local fontN = CreateFont("tq2NFont")
			fontN:SetFont(LSM:Fetch("font", prdb.qlFont), prdb.qlFontSize)
			local fontH1 = CreateFont("tq2H1Font")
			fontH1:SetFont(LSM:Fetch("font", prdb.qlFont), prdb.qlFontSizeH1, "OUTLINE")
			local fontH2 = CreateFont("tq2H2Font")
			fontH2:SetFont(LSM:Fetch("font", prdb.qlFont), prdb.qlFontSizeH2, "OUTLINE")
			tq2QlFrame.title:SetFontObject(fontN)
			tq2QlFrame.text:SetFontObject(fontN)
			tq2QlFrame.text:SetFontObject("h1", fontH1)
			tq2QlFrame.text:SetFontObject("h2", fontH2)
			if self.quests[qid].id then
				tq2QlFrame.abandon:Enable()
				if self.numPartyMembers > 0 and self.quests[qid].sharable then
					tq2QlFrame.share:Enable()
				else
					tq2QlFrame.share:Disable()
				end
			else
				tq2QlFrame.abandon:Disable()
				tq2QlFrame.share:Disable()
			end
			local tIndex = 2
			if self.quests[qid].playersOnQuest > 1 then
				self.tempTable[1] = "<HTML><BODY><H1>|cff"..self.quests[qid].color..self.quests[qid].tag..self.quests[qid].title.."|r &lt;"..self.quests[qid].playersOnQuest.."&gt;</H1>"
			else
				self.tempTable[1] = "<HTML><BODY><H1>|cff"..self.quests[qid].color..self.quests[qid].tag..self.quests[qid].title.."|r </H1>"
			end
			if not self.quests[qid].description then
				self.tempTable[tIndex] = LC["Quests informations not yet available, please try once synchronization with party is complete"]
				setTq2QlText(tconcat(self.tempTable, "<P><BR/>", 1, tIndex).."</P></BODY></HTML>")
			else
				if self.questsObjectives[qid] then
					self.tempTable[tIndex] = "<P>"..gsub(self.quests[qid].objective, "[<>]", self.lhrepl).."</P><P>"
					for oid, qoData in pairs(self.questsObjectives[qid]) do
						tIndex = tIndex + 1
						local qoStatus, qoColor = self:updateQuestObjectiveStatus(qid, oid)
						self.tempTable[tIndex] = "|cff"..qoColor..qoData.desc.."|r : "..format(qoStatus, qoColor)
					end
					tIndex = tIndex + 1
					self.tempTable[tIndex] = "</P><BR/><H2>"..LC["Description:"].."</H2>"
				else
					self.tempTable[tIndex] = "<P>"..gsub(self.quests[qid].objective, "[<>]", self.lhrepl).."</P>"
					tIndex = tIndex + 1
					self.tempTable[tIndex] = "<H2>"..LC["Description:"].."</H2>"
				end
				tIndex = tIndex + 1
				self.tempTable[tIndex] = "<P>"..gsub(self.quests[qid].description, "[<>]", self.lhrepl).."</P>"
				if (self.quests[qid].titleReward ~= "" or self.quests[qid].rewardSpellLink or (self.quests[qid].numRewards + self.quests[qid].numChoices + self.quests[qid].money + self.quests[qid].honor + self.quests[qid].talent) > 0 ) then
					tIndex = tIndex + 1
					self.tempTable[tIndex] = "<H2>"..LC["Rewards:"].."</H2><P>"
					if self.quests[qid].money > 0 then
						tIndex = tIndex + 1
						self.tempTable[tIndex] = LC["You will rececive: "]..self:formatMoney(self.quests[qid].money).."<BR/>"
					end
					if self.quests[qid].honor > 0 then
						tIndex = tIndex + 1
						self.tempTable[tIndex] = LC["Honor points: "]..self.quests[qid].honor.."<BR/>"
					end
					if self.quests[qid].talent > 0 then
						tIndex = tIndex + 1
						self.tempTable[tIndex] = LC["Talent points: "]..self.quests[qid].talent.."<BR/>"
					end
					if self.quests[qid].titleReward ~= "" then
						tIndex = tIndex + 1
						self.tempTable[tIndex] = LC["Title: "]..self.quests[qid].titleReward.."<BR/>"
					end
					if self.quests[qid].rewardSpellName ~= "" then
						tIndex = tIndex + 1
						self.tempTable[tIndex] = "|T"..self.quests[qid].rewardSpellTexture..":32|t |cff71d5ff|Hlhref:spell:"..qid.."|h["..self.quests[qid].rewardSpellName.."]|h|r".."<BR/>"
					end
					if self.quests[qid].numRewards > 0 then
						for i = 1, self.quests[qid].numRewards do
							local numItems = self.quests[qid].itemRewards[i].numItems
							if numItems > 1 then
								if self.quests[qid].itemRewards[i].texture and self.quests[qid].itemRewards[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = numItems.." |T"..self.quests[qid].itemRewards[i].texture..":32|t"..self.quests[qid].itemRewards[i].link
								elseif self.quests[qid].itemRewards[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = numItems.." "..self.quests[qid].itemRewards[i].link
								end
							else
								if self.quests[qid].itemRewards[i].texture and self.quests[qid].itemRewards[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = "|T"..self.quests[qid].itemRewards[i].texture..":32|t"..self.quests[qid].itemRewards[i].link
								elseif self.quests[qid].itemRewards[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = self.quests[qid].itemRewards[i].link
								end
							end
						end
					end
					if self.quests[qid].numChoices > 0 then
						tIndex = tIndex + 1
						self.tempTable[tIndex] = LC["Choose one of the following rewards:"].."<BR/>"
						for i = 1, self.quests[qid].numChoices do
							local numItems = self.quests[qid].itemChoices[i].numItems
							if numItems > 1 then
								if self.quests[qid].itemChoices[i].texture and self.quests[qid].itemChoices[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = numItems.." |T"..self.quests[qid].itemChoices[i].texture..":32|t"..self.quests[qid].itemChoices[i].link
								elseif self.quests[qid].itemChoices[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = numItems.." "..self.quests[qid].itemChoices[i].link
								end
							else
								if self.quests[qid].itemChoices[i].texture and self.quests[qid].itemChoices[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = "|T"..self.quests[qid].itemChoices[i].texture..":32|t"..self.quests[qid].itemChoices[i].link
								elseif self.quests[qid].itemChoices[i].link then
									tIndex = tIndex + 1
									self.tempTable[tIndex] = self.quests[qid].itemChoices[i].link
								end
							end
						end
					end
					setTq2QlText(tconcat(self.tempTable, "<BR/>", 1, tIndex).."</P></BODY></HTML>")
				else
					setTq2QlText(tconcat(self.tempTable, "<BR/>", 1, tIndex).."</BODY></HTML>")
				end
			end
		end
		if LightHeaded and prdb.showLightHeaded then
			if LightHeaded and not tomQuest2LhFrame then
				self:createLhGUI()
			end
			tq2LhFrame:Show()
			local font = CreateFont("tq2LhFont")
			font:SetFont(LSM:Fetch("font", prdb.lhFont), prdb.lhFontSize)
			tq2LhFrame.title:SetFontObject(font)
			tq2LhFrame.page:SetFontObject(font)
			tq2LhFrame.text:SetFontObject(font)
			local num = LightHeaded:GetNumQuestComments(qid) or 0
			if prdb.showAllCommentsOnOnePage then
				tomQuest2.currentPage = 0
				tq2LhFrame.next:Hide()
				tq2LhFrame.prev:Hide()
				tq2LhFrame.page:Hide()
				local lhText = self:getQuestLightHeadedInformations(qid, 0, num)
				if lhText then
					setTq2LhText(lhText)
				end
			else
				tomQuest2.currentPage = 1
				tq2LhFrame.page:Show()
				local lhText = self:getQuestLightHeadedInformations(qid, 1, num)
				if lhText then
					tq2LhFrame.page:SetText(format(LC["Page %s of %s"], 1, num + 1))
					setTq2LhText(lhText)
					if num == 0 then
						tq2LhFrame.prev:Hide()
						tq2LhFrame.next:Hide()
					else
						tq2LhFrame.prev:Show()
						tq2LhFrame.next:Show()
						tq2LhFrame.prev:Disable()
						if tomQuest2.currentPage == num + 1 then
							tq2LhFrame.next:Disable()
						else
							tq2LhFrame.next:Enable()
						end
					end
				end
			end
		end
		if prdb.showQuestLog and prdb.showLightHeaded and LightHeaded and (prdb.attach == 1 or prdb.attach == 2) then
			tq2ParentFrame:Show()
		end
	elseif not prdb.tomQuest2s["informations"] and tomQuest2.quests[qid] and tomQuest2.quests[qid].id then
		QuestLog_OpenToQuest(tomQuest2.quests[qid].id)
	end
end

function tomQuest2:getQuestLightHeadedInformations(qid, page, numComments)
	local title = self.quests[qid] and self.quests[qid].title or LightHeaded:GetQuestName(qid)
	if page == 0 or page == 1 then
		local tIndex = 3
		for qid, sharable, level, reqlev, stype, sname, sid, etype, ename, eid, exp, rep, series in LightHeaded:IterateQuestInfo(qid) do
			self.tempTable[1] = "|c"..prdb.color..LC["Name:|r "]..title
			self.tempTable[2] = LC["Quest ID:|r"].." |Hlhref:external:http://www.wowhead.com/?quest="..qid.."|h"..qid.."|h"
			if sharable then
				self.tempTable[3] = LC["Sharable:|r "]..LC["Yes"]
			else
				self.tempTable[3] = LC["Sharable:|r "]..LC["No"]
			end
			if level ~= "" then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = LC["Level:|r "]..level
			end
			if reqlev ~= "" then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = LC["Required level:|r"]..reqlev
			end
			if stype ~= "" and sname ~= "" then
				tIndex = tIndex + 1
				if stype == "npc" then
					self.tempTable[tIndex] = LC["Starts:|r "].."|cFF0066FF|Hlhref:npc:"..sid..":"..sname.."|h["..sname.."]|h|r"
				else
					self.tempTable[tIndex] = LC["Starts:|r "]..sname
				end
			end
			if etype ~= "" and ename ~= "" then
				tIndex = tIndex + 1
				if etype == "npc" then
					self.tempTable[tIndex] = LC["Ends:|r "].."|cFF0066FF|Hlhref:npc:"..eid..":"..ename.."|h["..ename.."]|h|r"
				else
					self.tempTable[tIndex] = LC["Ends:|r "]..ename
				end

			end
			if exp ~= "" then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = LC["Experience:|r "]..exp
			end
			if rep ~= "" then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = LC["Reputation gains:|r"]
				for name, value in rep:gmatch("([^\029]+)\029([^\029]+)") do
					tIndex = tIndex + 1
					self.tempTable[tIndex] = " - "..name.." |r: "..value
				end
			end
			if series ~= "" then
				tIndex = tIndex + 1
				self.tempTable[tIndex] = LC["Quest series:|r"]
				for step, id in series:gmatch("([^\029]+)\029([^\029]+)") do
					tIndex = tIndex + 1
					if qid == id then
						self.tempTable[tIndex] = step.." - "..title.." |r"
					else
						self.tempTable[tIndex] = step.." - |r|cFF0066FF|Hlhref:quest:"..id.."|h["..LightHeaded:GetQuestName(id).."]|h|r"
					end
				end
			end
		end
		if page == 0 and numComments > 0 then
			tIndex = tIndex + 1
			self.tempTable[tIndex] = LC["Comments for:|r "]..title
			for page = 1, numComments do
				tIndex = tIndex + 1
				self.tempTable[tIndex] = clean(LightHeaded:GetCommentText(qid, page))
			end
			return tconcat(self.tempTable, "\n|c"..prdb.color, 1, tIndex - numComments).."\n"..tconcat(self.tempTable, "\n", tIndex - numComments + 1, tIndex)
		else
			return tconcat(self.tempTable, "\n|c"..prdb.color, 1, tIndex)
		end
	elseif page > 1 then
		return "|c"..prdb.color..LC["Comments for:|r "]..title.."\n"..clean(LightHeaded:GetCommentText(qid, page - 1))
	end
end

------------
--- Core ---
------------
function tomQuest2:questLost(qid)
	if not self.quests[qid] then
		chdb.questsTracked[qid] = nil
		chdb.questsSubZoneAutoTracked[qid] = nil
		chdb.questsZoneAutoTracked[qid] = nil
		if self.currentQid ~= qid then return end
		self.currentQid = nil
		if tq2ParentFrame and tq2ParentFrame:IsVisible() then
			tq2ParentFrame:Hide()
		elseif tq2QlFrame and tq2QlFrame:IsVisible() and tq2LhFrame and tq2LhFrame:IsVisible() then
			tq2QlFrame:Hide()
			tq2LhFrame:Hide()
		elseif tq2QlFrame and tq2QlFrame:IsVisible() then
			tq2QlFrame:Hide()
		elseif tq2LhFrame and tq2LhFrame:IsVisible() then
			tq2LhFrame:Hide()
		end
	end
end

function tomQuest2:WatchFrame_Update()
	WatchFrame:Hide()
end

function tomQuest2:hideShowDefaultBlizTracker()
	if self.quests.hideDefaultBlizTracker then
		WatchFrame:Hide()
		self:SecureHook("WatchFrame_Update")
	else
		WatchFrame:Show()
		self:Unhook("WatchFrame_Update")
	end
end

function tomQuest2:zoneChanged()
	if UnitIsDead("player") then return end
	subZone = GetSubZoneText() or ""
	currentZone = GetZoneText() or ""
	for category, cData in pairs(self.questsCategories) do
		if currentZone == category then
			chdb.categoryDisplay.questsTracker[category] = 1
		elseif cData.zone then
			chdb.categoryDisplay.questsTracker[category] = 0
		end
	end
	if prdb.onZone and currentZone ~= oldZone then
		for qid in pairs(chdb.questsZoneAutoTracked) do
			RemoveQuestWatch(self.quests[qid].id, qid)
		end
		for qid, qData in pairs(self.quests) do
			if not chdb.questsTracked[qid] and qData.zone == currentZone then
				chdb.questsZoneAutoTracked[qid] = true
				AddQuestWatch(self.quests[qid].id, nil, qid)
			end
		end
	end
	if prdb.onSubZone and subZone ~= "" then
		for qid in pairs(chdb.questsSubZoneAutoTracked) do
			RemoveQuestWatch(self.quests[qid].id, qid)
		end
		for qid, qData in pairs(self.quests) do
			if not chdb.questsTracked[qid] and ((qData.objective and qData.objective:find(subZone, 1, true)) or (qData.description and qData.description:find(subZone, 1, true))) then
				chdb.questsSubZoneAutoTracked[qid] = true
				AddQuestWatch(self.quests[qid].id, nil, qid)
			end
		end
	end
	self:setQuestsTrackerLayout()
	oldZone = currentZone
end

function tomQuest2:updateQuestCounter()
	if not self.moduleState["questsTooltip"] then return end
	local tIndex, ldbColor = 0, nil
	if prdb.showNumCompletedQuests then
		tIndex = 1
		self.tempTable[tIndex] = self.numCompletedQuests
		if self.numQuests > 0 then
			ldbColor = self:getColorFromCompletionHEX(self.numCompletedQuests/self.numQuests)
		else
			ldbColor = "ffffff"
		end
	end
	if prdb.showNumQuests then
		tIndex = tIndex + 1
		self.tempTable[tIndex] = self.numQuests
		ldbColor = ldbColor or self:getColorFromCompletionHEX(self.numQuests/MAX_QUESTS)
	end
	if prdb.showMaxQuest then
		tIndex = tIndex + 1
		self.tempTable[tIndex] = MAX_QUESTS
		ldbColor = ldbColor or "ffffff"
	end
	if tIndex > 0 then
		if prdb.colorizeQuestsCounter then
			questsTooltipDataObj.text = format("|cff%s%s|r", ldbColor, tconcat(self.tempTable, "/", 1, tIndex))
		else
			questsTooltipDataObj.text = tconcat(self.tempTable, "/", 1, tIndex)
		end
	else
		questsTooltipDataObj.text = ""
	end
end

function tomQuest2:AbandonQuest()
	abandoning = true
end

function tomQuest2:addQuestCategory(category)
	local minLevel, maxLevel, sMinLevel, sMaxLevel, level, color, zone
	if category == self.PARTYQUESTSZONE then
		minLevel, maxLevel, level, color, zone = "", "", "", "ffffff", true
		sMinLevel, sMaxLevel = prdb.categoryWithoutLvlPos, prdb.categoryWithoutLvlPos
	elseif category == self.localClass then
		minLevel, maxLevel, level, color = "", "", "", playerColor
		sMinLevel, sMaxLevel = prdb.categoryWithoutLvlPos, prdb.categoryWithoutLvlPos
	else
		minLevel, maxLevel = LibTourist:GetLevel(category)
		sMinLevel, sMaxLevel = minLevel, maxLevel
		if maxLevel == 0 then
			level, color = "", "ffffff"
		else
			local r, g, b = LibTourist:GetLevelColor(category)
			level, color, zone = format("(%d-%d)", minLevel, maxLevel), format("%02x%02x%02x", r*255, g*255, b*255), true
		end
	end
	self.questsCategories[category] = {
		minLevel = minLevel,
		maxLevel = maxLevel,
		sMinLevel = sMinLevel,
		sMaxLevel = sMaxLevel,
		level = level,
		color = color,
		zone = zone,
	}
	self.questsByCategory[category] = {}
	self:createQuestCategoryCell(category, QUESTS_TOOLTIP, self.cQToFontTQ2)
	self:createQuestCategoryCell(category, QUESTS_TRACKER, self.cQTrFontTQ2)
end

function tomQuest2:addQuest(qid, title, level, qtag, group, daily, numObjectives, category)
	if numObjectives > 0 then
		self.questsObjectives[qid] = {}
		self.questsObjectiveTextCells.questsTooltip[qid], self.questsObjectiveStatusCells.questsTooltip[qid] = {}, {}
		self.questsObjectiveTextCells.questsTracker[qid], self.questsObjectiveStatusCells.questsTracker[qid] = {}, {}
	end
	local qc = self:getDifficultyColor(level - self.playerLevel)
	local weightedLevel = levelTag[qtag](qid, level, group)
	local tagLevel = prdb.level == "questLevel" and level or weightedLevel
	local tag
	if tagLevel > 0 or qtag ~= "notag" or group > 0 or daily == 1 then
		tag = format("[%s%s%s%s]", tagLevel > 0 and tagLevel or "", prdb[qtag], group > 0 and group or "", daily == 1 and (qtag ~= "daily" and prdb["daily"] or "") or "")
	else
		tag = ""
	end
	self.quests[qid] = {
		title = title, level = level, weightedLevel = weightedLevel, shortTag = qtag, tag = tag, group = group, daily = daily,
		numObjectives = numObjectives, category = category, playersOnQuest = 0, color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	}
	self.questTextCells.questsTooltip[qid] = self:getContentCell(self.qQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	self.questStatusCells.questsTooltip[qid] = self:getContentCell(self.qQToFontTQ2, "RIGHT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	self.questTextCells.questsTracker[qid] = self:getContentCell(self.qQTrFontTQ2, "LEFT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
	self.questStatusCells.questsTracker[qid] = self:getContentCell(self.qQTrFontTQ2, "RIGHT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
end

function tomQuest2:addPlayerToQuest(qid, status, category, player)
	self.quests[qid].playersOnQuest = self.quests[qid].playersOnQuest + 1
	if not player then
		self.questsTitleToqid[self.quests[qid].title] = qid
		self.quests[qid].playerStatus = status
		self.questsByCategory[category][qid] = true
		if category == self.localClass then self.quests[qid].class = true end
		if prdb.partyHeader and self.quests[qid].playersOnQuest > 1 then
			self.questsByCategory[self.PARTYQUESTSZONE][qid] = nil
			if not next(self.questsByCategory[self.PARTYQUESTSZONE]) then
				self.questsCategories[self.PARTYQUESTSZONE] = nil
				self.questsByCategory[self.PARTYQUESTSZONE] = nil
			end
		end
		if not self.firstRun then
			self:sendMessage("q", qid, self.quests[qid].title, self.quests[qid].level, self.quests[qid].tag, self.quests[qid].group, self.quests[qid].daily, self.quests[qid].numObjectives, self.quests[qid].playerStatus, category)
		end
	else
		if not self.questsCategories[category] then self:addQuestCategory(category) end
		self.questsByCategory[category][qid] = true
		if not self.quests[qid].complete then
			self.quests[qid].complete = {[player] = status}
		else
			self.quests[qid].complete[player] = status
		end
	end
	if not self.firstRun then
		self:questsSort()
	end
	self:updateQuestCells(qid)
end

function tomQuest2:removePartyFromQuest(sender, qid, abandoning)
	self.quests[qid].complete[sender] = nil
	if self.quests[qid].playersOnQuest == 1 then
		self.questsObjectives[qid] = nil
		local category = prdb.partyHeader and self.PARTYQUESTSZONE or self.quests[qid].category
		self.questsByCategory[category][qid] = nil
		if not next(self.questsByCategory[category]) then
			self.questsCategories[category] = nil
			self.questsByCategory[category] = nil
			self:removeQuestCategoryCells(category)
		end
		self.quests[qid] = nil
		self:removeQuestCells(qid)
	else
		self.quests[qid].playersOnQuest = self.quests[qid].playersOnQuest - 1
		self.quests[qid].complete[sender] = nil
		self:updateQuestCells(qid)
		if not next(self.quests[qid].complete) then
			self.quests[qid].complete = nil
			if self.questsObjectives[qid] then
				for oid in pairs(self.questsObjectives[qid]) do
					self.questsObjectives[qid][oid].got = nil
					self.questsObjectives[qid][oid].nGot = nil
					self:updateQuestObjectiveCells(qid, oid)
				end
			end
		else
			if self.questsObjectives[qid] then
				for oid in pairs(self.questsObjectives[qid]) do
					self.questsObjectives[qid][oid].got[sender] = nil
					self.questsObjectives[qid][oid].nGot[sender] = nil
					self:updateQuestObjectiveCells(qid, oid)
				end
			end
		end
	end
end

function tomQuest2:updateQuest(qid, status, message, player)
	if not player then
		self.quests[qid].playerStatus = status
		self:sendMessage(message, qid)
	else
		self.quests[qid].complete[player] = status
	end
	self:updateQuestCells(qid)
end

function tomQuest2:addQuestObjective(qid, oid, desc, need, nNeed)
	self.questsObjectives[qid][oid] = {desc = desc, nNeed = nNeed, need = need}
	self.questsObjectiveTextCells.questsTooltip[qid][oid] = self:getContentCell(self.qoQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	self.questsObjectiveStatusCells.questsTooltip[qid][oid] = self:getContentCell(self.qoQToFontTQ2, "RIGHT", QUESTS_TOOLTIP, QUESTS_TOOLTIP, qid, true)
	self.questsObjectiveTextCells.questsTracker[qid][oid] = self:getContentCell(self.qoQTrFontTQ2, "LEFT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
	self.questsObjectiveStatusCells.questsTracker[qid][oid] = self:getContentCell(self.qoQTrFontTQ2, "RIGHT", QUESTS_TRACKER, QUESTS_TRACKER, qid, true)
end

function tomQuest2:addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot, player)
	if not player then
		self.questsObjectives[qid][oid].playerGot = got
		self.questsObjectives[qid][oid].nPlayerGot= nGot
		if not self.firstRun then
			self:sendMessage("o", qid, oid, desc, got, need, nGot, nNeed)
		end
	elseif not self.questsObjectives[qid][oid].got then
		self.questsObjectives[qid][oid].got = {[player] = got}
		self.questsObjectives[qid][oid].nGot = {[player] = nGot}
	else
		self.questsObjectives[qid][oid].got[player] = got
		self.questsObjectives[qid][oid].nGot[player] = nGot
	end
	self:updateQuestObjectiveCells(qid, oid)
end

local parseObjective = {
	item = function(description, done)
		local desc, got, need = description:match(tomQuest2.objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	object = function(description, done)
		local desc, got, need = description:match(tomQuest2.objectsPattern)
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	monster = function(description, done)
		local desc, got, need = description:match(tomQuest2.monstersPattern)
		if desc == nil or got == nil or need == nil then
			desc, got, need = description:match(tomQuest2.objectsPattern)
		end
		return desc, got, need, tonumber(got), tonumber(need)
	end,
	reputation = function(description, done)
		local desc, got, need = description:match(tomQuest2.factionPattern)
		return desc, got, need, reactions[got], reactions[need]
	end,
	log = function(description, done)
		if done then
			return description, 1, 1, 1, 1
		else
			return description, 0, 1, 0, 1
		end
	end,
	event = function(description, done)
		if done then
			return description, 1, 1, 1, 1
		else
			return description, 0, 1, 0, 1
		end
	end,
	player = function(description, done)
		local got, need = description:match(tomQuest2.playersPattern)
		if tomQuest2.faction == "Alliance" then
			return LC["Horde player killed"], got, need, tonumber(got), tonumber(need)
		else
			return LC["Alliance player killed"], got, need, tonumber(got), tonumber(need)
		end
	end,
}

function tomQuest2:QUEST_LOG_UPDATE()
	if self.questLogUpdating and not self.questLogUpdateHandle then 
		self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
		return
	end
	if self.questLogUpdateHandle then
		self:CancelTimer(self.questLogUpdateHandle, true)
	end
	self.questLogUpdating = true
	local selectionId = GetQuestLogSelection()
	local timeStamp = GetTime()
	local numCompletedQuests, numEntries, numQuests = 0, GetNumQuestLogEntries()
	local category
	for id = 1, numEntries do
		local title, level, tag, group, header, collapsed, completed, daily, qid = GetQuestLogTitle(id)
		if header then
			category = title
			if collapsed then
				self.collapsedHeader[category] = true
			elseif self.collapsedHeader[category] then
				self.collapsedHeader[category] = nil
			end
			if not self.questsCategories[category] then
				self:addQuestCategory(category)
			end
		else
			level, tag, group, daily, completed = level or 0, tag or "", group or 0, daily or 0, completed or 0
			if completed == 1 then numCompletedQuests = numCompletedQuests + 1 end
			if not self.quests[qid] then
				if tags[tag] then
					tag = tags[tag]
				elseif tag == RAID then
					tag = "raid"
					group = LibTourist:GetInstanceGroupSize(category) or group
				elseif tag:find(RAID) then
					tag = "raid"
					group = tonumber(tag:match("%d+")) or group
				else
					self:Print("tag ["..tag.."] is missing for quest ["..qid.."] please report to tomQuest2 author on WOWAce or WOWInterface")
					tag = "notag"
				end
				local numObjectives = GetNumQuestLeaderBoards(id) or 0
				self:addQuest(qid, title, level, tag, group, daily, numObjectives, category)
				self:addPlayerToQuest(qid, completed, category)
			elseif not self.quests[qid].playerStatus then 
				self:addPlayerToQuest(qid, completed, category)
			else
				if completed == 0 and self.quests[qid].playerStatus == 1 then
					self:updateQuest(qid, 0, "a")
				elseif completed == 1 and self.quests[qid].playerStatus == 0 then
					self:updateQuest(qid, 1, "c")
					if self.moduleState["announce"] and prdb.announcePlayerQuestComplete and self.numPartyMembers > 0 then
						SendChatMessage(format(LC["(%s) : finished"], title), "PARTY")
					end
					if self.moduleState["notifications"] and prdb.notifyPlayerQuestComplete then
						self:Pour(format(LC["(%s) : finished"], title), 0, 1, 0)
					end
					if self.moduleState["soundNotifications"] then
						play(LSM:Fetch("sound", prdb.soundQuestComplete))
					end
				elseif completed == -1 and self.quests[qid].playerStatus ~= -1 then
					self:updateQuest(qid, -1, "f")
					if self.moduleState["announce"] and prdb.announcePlayerQuestFailed and self.numPartyMembers > 0 then
						SendChatMessage(format(LC["(%s) : failed"], title), "PARTY")
					end
					if self.moduleState["notifications"] and prdb.notifyPlayerQuestFailed then
						self:Pour(format(LC["(%s) : failed"], title), 1, 0, 0)
					end
					if self.moduleState["soundNotifications"] then
						play(LSM:Fetch("sound", prdb.soundQuestFailed))
					end
				end
			end
			self.quests[qid].id, self.quests[qid].timeStamp = id, timeStamp
			local started = 0
			for oid = 1, self.quests[qid].numObjectives do
				local description, qType, done = GetQuestLogLeaderBoard(oid, id)
				if qType and description then
					if parseObjective[qType] then
						local desc, got, need, nGot, nNeed = parseObjective[qType](description, done)
						if not desc or strtrim(desc) == "" then
							if not self.questLogUpdateHandle then 
								self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
							end
							return
						elseif not self.questsObjectives[qid][oid] then
							self:addQuestObjective(qid, oid, desc, need, nNeed)
							self:addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot)
						elseif not self.questsObjectives[qid][oid].nPlayerGot then
							self:addPlayerToQuestObjective(qid, oid, desc, need, nNeed, got, nGot)
						elseif self.questsObjectives[qid][oid].nPlayerGot ~= nGot then
							self.questsObjectives[qid][oid].playerGot, self.questsObjectives[qid][oid].nPlayerGot = got, nGot
							self:updateQuestObjectiveCells(qid, oid)
							if nGot == nNeed then
								if self.moduleState["announce"] and prdb.announcePlayerObjectiveComplete and (self.quests[qid].playerStatus == 0 or prdb.announceObjectiveProgressWhenQuestComplete) then
									SendChatMessage(format(LC["(%s) %s : finished"], title, desc), "PARTY")
								end
								if self.moduleState["notifications"] and prdb.notifyPlayerObjectiveComplete and (self.quests[qid].playerStatus == 0 or prdb.notifiyObjectiveProgressWhenQuestComplete) then
									self:Pour(format(LC["(%s) %s : finished"], title, desc), 0, 1, 0)
								end
								if self.moduleState["soundNotifications"] and self.quests[qid].playerStatus == 0 then
									play(LSM:Fetch("sound", prdb.soundQuestComplete))
								end
							else
								if self.moduleState["announce"] and prdb.announcePlayerObjectiveProgress then
									SendChatMessage("(%s) %s : %s / %s", title, desc, got, need, "PARTY")
								end
								if self.moduleState["notifications"] and prdb.notifyPlayerObjectiveProgress then
									self:Pour(format("(%s) %s : %s / %s", title, desc, got, need), self:getColorFromCompletionRGB(nGot/ nNeed))
								end
							end
							self:sendMessage("p", qid, oid, got, nGot)
							self:qTrQuestObjectiveProgress(qid, oid, got, nGot)
						end
						if nGot ~= 0 then started = 1 end
					else
						self:Print("objective type ["..qType.."] unknown for objective ["..description.."] and quest ["..qid.."] please report to tomQuest2 author on WOWAce or WOWInterface")
					end
				else
					if not self.questLogUpdateHandle then 
						self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
					end
					return
				end
			end
			if not self.quests[qid].extras then
				SelectQuestLogEntry(id)
				self.quests[qid].description, self.quests[qid].objective = GetQuestLogQuestText()
				if not self.quests[qid].description or not self.quests[qid].objective then
					if not self.questLogUpdateHandle then 
						self.questLogUpdateHandle = self:ScheduleTimer("QUEST_LOG_UPDATE", 0.1)
					end
					return
				else
					if not self.questsObjectives[qid] then
						self:createQuestDescriptionCells(qid)
					end
					self.quests[qid].extras = true
				end
				local itemLink, itemIcon, itemCharges = GetQuestLogSpecialItemInfo(id)
				if itemLink then
					self.quests[qid].specialItemLink, self.quests[qid].specialItemIcon, self.quests[qid].specialItemCharges = itemLink, itemIcon, itemCharges
					if self.items[itemLink] and self.items[itemLink] ~= qid then
						if self.items[itemLink] == 0 then
							self.itemStartingQuest[itemLink] = nil
						elseif self.items[itemLink] == -1 then
							self.usableQuestItems[itemLink] = nil
						end
					end
					self.quests[qid].itemHasRange = ItemHasRange(itemLink)
					self.quests[qid].item = true
					if not self.specialItemButtons.questsTooltip[qid] then
						self.specialItemButtons.questsTooltip[qid] = self:getItemButton(self.questTextCells.questsTooltip[qid], self.quests[qid].id, self.quests[qid].specialItemLink, self.quests[qid].specialItemIcon, self.quests[qid].itemHasRange, QUESTS_TOOLTIP, prdb.questsTooltip.questItemIconSize)
						self.specialItemButtons.questsTracker[qid] = self:getItemButton(self.questTextCells.questsTracker[qid], self.quests[qid].id, self.quests[qid].specialItemLink, self.quests[qid].specialItemIcon, self.quests[qid].itemHasRange, QUESTS_TRACKER, prdb.questsTracker.questItemIconSize)
					end
					self.items[itemLink] = qid
				end
				self.quests[qid].sharable = GetQuestLogPushable()
				self.quests[qid].money = GetQuestLogRewardMoney() or 0
				self.quests[qid].honor = GetQuestLogRewardHonor() or 0
				self.quests[qid].talent = GetQuestLogRewardTalents() or 0
				self.quests[qid].titleReward = GetQuestLogRewardTitle() or ""
				local numRewards = GetNumQuestLogRewards() or 0
				local numChoices = GetNumQuestLogChoices() or 0
				self.quests[qid].numRewards, self.quests[qid].numChoices = numRewards, numChoices
				local rewardSpellTexture, rewardSpellName = GetQuestLogRewardSpell()
				self.quests[qid].rewardSpellTexture = rewardSpellTexture or ""
				self.quests[qid].rewardSpellName = rewardSpellName or ""
				if numRewards > 0 then
					self.quests[qid].itemRewards = {}
					for i = 1, numRewards do
						local name, texture, numItems, quality, isUsable = GetQuestLogRewardInfo(i)
						local itemLink = GetQuestLogItemLink("reward", i)
						self.quests[qid].itemRewards[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = itemLink}
					end
				end
				if numChoices > 0 then
					self.quests[qid].itemChoices = {}
					for i = 1, numChoices do
						local name, texture, numItems, quality, isUsable = GetQuestLogChoiceInfo(i)
						local itemLink = GetQuestLogItemLink("choice", i)
						self.quests[qid].itemChoices[i] = {name = name, texture = texture, numItems = numItems, quality = quality, isUsable = isUsable, link = itemLink}
					end
				end
				if self.usableQuestItems then
					for itemLink, itemData in pairs(self.usableQuestItems) do
						if (self.quests[qid].objective and self.quests[qid].objective:find(itemData.name, 1, true)) or (self.quests[qid].description and self.quests[qid].description:find(itemData.name, 1, true)) then
							self.items[itemLink] = qid
							self.quests[qid].specialItemLink, self.quests[qid].specialItemIcon = itemLink, itemData.icon
							self.usableQuestItems[itemLink] = nil
						end
					end
				end
				if self.itemStartingQuest then
					for itemLink, itemData in pairs(self.itemStartingQuest) do
						if (self.quests[qid].objective and self.quests[qid].objective:find(itemData.name, 1, true)) or (self.quests[qid].description and self.quests[qid].description:find(itemData.name, 1, true)) then
							self.items[itemLink] = qid
							self.quests[qid].specialItemLink, self.quests[qid].specialItemIcon = itemLink, itemData.icon
							self.itemStartingQuest[itemLink] = nil
						end
					end
				end
				local initialTimer = GetQuestLogTimeLeft()
				if initialTimer then
					self.quests[qid].initialTimer = initialTimer
					self.quests[qid].startTime = GetTime()
				end
			end
			if self.firstRun then
				self.quests[qid].old = true
			elseif not self.quests[qid].old then
				self.quests[qid].old = true
				self:sendMessage("r", qid, started)
				if prdb.onQuestAccepted == 1 or (prdb.onQuestAccepted == 2 and self.playerLevel ~= MAX_PLAYER_LEVEL) or (prdb.onObjectiveProgress and started == 1) or (prdb.onDaily and self.quests[qid].daily == 1) or (prdb.onClass and self.quests[qid].class) then
					if not chdb.questsTracked[qid] then
						AddQuestWatch(id, nil, qid)
					else
						chdb.questsSubZoneAutoTracked[qid] = nil
						chdb.questsZoneAutoTracked[qid] = nil
					end
				elseif prdb.onZone and self.quests[qid].zone == currentZone then
					if not chdb.questsTracked[qid] then
						chdb.questsZoneAutoTracked[qid] = true
						AddQuestWatch(id, nil, qid)
					else
						chdb.questsSubZoneAutoTracked[qid] = nil
					end
				elseif prdb.onSubZone and not chdb.questsTracked[qid] and subZone ~= "" and ((self.quests[qid].objective and self.quests[qid].objective:find(subZone, 1, true)) or (self.quests[qid].description and self.quests[qid].description:find(subZone, 1, true))) then
					chdb.questsSubZoneAutoTracked[qid] = true
					AddQuestWatch(id, nil, qid)
				end
			end
		end
	end
	if GetQuestLogSelection() ~= selectionId then
		SelectQuestLogEntry(selectionId)
	end
	if not self.firstRun then
		for qid, qData in pairs(self.quests) do
			if qData.playerStatus and qData.timeStamp ~= timeStamp then
				if not self.collapsedHeader[qData.category] then
					local daily, title = self.quests[qid].daily, self.quests[qid].title
					self.questsTitleToqid[title] = nil
					if self.quests[qid].playersOnQuest == 1 then
						self.questsObjectives[qid] = nil
						local category = self.quests[qid].category
						self.questsByCategory[category][qid] = nil
						if not next(self.questsCategories[category]) then
							self.questsCategories[category] = nil
							self.questsByCategory[category] = nil
							self:removeQuestCategoryCells(category)
						end
						self.quests[qid] = nil
						self:removeQuestCells(qid)
					else
						self.quests[qid].playersOnQuest = self.quests[qid].playersOnQuest - 1
						self.quests[qid].playerStatus = nil
						self.quests[qid].id = nil
						self:updateQuestCells(qid)
						if self.questsObjectives[qid] then
							for oid, qoData in pairs(self.questsObjectives[qid]) do
								self.questsObjectives[qid][oid].playerGot = nil
								self.questsObjectives[qid][oid].nPlayerGot = nil
								self:updateQuestObjectiveCells(qid, oid)
							end
						end
						if prdb.partyHeader then
							local category = self.quests[qid].category
							self.questsByCategory[category][qid] = nil
							if not next(self.questsByCategory[category]) then
								self.questsCategories[category] = nil
								self.questsByCategory[category] = nil
								self:removeQuestCategoryCells(category)
							end
							if not self.questsByCategory[self.PARTYQUESTSZONE] then
								self:addQuestCategory(self.PARTYQUESTSZONE)
							end
							self.questsByCategory[self.PARTYQUESTSZONE][qid] = true
							self:refreshQuestsLayout()
						end
					end
					self:questLost(qid)
					self:sendMessage("l", qid, abandoning)
					if daily == 1 and not abandoning then
						if not prdb.dailyList[self.playerName] then
							prdb.dailyList[self.playerName] = {class = self.playerClass, dailies = {}}
						end
						prdb.dailyList[self.playerName].dailies[#prdb.dailyList[self.playerName].dailies+1] = time().."^"..title
					end
				else
					self.quests[qid].id = nil
				end
			end
		end
	else
		self.firstRun = nil
		self:PARTY_MEMBERS_CHANGED()
		self:BAG_UPDATE()
		self:RegisterBucketEvent("BAG_UPDATE", 0.2, "BAG_UPDATE")
		if prdb.onLogIn then
			for qid in pairs (self.quests) do
				AddQuestWatch(self.quests[qid].id, nil, qid, true)
			end
		else
			for qid in pairs(chdb.questsTracked) do
				if not self.quests[qid] then
					chdb.questsTracked[qid] = nil
					chdb.questsSubZoneAutoTracked[qid] = nil
					chdb.questsZoneAutoTracked[qid] = nil
				else
					AddQuestWatch(self.quests[qid].id, nil, qid, true)
				end
			end
		end
		self:categoriesSort()
		self:questsSort()
		if prdb.achievementsTracker.showInQuestTracker then
			if self.aTrInit then
				self:setQuestsTrackerLayout()
			end
		else
			self:setQuestsTrackerLayout()
		end
		self.qTrInit = true
	end
	if numQuests ~= self.numQuests or numCompletedQuests ~= self.numCompletedQuests then
		self.numQuests, self.numCompletedQuests = numQuests, numCompletedQuests
		self:updateQuestCounter()
	end
	abandoning, self.questLogUpdating = nil, nil
end

function tomQuest2:PLAYER_XP_UPDATE()
	if self.sendXPMax then
		self:sendMessage("u", UnitXP("player"), UnitXPMax("player"))
		self.sendXPMax = nil
	else
		self:sendMessage("x", UnitXP("player"))
	end
end

function tomQuest2:PLAYER_LEVEL_UP(event, newPlayerLevel)
	self.playerLevel = newPlayerLevel
	if self.playerLevel == MAX_PLAYER_LEVEL and self.xpHandle then
		self:UnregisterBucketEvent(self.xpHandle)
		self.xpHandle = nil
		self:UnregisterEvent("PLAYER_LEVEL_UP")
	elseif syncParty then
		self.sendXPMax = true
	end
	for category, cData in pairs(self.questsCategories) do
		if cData.minLevel ~= 0 then
			local r, g, b = LibTourist:GetLevelColor(category)
			self.questsCategories[category].color = format("%02x%02x%02x", r*255, g*255, b*255)
		end
	end
	for qid, qData in pairs(self.quests) do
		local qc = self:getDifficultyColor(qData.level - self.playerLevel)
		self.quests[qid].color = format("%02x%02x%02x", qc.r*255, qc.g*255, qc.b*255)
	end
end

local function findItemOnUse(itemLink)
	scanTooltipTQ2:ClearLines()
	scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
	scanTooltipTQ2:SetHyperlink(itemLink)
	scanTooltipTQ2:Show()
	for _, lineNum in pairs(scanTooltipLines) do
		local text = _G[lineNum]:GetText()
		if text and sub(text, 1, tomQuest2.itemUseLen) == ITEM_SPELL_TRIGGER_ONUSE then
			scanTooltipTQ2:Hide()
			return true
		end
	end
	scanTooltipTQ2:Hide()
	return false
end

local function findItemStartingQuest(itemLink)
	scanTooltipTQ2:ClearLines()
	scanTooltipTQ2:SetOwner(WorldFrame, "ANCHOR_NONE")
	scanTooltipTQ2:SetHyperlink(itemLink)
	scanTooltipTQ2:Show()
	for _, lineNum in pairs(scanTooltipLines) do
		local text = _G[lineNum]:GetText()
		if text and text == ITEM_STARTS_QUEST then
			scanTooltipTQ2:Hide()
			return true
		end
	end
	scanTooltipTQ2:Hide()
	return false
end

function tomQuest2:analyseItem(itemLink)
	local itemName, _, itemRarity, _, _, itemType, _, _, _, itemTexture = GetItemInfo(itemLink)
	if itemType == LC["Quest"] then
		local itemSpell = GetItemSpell(itemLink)
		if itemSpell or findItemOnUse(itemLink) then
			for qid, qData in pairs (self.quests) do
				if qData.playerStatus and ((qData.objective and qData.objective:find(itemName, 1, true)) or (qData.description and qData.description:find(itemName, 1, true))) then
					self.items[itemLink] = qid
					self.quests[qid].specialItemLink, self.quests[qid].specialItemIcon = itemLink, itemTexture
					self:createFakeItem(qid)
				end
			end
			self.items[itemLink] = -1
			self.usableQuestItems[itemLink] = {icon = itemTexture, color = self.rarityColor[itemRarity], name = itemName}
		elseif findItemStartingQuest(itemLink) then
			self.items[itemLink] = 0
			self.itemStartingQuest[itemLink] = {icon = itemTexture, color = self.rarityColor[itemRarity], name = itemName}
			if not self.firstRun then
				if self.moduleState["notifications"] and prdb.notifyItemStartingQuestLooted then
					self:Pour(format(LC["You've just looted %s which start a quest"], itemLink), 0, 1, 0)
				end
			end
		end
	elseif self.specialItems[itemLink] then
		self.items[itemLink] = -1
		self.usableQuestItems[itemLink] = {icon = itemTexture, color = self.rarityColor[itemRarity], name = itemName}
	elseif findItemStartingQuest(itemLink) then
		self.items[itemLink] = 0
		self.itemStartingQuest[itemLink] = {icon = itemTexture, color = self.rarityColor[itemRarity], name = itemName}
		if not self.firstRun then
			if self.moduleState["notifications"] and prdb.notifyItemStartingQuestLooted then
				self:Pour(format(LC["You've just looted %s which start a quest"], itemLink), 0, 1, 0)
			end
		end
	else
		self.items[itemLink] = -2
	end
end

function tomQuest2:BAG_UPDATE()
	local timeStamp = GetTime()
	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			local itemLink = GetContainerItemLink(bag, slot)
			if itemLink then
				self.itemsTimeStamp[itemLink] = timeStamp
				if not self.items[itemLink] then
					self:analyseItem(itemLink)
				end
			end
		end
	end
	for slotId in pairs(self.inventorySlotId) do
		local itemLink = GetInventoryItemLink("player", slotId)
		if itemLink then
			self.itemsTimeStamp[itemLink] = timeStamp
			if not self.items[itemLink] then
				self:analyseItem(itemLink)
			end
		end
	end
	for itemLink in pairs(self.itemsTimeStamp) do
		if self.itemsTimeStamp[itemLink] ~= timeStamp then
			self.itemsTimeStamp[itemLink] = nil
			if self.items[itemLink] then
				if self.items[itemLink] == 0 then
					self.itemStartingQuest[itemLink] = nil
					self.items[itemLink] = nil
				elseif self.items[itemLink] == -1 then
					self.usableQuestItems[itemLink] = nil
					self.items[itemLink] = nil
				elseif self.items[itemLink] == -2 then
					self.items[itemLink] = nil
				end
			end
		end
	end
end

function tomQuest2:PARTY_MEMBERS_CHANGED()
	local numPartyMembers = GetNumPartyMembers() or 0
	if self.numPartyMembers ~= numPartyMembers then
		if self.numPartyMembers == 0 then
			if self.playerLevel ~= MAX_PLAYER_LEVEL then
				self.xpHandle = self:RegisterBucketEvent("PLAYER_XP_UPDATE", 60, "PLAYER_XP_UPDATE")
			end
		elseif numPartyMembers == 0 then
			if self.xpHandle then
				self:UnregisterBucketEvent(self.xpHandle)
				self.xpHandle = nil
			end
		end
		self:computeQuestsLevel()
		self.numPartyMembers = numPartyMembers
		if self.moduleState["syncParty"] then
			local timeStamp = GetTime()
			local partySync = 0
			if self.numPartyMembers > 0 then
				for i=1, self.numPartyMembers do
					local partyName, partyRealm = UnitName(pId[i])
					if partyRealm and partyRealm ~= "" then
						partyName = partyName.."-"..partyRealm
					end
					if not self.partyTimeStamp[partyName] then
						self:SendCommMessage("tomQ2", self:Serialize("v", version, firstCompatibleVersion, self.playerClass, UnitXP("player"), UnitXPMax("player")), "WHISPER", partyName, "BULK")
					end
					self.partyTimeStamp[partyName] = timeStamp
					partySync = partySync + (self.party[partyName] and 1 or 0)
				end
			end
			for partyName, latestTimeStamp in pairs(self.partyTimeStamp) do
				if latestTimeStamp ~= timeStamp then
					if self.party[partyName] then
						for qid, questData in pairs(self.quests) do
							if questData.complete[partyName] then
								self:removePartyFromQuest(partyName, qid)
							end
						end
						self.party[partyName] = nil
					end
					self.partyTimeStamp[partyName] = nil
				end
			end
			if partySync == 0 then
				syncParty = false
			else
				syncParty = true
			end
		end
	end
end

----------------------
--- Initialization ---
----------------------
function tomQuest2:setBlizzNotification()
	if prdb.hideBlizzardNotification then
		UIErrorsFrame:SetScript("OnEvent", function(self, event, message, ...)
			if event == "UI_INFO_MESSAGE" and (message:match(tomQuest2.found) or message:match(tomQuest2.item) or message:match(tomQuest2.kill) or message:match(tomQuest2.playerKilled) or message:match(tomQuest2.oComplete) or message:match(tomQuest2.qComplete) or message:match(tomQuest2.qFailed)) then return end
			return origiOnEvent(self, event, message, ...)
		end)
	else
		UIErrorsFrame:SetScript("OnEvent", function(self, event, message, ...)
			return origiOnEvent(self, event, message, ...)
		end)
	end
end

function tomQuest2:enableModule(module)
	self.moduleState[module] = true
	if module == "syncParty" then
		self:RegisterComm("tomQ2", "commHandler")
	elseif module == "achievementsTracker" then
		self:SecureHook("AddTrackedAchievement")
		self:SecureHook("RemoveTrackedAchievement")
		self:RawHook("IsTrackedAchievement", true)
		self.criteriaHandle = self:RegisterBucketEvent("CRITERIA_UPDATE", 1, "CRITERIA_UPDATE")
		self:RegisterEvent("ACHIEVEMENT_EARNED")
		if prdb.timedAchievements then
			self:RegisterEvent("TRACKED_ACHIEVEMENT_UPDATE")
		end
		self.achievementsFirstRun = true
		for aid in pairs(chdb.achievementTracked) do
			local _, _, _, completed = GetAchievementInfo(aid)
			if not completed then
				AddTrackedAchievement(aid, true)
			else
				chdb.achievementTracked[aid] = nil
			end
		end
		self.achievementsFirstRun = nil
		if prdb.achievementsTracker.showInQuestTracker then
			if self.qTrInit then
				self:setQuestsTrackerLayout()
			end
		else
			self:setAchievementsTrackerLayout()
		end
		self.aTrInit = true
		if AchievementFrame then
			AchievementFrameAchievements_ForceUpdate()
		end
	elseif module == "questsTracker" then
		self:SecureHook("AddQuestWatch")
		self:SecureHook("RemoveQuestWatch")
	elseif module == "questsTooltip" then
		if not questsTooltipDataObj then
			questsTooltipDataObj = LDB:NewDataObject("tomQuest2_QuestsTooltip", {type = "data source", icon = "Interface\\AddOns\\tomQuest2\\media\\icon"})
		end
		questsTooltipDataObj.OnEnter = questsTooltipDataObjOnEnter
		questsTooltipDataObj.OnLeave = questsTooltipDataObjOnLeave
		questsTooltipDataObj.OnClick = questsTooltipDataObjOnClick
	elseif module == "dailyTooltip" then
		if not dailyQuestsTooltipDataObj then
			dailyQuestsTooltipDataObj = LDB:NewDataObject("tomQuest2_DailyTooltip", {type = "data source", icon = "Interface\\AddOns\\tomQuest2\\media\\icon", text = ""})
		end
		dailyQuestsTooltipDataObj.OnEnter = dailyQuestsTooltipDataObjOnEnter
		dailyQuestsTooltipDataObj.OnLeave = onLeave
		dailyQuestsTooltipDataObj.OnClick = dailyQuestsTooltipDataObjOnClick
		self.dailyTimer = self:ScheduleRepeatingTimer("updateDQToText", 60)
	elseif module == "questsGivers" then
		local LDQ = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-DailyQuests")
		local LFQ = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-ForbidenQuests")
		for _, v in pairs(LDQ) do
			self.dailies[v] = true
		end
		for _, v in pairs(LFQ) do
			self.forbiddenQuests[v] = true
		end
		LDQ, LFQ = nil, nil
		self:RegisterEvent("GOSSIP_SHOW")
		self:RegisterEvent("QUEST_GREETING")
		self:RegisterEvent("QUEST_COMPLETE")
		self:RegisterEvent("QUEST_DETAIL")
		self:RegisterEvent("QUEST_PROGRESS")
		self:RegisterEvent("QUEST_ACCEPT_CONFIRM")
	elseif module == "tooltips" then
		self:HookScript(GameTooltip, "OnShow")
		self:HookScript(GameTooltip, "OnTooltipSetItem")
		self:HookScript(GameTooltip, "OnTooltipSetUnit")
	elseif module == "achievementsTradeSkills" then
		for _, aid in pairs(self.achTrade) do
			local _, name, _, completed, _, _, _, _, _, icon = GetAchievementInfo(aid)
			if not completed then
				self.achievementName[aid] = name
				self.achievementIcon[aid] = icon
				local numCriteria = GetAchievementNumCriteria(aid)
				for cid = 1, numCriteria do
					local cString, _, completed, _, _, _, _, _, _, critId = GetAchievementCriteriaInfo(aid, cid)
					if not completed then
						self.achievementsTradeSkills[cString] = critId
					end
				end
			end
		end
		if next(self.achievementsTradeSkills) then
			self.cooking = GetCategoryInfo(170)
			if IsAddOnLoaded("Blizzard_TradeSkillUI") then
				self:SecureHook("TradeSkillFrame_Update")
			elseif IsAddOnLoaded("MrTrader_SkillWindow") then
				self:SecureHook(MRTSkillWindow, "UpdateSkillList")
			elseif IsAddOnLoaded("Skillet") then
				self:SecureHook(Skillet, "internal_UpdateTradeSkillWindow")
			elseif IsAddOnLoaded("AdvancedTradeSkillWindow") then
				self:SecureHook("ATSWFrame_Update")
			else
				self:RegisterEvent("ADDON_LOADED")
			end
		end
	elseif module == "tagQuestLog" then
		self:SecureHook("QuestLog_Update", "blizzQuestLogUpdate")
		self:HookScript(QuestLogScrollFrame, "OnMouseWheel", "blizzQuestLogUpdate")
		self:HookScript(QuestLogScrollFrameScrollBar, "OnValueChanged", "blizzQuestLogUpdate")
	elseif module == "notifications" then
		self:setBlizzNotification()
	end
end

function tomQuest2:disableModule(module)
	self.moduleState[module] = nil
	if module == "syncParty" then
		self:UnregisterComm("tomQ2")
	elseif module == "achievementsTracker" then
		self:Unhook("AddTrackedAchievement")
		self:Unhook("RemoveTrackedAchievement")
		self:Unhook("IsTrackedAchievement")
		self:UnregisterBucket(self.criteriaHandle)
		self:UnregisterEvent("ACHIEVEMENT_EARNED")
		if prdb.timedAchievements then
			self:UnregisterEvent("TRACKED_ACHIEVEMENT_UPDATE")
		end
		self.achievementsFirstRun = true
	elseif module == "questsTracker" then
		self:Unhook("AddQuestWatch")
		self:Unhook("RemoveQuestWatch")
	elseif module == "questsTooltip" then
		questsTooltipDataObj.OnEnter = nil
		questsTooltipDataObj.OnLeave = nil
		questsTooltipDataObj.OnClick = nil
	elseif module == "dailyTooltip" then
		dailyQuestsTooltipDataObj.OnEnter = nil
		dailyQuestsTooltipDataObj.OnLeave = nil
		dailyQuestsTooltipDataObj.OnClick = nil
		self:CancelTimer(self.dailyTimer, true)
		self.dailyTimer = nil
	elseif module == "questsGivers" then
		self.dailies = nil
		self.forbiddenQuests = nil
		self:UnregisterEvent("GOSSIP_SHOW")
		self:UnregisterEvent("QUEST_GREETING")
		self:UnregisterEvent("QUEST_COMPLETE")
		self:UnregisterEvent("QUEST_DETAIL")
		self:UnregisterEvent("QUEST_PROGRESS")
		self:UnregisterEvent("QUEST_ACCEPT_CONFIRM")
	elseif module == "tooltips" then
		self:setMobTooltip()
		self:setItemTooltip()
		self:Unhook(GameTooltip, "OnShow")
		self:Unhook(GameTooltip, "OnTooltipSetItem")
		self:Unhook(GameTooltip, "OnTooltipSetUnit")
	elseif module == "achievementsTradeSkills" then
		self:UnregisterEvent("ADDON_LOADED")
		if next(self.achievementsTradeSkills) then
			if IsAddOnLoaded("Blizzard_TradeSkillUI") then
				self:Unhook("TradeSkillFrame_Update")
			elseif IsAddOnLoaded("MrTrader_SkillWindow") then
				self:Unhook(MRTSkillWindow, "UpdateSkillList")
			elseif IsAddOnLoaded("Skillet") then
				self:Unhook(Skillet, "internal_UpdateTradeSkillWindow")
			elseif IsAddOnLoaded("AdvancedTradeSkillWindow") then
				self:Unhook("ATSWFrame_Update")
			else
				self:UnregisterEvent("ADDON_LOADED")
			end
		end
	elseif module == "tagQuestLog" then
		self:Unhook("QuestLog_Update")
		self:Unhook(QuestLogScrollFrame, "OnMouseWheel")
		self:Unhook(QuestLogScrollFrameScrollBar, "OnValueChanged")
	elseif module == "notifications" then
		UIErrorsFrame:SetScript("OnEvent", function(self, event, message, ...)
			return origiOnEvent(self, event, message, ...)
		end)
	end
end

function tomQuest2:RAID_ROSTER_UPDATE(event, forced)
	local numRaidMembers = GetNumRaidMembers()
	if self.numRaidMembers ~= numRaidMembers then
		self:computeQuestsLevel()
		self.numRaidMembers = numRaidMembers
	end
	if not prdb.raidModules.enabled then return end
	local inRaid = self.numRaidMembers > 0 and true or nil
	local _, instanceType = IsInInstance()
	local inRaidInstance = instanceType == "raid" and true or nil
	if inRaid ~= inRaidInstance or forced then
		for module, raidState in pairs(prdb.raidModules) do
			if raidState == "inRaid" then
				if inRaid and self.moduleState[module] then
					self:disableModule(module)
					self:Print(format(LC["%s module is now disabled"], module))
				elseif not inRaid and not self.moduleState[module] and prdb.modules[module] then
					self:enableModule(module)
					self:Print(format(LC["%s module is now enabled"], module))
				end
			elseif raidState == "hiddenInRaid" and self.moduleState[module] then
				if module == "questsTracker" then
					self:tQ2toggleQuestsTracker(inRaid and 0 or 1)
				elseif module == "achievementsTracker" then
					self:tQ2toggleAchievementsTracker(inRaid and 0 or 1)
				end
			end
		end
		self.inRaid = inRaid
	end
	if inRaidInstance ~= self.inRaidInstance or forced then
		for module, raidState in pairs(prdb.raidModules) do
			if raidState == "inRaidInstance" then
				if inRaidInstance and self.moduleState[module] then
					self:disableModule(module)
					self:Print(format(LC["%s module is now disabled"], module))
				elseif not inRaidInstance and not self.moduleState[module] and prdb.modules[module] then
					self:enableModule(module)
					self:Print(format(LC["%s module is now enabled"], module))
				end
			elseif raidState == "hiddenInRaidInstance" and self.moduleState[module] then
				if module == "questsTracker" then
					self:tQ2toggleQuestsTracker(inRaidInstance and 0 or 1)
				elseif module == "achievementsTracker" then
					self:tQ2toggleAchievementsTracker(inRaidInstance and 0 or 1)
				end
			end
		end
		self.inRaidInstance = inRaidInstance
	end
end

function tomQuest2:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("tomQuest2DB", defaults, "Default")
	prdb, chdb = self.db.profile, self.db.char
	self.db.RegisterCallback(self, "OnProfileChanged", "Refresh")
	self.db.RegisterCallback(self, "OnProfileCopied", "Refresh")
	self.db.RegisterCallback(self, "OnProfileReset", "Refresh")
	chdb.achievementTracked = chdb.achievementTracked or {}
	chdb.questsTracked = chdb.questsTracked or {}
	chdb.questsSubZoneAutoTracked = chdb.questsSubZoneAutoTracked or {}
	chdb.questsZoneAutoTracked = chdb.questsZoneAutoTracked or {}
	chdb.collapseAll = chdb.collapseAll or 0
	chdb.categoryDisplay = chdb.categoryDisplay or {}
	chdb.categoryDisplay.questsTooltip = chdb.categoryDisplay.questsTooltip or {}
	chdb.categoryDisplay.questsTracker = chdb.categoryDisplay.questsTracker or {}
	chdb.categoryDisplay.achievementsTracker = chdb.categoryDisplay.achievementsTracker or {}
	prdb.dailyList = prdb.dailyList or {}
	self:SetSinkStorage(prdb.sinkOptions)
end

function tomQuest2:OnEnable()
	if prdb.version and prdb.version < self.lastCompatibleDB then
		self.db:ResetDB()
		self:Refresh()
	end
	self:setBackDrop("questsTooltip")
	self:setBackDrop("questsTracker")
	self:setBackDrop("achievementsTracker")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self.cQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.categoryFont), prdb.questsTooltip.categoryFontSize, prdb.questsTooltip.categoryFontOutline)
	self.qQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questFont), prdb.questsTooltip.questFontSize, prdb.questsTooltip.questFontOutline)
	self.qoQToFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTooltip.questObjectiveFont), prdb.questsTooltip.questObjectiveFontSize, prdb.questsTooltip.questObjectiveFontOutline)
	self.cQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.categoryFont), prdb.questsTracker.categoryFontSize, prdb.questsTracker.categoryFontOutline)
	self.qQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questFont), prdb.questsTracker.questFontSize, prdb.questsTracker.questFontOutline)
	self.qoQTrFontTQ2:SetFont(LSM:Fetch("font", prdb.questsTracker.questObjectiveFont), prdb.questsTracker.questObjectiveFontSize, prdb.questsTracker.questObjectiveFontOutline)
	self.cATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.categoryFont), prdb.achievementsTracker.categoryFontSize, prdb.achievementsTracker.categoryFontOutline)
	self.scATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.subCategoryFont), prdb.achievementsTracker.subCategoryFontSize, prdb.achievementsTracker.subCategoryFontOutline)
	self.aATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementFont), prdb.achievementsTracker.achievementFontSize, prdb.achievementsTracker.achievementFontOutline)
	self.acATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.achievementCriterionFont), prdb.achievementsTracker.achievementCriterionFontSize, prdb.achievementsTracker.achievementCriterionFontOutline)
	self.sbATrFontTQ2:SetFont(LSM:Fetch("font", prdb.achievementsTracker.statusBarFont), prdb.achievementsTracker.statusBarFontSize, prdb.achievementsTracker.statusBarFontOutline)
	self.displayFrames = {
		questsTooltip = self:getContainer("tomQuest2QuestsTooltip"),
		questsTracker = self:getContainer("tomQuest2QuestsTracker"),
		achievementsTracker = self:getContainer("tomQuest2AchievementsTracker")
	}
	if prdb.achievementsTracker.showInQuestTracker then
		self.ACHIEVEMENTS_TRACKER_FRAME = QUESTS_TRACKER
	else
		self.ACHIEVEMENTS_TRACKER_FRAME = ACHIEVEMENTS_TRACKER
	end
	if LBF then
		self.LBFGroup = LBF:Group("tomQuest2", "Items")
		self.LBFGroup.SkinID = prdb.skin.skin or "DreamLayout"
		self.LBFGroup.Backdrop = prdb.skin.backdrop
		self.LBFGroup.Gloss = prdb.skin.gloss
		self.LBFGroup.Colors = prdb.skin.Colors
		LBF:RegisterSkinCallback("tomQuest2", skinChanged)
	end
	LSM.RegisterCallback(self, "LibSharedMedia_Registered", "updateUsedMedia")
	self.tooltipHeaderCell = self:getContentCell(self.cQToFontTQ2, "CENTER", "header", QUESTS_TOOLTIP, nil, nil, true)
	self.tooltipHeaderCell.fs:SetText("|cfffffffftomQuest2|r")
	self.tooltipHeaderButton = self:getButton(self.tooltipHeaderCell, chdb.categoryDisplay.questsTooltip.collapseAll == 0 and expandTexture or collapseTexture, prdb.questsTooltip.collapseButtonSize, "header")
	for k, v in pairs(interactivityAction) do
		local action = prdb.questsTooltip[k]
		if action ~= "nothing" then
			self.hintCells[action] = self:getContentCell(self.cQToFontTQ2, "LEFT", QUESTS_TOOLTIP, QUESTS_TOOLTIP)
			self.hintCells[action].fs:SetFormattedText("|cffeda55f%s|r |cff19ff19%s|r", v, self.interactivityList[action])
		end
	end
	ExpandQuestHeader(0)
	self.numCompletedDailyQuests = GetDailyQuestsCompleted() or 0
	local previsousResetTime = time() - 86400 + GetQuestResetTime()
	if next(prdb.dailyList) then
		for player, playerData in pairs(prdb.dailyList) do
			for k = #playerData.dailies, 1, -1 do
				local dateJ, _ = playerData.dailies[k]:match(dailyPattern)
				if dateJ < previousResetTime then
					tremove(prdb.dailyList[player].dailies, k)
				end
			end
		end
	end
	for module, state in pairs(prdb.modules) do
		if state then
			self:enableModule(module)
		end
	end
	prdb.version = self.dbVersion
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(updateClassColors)
	end
	self:SecureHook("AbandonQuest")
	if prdb.hideDefaultBlizTracker then
		self:SecureHook("WatchFrame_Update")
		WatchFrame:Hide()
	end
	self:RegisterEvent("CHAT_MSG_SYSTEM")
	self:RegisterEvent("QUEST_LOG_UPDATE")
	if self.playerLevel ~= MAX_PLAYER_LEVEL then
		self:RegisterEvent("PLAYER_LEVEL_UP")
	end
	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "RAID_ROSTER_UPDATE")
	subZone = GetSubZoneText() or ""
	currentZone = GetZoneText() or ""
	self:RegisterEvent("ZONE_CHANGED", "zoneChanged")
	self:RegisterEvent("ZONE_CHANGED_INDOORS", "zoneChanged")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "zoneChanged")
end

function tomQuest2:OnDisable()
	UIErrorsFrame:SetScript("OnEvent", function(self, event, message, ...)
		return origiOnEvent(self, event, message, ...)
	end)
end

function tomQuest2:Refresh()
	prdb.version = self.dbVersion
	prdb = self.db.profile
	for module, state in pairs(prdb.modules) do
		if state and not self.moduleState[module] then
			self:enableModule(module)
		elseif not state and self.moduleState[module] then
			self:disableModule(module)
		end
	end
	self:computeQuestsTag()
	if prdb.hideDefaultBlizTracker then
		self:SecureHook("WatchFrame_Update")
		WatchFrame:Hide()
	else
		self:Unhook("WatchFrame_Update")
		WatchFrame:Show()
	end
	self:updateAllQuestsStatus()
	self:questCounterUpdated()
end

local optionFrame = CreateFrame("Frame", nil, InterfaceOptionsFrameAddOns)
local function loadConfigGUI()
	optionFrame:SetScript("OnShow", nil)
	LoadAddOn("tomQuest2_Config")
end
optionFrame:SetScript("OnShow", loadConfigGUI)

--------------------------
--- Keybinding globals ---
--------------------------
BINDING_HEADER_TOMQUEST2 = "tomQuest2"
BINDING_NAME_TQ2QUESTTRACKERTOGGLE = LC["Quests tracker"]
BINDING_NAME_TQ2ACHIEVEMENTTRACKERTOGGLE = LC["Achievements tracker"]

function tomQuest2:tQ2toggleQuestsTracker(display)
	prdb.questsTracker.toggleTracker = not prdb.questsTracker.toggleTracker
	if not display then
		if not prdb.toggleTracker then
			prdb.questsTracker.toggleTracker = true
		else
			prdb.questsTracker.toggleTracker = false
		end
	elseif display == 1 and not prdb.questsTracker.toggleTracker then
		prdb.questsTracker.toggleTracker = true
	elseif display == 0 and prdb.questsTracker.toggleTracker then
		prdb.questsTracker.toggleTracker = false
	end
	self:setQuestsTrackerLayout()
end

function tomQuest2:tQ2toggleAchievementsTracker(display)
	prdb.achievementsTracker.toggleTracker = not prdb.achievementsTracker.toggleTracker
	if not display then
		if not prdb.achievementsTracker.toggleTracker then
			prdb.achievementsTracker.toggleTracker = true
		else
			prdb.achievementsTracker.toggleTracker = false
		end
	elseif display == 1 and not prdb.achievementsTracker.toggleTracker then
		prdb.achievementsTracker.toggleTracker = true
	elseif display == 0 and prdb.achievementsTracker.toggleTracker then
		prdb.achievementsTracker.toggleTracker = false
	end
	self:setAchievementsTrackerLayout()
end